"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file Accordion component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Accordion =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Accordion, _Component);

  function Accordion(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Accordion);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Accordion)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetHeight", function (callback) {
      var el = _this.accordionContent && _this.accordionContent.current;

      if (_this.state.collapsed || !el) {
        return;
      }

      var style = window.getComputedStyle(el);

      if (!style) {
        return;
      }

      _this.setState({
        contentHeight: 'auto'
      }, function () {
        _this.setState({
          contentHeight: el.clientHeight
        }, function () {
          callback && callback();
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "collpase", function () {
      _this.setState({
        collapsed: true
      }, function () {
        var _this$props = _this.props,
            onCollpase = _this$props.onCollpase,
            onChange = _this$props.onChange;
        onCollpase && onCollpase();
        onChange && onChange(true);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "expand", function () {
      _this.setState({
        collapsed: false
      }, function () {
        var _this$props2 = _this.props,
            onExpand = _this$props2.onExpand,
            onChange = _this$props2.onChange;
        onExpand && onExpand();
        onChange && onChange(false);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      _this.state.collapsed ? _this.expand() : _this.collpase();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "init", function () {
      if (!_this.props.collapsed) {
        _this.resetHeight();
      } else {
        setTimeout(function () {
          _this.setState({
            collapsed: false
          }, function () {
            _this.resetHeight(function () {
              _this.setState({
                collapsed: _this.props.collapsed
              });
            });
          });
        }, 0);
      }
    });
    _this.accordionContent = (0, _react.createRef)();
    _this.state = {
      collapsed: props.collapsed,
      contentHeight: null
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(Accordion, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.init();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          children = _this$props3.children,
          className = _this$props3.className,
          style = _this$props3.style,
          title = _this$props3.title,
          collapseIcon = _this$props3.collapseIcon,
          _this$state = this.state,
          collapsed = _this$state.collapsed,
          contentHeight = _this$state.contentHeight;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('accordion', (0, _defineProperty2["default"])({
          collapsed: collapsed
        }, className, className)),
        style: style
      }, _react["default"].createElement(_RaisedButton["default"], {
        className: "accordion-title",
        theme: _Theme["default"].SECONDARY,
        value: title,
        rightIconCls: collapseIcon,
        onClick: this.handleClick
      }), _react["default"].createElement("div", {
        ref: this.accordionContent,
        className: "accordion-content",
        style: {
          height: contentHeight
        }
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        collapsed: _ComponentUtil["default"].getDerivedState(props, state, 'collapsed')
      };
    }
  }]);
  return Accordion;
}(_react.Component);

(0, _defineProperty2["default"])(Accordion, "Theme", _Theme["default"]);
Accordion.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The accordion's title.
   */
  title: _propTypes["default"].string,
  collapsed: _propTypes["default"].bool,

  /**
   * Collapse icon.
   */
  collapseIcon: _propTypes["default"].string,

  /**
   * Callback function fired when collpase the accordion.
   */
  onCollpase: _propTypes["default"].func,

  /**
   * Callback function fired when expand the accordion.
   */
  onExpand: _propTypes["default"].func,

  /**
   * Callback function fired when change the status of accordion.
   */
  onChange: _propTypes["default"].func
};
Accordion.defaultProps = {
  title: 'title',
  collapsed: false,
  collapseIcon: 'fas fa-angle-down'
};
var _default = Accordion;
exports["default"] = _default;