"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Anchor component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Anchor =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Anchor, _Component);

  function Anchor(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Anchor);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Anchor)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          isLoading = _this$props.isLoading,
          onClick = _this$props.onClick;
      !disabled && !isLoading && onClick && onClick(e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function (e) {
      _this.setState({
        focused: true
      }, function () {
        var onFocus = _this.props.onFocus;
        onFocus && onFocus(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function (e) {
      _this.setState({
        focused: false
      }, function () {
        var onBlur = _this.props.onBlur;
        onBlur && onBlur(e);
      });
    });
    _this.state = {
      focused: false
    };
    return _this;
  }

  (0, _createClass2["default"])(Anchor, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          children = _this$props2.children,
          className = _this$props2.className,
          style = _this$props2.style,
          theme = _this$props2.theme,
          iconCls = _this$props2.iconCls,
          rightIconCls = _this$props2.rightIconCls,
          disabled = _this$props2.disabled,
          isLoading = _this$props2.isLoading,
          tip = _this$props2.tip,
          tipPosition = _this$props2.tipPosition,
          parentEl = _this$props2.parentEl,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["children", "className", "style", "theme", "iconCls", "rightIconCls", "disabled", "isLoading", "tip", "tipPosition", "parentEl"]),
          focused = this.state.focused,
          loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, _react["default"].createElement("a", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('anchor', (_classNames = {
          focused: focused
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled || isLoading,
        onClick: this.handleClick,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      }), isLoading && loadingIconPosition === 'left' ? _react["default"].createElement(_CircularLoading["default"], {
        className: "anchor-icon anchor-icon-left button-loading-icon",
        size: "small"
      }) : iconCls ? _react["default"].createElement("i", {
        className: "anchor-icon anchor-icon-left ".concat(iconCls),
        "aria-hidden": "true"
      }) : null, children, isLoading && loadingIconPosition === 'right' ? _react["default"].createElement(_CircularLoading["default"], {
        className: "anchor-icon anchor-icon-right button-loading-icon",
        size: "small"
      }) : rightIconCls ? _react["default"].createElement("i", {
        className: "anchor-icon anchor-icon-right ".concat(rightIconCls),
        "aria-hidden": "true"
      }) : null));
    }
  }]);
  return Anchor;
}(_react.Component);

(0, _defineProperty2["default"])(Anchor, "Theme", _Theme["default"]);
Anchor.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  href: _propTypes["default"].string,
  alt: _propTypes["default"].string,
  target: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  onClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func
};
Anchor.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  href: 'javascript:void(0)',
  target: '_blank',
  disabled: false,
  readOnly: false,
  isLoading: false
};
var _default = Anchor;
exports["default"] = _default;