"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _BadgeType = _interopRequireDefault(require("../_statics/BadgeType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Badge component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Badge =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Badge, _Component);

  function Badge(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Badge);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Badge)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleValue", function () {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.value;
      var _this$props = _this.props,
          type = _this$props.type,
          overflowValue = _this$props.overflowValue;

      if (type !== _BadgeType["default"].NUMBER) {
        return null;
      }

      if (overflowValue == null || value <= overflowValue) {
        return value;
      }

      return "".concat(overflowValue, "+");
    });
    return _this;
  }
  /**
   * handle display number
   * @param value
   * @returns {string|null|Number}
   */


  (0, _createClass2["default"])(Badge, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          className = _this$props2.className,
          style = _this$props2.style,
          visible = _this$props2.visible,
          type = _this$props2.type;
      return _react["default"].createElement("span", {
        className: (0, _classnames["default"])('badge-wrapper', (0, _defineProperty2["default"])({
          'no-child': !children
        }, className, className)),
        style: style
      }, children, visible ? _react["default"].createElement("sup", {
        className: (0, _classnames["default"])('badge', "badge-".concat(type))
      }, this.handleValue()) : null);
    }
  }]);
  return Badge;
}(_react.Component);

(0, _defineProperty2["default"])(Badge, "Type", _BadgeType["default"]);
Badge.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  visible: _propTypes["default"].bool,
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_BadgeType["default"])),
  value: _propTypes["default"].number,
  overflowValue: _propTypes["default"].number
};
Badge.defaultProps = {
  visible: true,
  type: _BadgeType["default"].DOT
};
var _default = Badge;
exports["default"] = _default;