"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file ButtonCheckbox component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ButtonCheckbox =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ButtonCheckbox, _Component);

  function ButtonCheckbox(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ButtonCheckbox);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ButtonCheckbox)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var value = !_this.state.value;

      _this.setState({
        value: value
      }, function () {
        var _this$props = _this.props,
            disabled = _this$props.disabled,
            onChange = _this$props.onChange;
        !disabled && onChange && onChange(value);
      });
    });
    _this.state = {
      value: !!props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(ButtonCheckbox, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          theme = _this$props2.theme,
          activatedTheme = _this$props2.activatedTheme,
          text = _this$props2.text,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["className", "theme", "activatedTheme", "text"]),
          value = this.state.value;
      return _react["default"].createElement(_RaisedButton["default"], (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('button-checkbox', (0, _defineProperty2["default"])({
          activated: value
        }, className, className)),
        value: text,
        isRounded: true,
        theme: value ? activatedTheme : theme,
        onClick: this.handleClick
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return ButtonCheckbox;
}(_react.Component);

(0, _defineProperty2["default"])(ButtonCheckbox, "Theme", _Theme["default"]);
ButtonCheckbox.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The ButtonCheckbox theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The ButtonCheckbox activated theme.
   */
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The title of the ButtonCheckbox.
   */
  title: _propTypes["default"].string,

  /**
   * The text of the button.
   */
  text: _propTypes["default"].string,

  /**
   * If true,the button will be in active status.
   */
  value: _propTypes["default"].bool,

  /**
   * Disables the button if set to true.
   */
  disabled: _propTypes["default"].bool,

  /**
   * Callback function fired when the button is touch-tapped.
   */
  onChange: _propTypes["default"].func
};
ButtonCheckbox.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].PRIMARY,
  value: false,
  disabled: false
};
var _default = ButtonCheckbox;
exports["default"] = _default;