"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CascaderListItem = _interopRequireDefault(require("../_CascaderListItem"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _HorizontalDirection = _interopRequireDefault(require("../_statics/HorizontalDirection"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

var _CascaderCalculation = _interopRequireDefault(require("../_vendors/CascaderCalculation"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var CascaderList =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CascaderList, _Component);

  function CascaderList(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CascaderList);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CascaderList)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }

      if (!_Calculation["default"].isItemChecked(node, value, _this.props)) {
        value.push(node);
      }

      if (!node.children || node.children.length < 1) {
        return;
      }

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = node.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var item = _step.value;

          _this.addRecursiveValue(item, value);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }

      var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);

      if (index > -1) {
        value.splice(index, 1);
      }

      if (!node.children || node.children.length < 1) {
        return;
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = node.children[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var item = _step2.value;

          _this.removeRecursiveValue(item, value);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
            _iterator2["return"]();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateValue", function (value) {
      var _this$props = _this.props,
          data = _this$props.data,
          valueField = _this$props.valueField,
          displayField = _this$props.displayField;
      var result = [];

      _Util["default"].postOrderTraverse({
        children: data
      }, function (node) {
        if (!node.children || node.children.length < 1) {
          if (value.findIndex(function (item) {
            return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(node, valueField, displayField);
          }) > -1) {
            result.push(node);
          }
        } else {
          if (node.children.every(function (child) {
            return result.findIndex(function (item) {
              return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(child, valueField, displayField);
            }) > -1;
          })) {
            result.push(node);
          }
        }
      });

      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeClick", function (node, index, path, e) {
      var onNodeClick = _this.props.onNodeClick;
      onNodeClick && onNodeClick(node, index, path, e);

      _this.setState({
        activatedPath: path
      }, function () {
        var onPathChange = _this.props.onPathChange;
        onPathChange && onPathChange(path);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeSelect", function (node, path) {
      if (!node) {
        return;
      }

      var _this$props2 = _this.props,
          selectMode = _this$props2.selectMode,
          isSelectRecursive = _this$props2.isSelectRecursive,
          value = _this.state.value,
          state = {};

      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value ? value.slice() : value;

        if (!result || !(0, _isArray["default"])(result)) {
          result = [];
        }

        if (isSelectRecursive) {
          _this.addRecursiveValue(node, result);

          result = _this.updateValue(result);
        } else {
          result.push(node);
        }

        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT && !_CascaderCalculation["default"].hasChildren(node)) {
        state.value = node;
      }

      _this.setState(state, function () {
        var _this$props3 = _this.props,
            onNodeSelect = _this$props3.onNodeSelect,
            onChange = _this$props3.onChange;
        onNodeSelect && onNodeSelect(node, path);
        state.value && onChange && onChange(state.value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeDeselect", function (node, path) {
      var selectMode = _this.props.selectMode;

      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      var isSelectRecursive = _this.props.isSelectRecursive,
          stateValue = _this.state.value;
      var value = stateValue ? stateValue.slice() : stateValue;

      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        if (isSelectRecursive) {
          _this.removeRecursiveValue(node, value);

          value = _this.updateValue(value);
        } else {
          var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);

          if (index > -1) {
            value.splice(index, 1);
          }
        }
      }

      _this.setState({
        value: value
      }, function () {
        var _this$props4 = _this.props,
            onNodeDeselect = _this$props4.onNodeDeselect,
            onChange = _this$props4.onChange;
        onNodeDeselect && onNodeDeselect(node, path);
        onChange && onChange(value);
      });
    });

    var _value = _Calculation["default"].getInitValue(props);

    _this.state = {
      value: _value,
      activatedPath: _CascaderCalculation["default"].calPath(_value, props.data, props)
    };
    return _this;
  }

  (0, _createClass2["default"])(CascaderList, [{
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          children = _this$props5.children,
          className = _this$props5.className,
          style = _this$props5.style,
          theme = _this$props5.theme,
          selectTheme = _this$props5.selectTheme,
          listWidth = _this$props5.listWidth,
          expandDirection = _this$props5.expandDirection,
          data = _this$props5.data,
          expandedIconCls = _this$props5.expandedIconCls,
          radioUncheckedIconCls = _this$props5.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props5.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props5.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props5.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props5.checkboxIndeterminateIconCls,
          idField = _this$props5.idField,
          valueField = _this$props5.valueField,
          displayField = _this$props5.displayField,
          descriptionField = _this$props5.descriptionField,
          disabled = _this$props5.disabled,
          isLoading = _this$props5.isLoading,
          readOnly = _this$props5.readOnly,
          selectMode = _this$props5.selectMode,
          isSelectRecursive = _this$props5.isSelectRecursive,
          renderer = _this$props5.renderer,
          _this$state = this.state,
          value = _this$state.value,
          activatedPath = _this$state.activatedPath;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('cascader-list', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread({}, style, {
          width: _CascaderCalculation["default"].getMaxDepth(activatedPath) * listWidth
        }),
        disabled: disabled
      }, _react["default"].createElement(_CascaderListItem["default"], {
        expandDirection: expandDirection,
        activatedPath: activatedPath,
        data: data,
        value: value,
        theme: theme,
        selectTheme: selectTheme,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        disabled: disabled,
        isLoading: isLoading,
        readOnly: readOnly,
        selectMode: selectMode,
        renderer: renderer,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        isSelectRecursive: isSelectRecursive,
        onNodeClick: this.handleNodeClick,
        onNodeSelect: this.handleNodeSelect,
        onNodeDeselect: this.handleNodeDeselect
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return CascaderList;
}(_react.Component);

(0, _defineProperty2["default"])(CascaderList, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(CascaderList, "ExpandDirection", _HorizontalDirection["default"]);
(0, _defineProperty2["default"])(CascaderList, "Theme", _Theme["default"]);
CascaderList.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The theme of the tree node.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  listWidth: _propTypes["default"].number,

  /**
   * The theme of the tree node select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The mode of tree node.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The direction of expansion.
   */
  expandDirection: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalDirection["default"])),

  /**
   * Children passed into the tree node.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,

    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    children: _propTypes["default"].array,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,

    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  })),

  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,

  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * If true, the tree will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true, the tree will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * Callback function fired when the tree node touch tap.
   */
  onNodeClick: _propTypes["default"].func,

  /**
   * Callback function fired when the tree node selected.
   */
  onNodeSelect: _propTypes["default"].func,

  /**
   * Callback function fired when the tree node deselected.
   */
  onNodeDeselect: _propTypes["default"].func,
  onPathChange: _propTypes["default"].func,

  /**
   * Callback function fired when the tree changed.
   */
  onChange: _propTypes["default"].func
};
CascaderList.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  listWidth: 200,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  expandDirection: _HorizontalDirection["default"].RIGHT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isSelectRecursive: true
};
var _default = CascaderList;
exports["default"] = _default;