"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Dropdown = _interopRequireDefault(require("../Dropdown"));

var _CascaderList = _interopRequireDefault(require("../CascaderList"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _HorizontalDirection = _interopRequireDefault(require("../_statics/HorizontalDirection"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _CascaderCalculation = _interopRequireDefault(require("../_vendors/CascaderCalculation"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file CascaderSelect component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var CascaderSelect =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CascaderSelect, _Component);

  function CascaderSelect(_props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CascaderSelect);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CascaderSelect)).call.apply(_getPrototypeOf2, [this, _props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.closePopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTriggerValue", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

      var data = props.data,
          selectMode = props.selectMode,
          placeholder = props.placeholder,
          triggerRenderer = props.triggerRenderer,
          renderer = props.renderer,
          displayField = props.displayField,
          valueField = props.valueField,
          value = _this.state.value,
          path = _CascaderCalculation["default"].calPath(value, data, props),
          isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT;

      if (triggerRenderer) {
        return typeof triggerRenderer === 'function' ? triggerRenderer(value, path) : triggerRenderer;
      }

      if (!value) {
        return placeholder;
      }

      if (isMultiSelect) {
        return value.length > 0 ? value.length + ' selected' : placeholder;
      }

      var result = [];

      function addNode(node, i) {
        result.push(renderer ? _react["default"].createElement("div", {
          key: 2 * i + 1,
          className: "cascader-select-trigger-value-node"
        }, renderer(node, path && path.slice(0, i + 1))) : _Util["default"].getTextByDisplayField(node, displayField, valueField));
      }

      if (path) {
        for (var i = 0, len = path.length; i < len; i++) {
          i > 0 && result.push(_react["default"].createElement("i", {
            key: 2 * i,
            className: "fas fa-angle-right cascader-select-trigger-value-separator"
          }));
          addNode(path[i].node, i);
        }
      }

      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePathChange", function () {
      _this.dropdown && _this.dropdown.current && _this.dropdown.current.resetPopupPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeSelect", function (node, path) {
      var onNodeSelect = _this.props.onNodeSelect;
      onNodeSelect && onNodeSelect(node, path);

      if (_this.props.selectMode !== _SelectMode["default"].SINGLE_SELECT) {
        return;
      }

      _this.setState({
        path: path
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var autoClose = _this.props.autoClose;

      if (autoClose) {
        _this.closePopup();
      }

      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupClosed", function (e) {
      _this.setState({
        popupVisible: false
      }, function () {
        var onClosePopup = _this.props.onClosePopup;
        onClosePopup && onClosePopup(e);
      });
    });
    _this.dropdown = (0, _react.createRef)();
    _this.state = {
      value: _props.value,
      popupVisible: false,
      path: _props.selectMode === _SelectMode["default"].SINGLE_SELECT ? _CascaderCalculation["default"].calPath(_props.value, _props.data, _props) : undefined
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(CascaderSelect, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          triggerClassName = _this$props.triggerClassName,
          popupClassName = _this$props.popupClassName,
          style = _this$props.style,
          name = _this$props.name,
          popupTheme = _this$props.popupTheme,
          listWidth = _this$props.listWidth,
          data = _this$props.data,
          renderer = _this$props.renderer,
          selectTheme = _this$props.selectTheme,
          selectMode = _this$props.selectMode,
          expandDirection = _this$props.expandDirection,
          valueField = _this$props.valueField,
          displayField = _this$props.displayField,
          descriptionField = _this$props.descriptionField,
          triggerRenderer = _this$props.triggerRenderer,
          isSelectRecursive = _this$props.isSelectRecursive,
          allowCollapse = _this$props.allowCollapse,
          onNodeDeselect = _this$props.onNodeDeselect,
          popupChildren = _this$props.popupChildren,
          onNodeClick = _this$props.onNodeClick,
          collapsedIconCls = _this$props.collapsedIconCls,
          expandedIconCls = _this$props.expandedIconCls,
          radioUncheckedIconCls = _this$props.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props.checkboxIndeterminateIconCls,
          onNodeSelect = _this$props.onNodeSelect,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "triggerClassName", "popupClassName", "style", "name", "popupTheme", "listWidth", "data", "renderer", "selectTheme", "selectMode", "expandDirection", "valueField", "displayField", "descriptionField", "triggerRenderer", "isSelectRecursive", "allowCollapse", "onNodeDeselect", "popupChildren", "onNodeClick", "collapsedIconCls", "expandedIconCls", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "onNodeSelect"]),
          _this$state = this.state,
          value = _this$state.value,
          popupVisible = _this$state.popupVisible;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('cascader-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? _react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, _react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        triggerClassName: (0, _classnames["default"])((0, _defineProperty2["default"])({
          activated: popupVisible,
          empty: !triggerRenderer && !value
        }, triggerClassName, triggerClassName)),
        popupClassName: (0, _classnames["default"])('cascader-select-popup', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        popupTheme: popupTheme,
        autoPopupWidth: false,
        triggerValue: this.getTriggerValue(),
        onClosePopup: this.handlePopupClosed
      }), _react["default"].createElement("div", {
        className: "cascader-select-list-scroller"
      }, _react["default"].createElement(_CascaderList["default"], {
        className: "cascader-select-list",
        theme: popupTheme,
        selectTheme: selectTheme,
        expandDirection: expandDirection,
        listWidth: listWidth,
        selectMode: selectMode,
        data: data,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        isSelectRecursive: isSelectRecursive,
        allowCollapse: allowCollapse,
        collapsedIconCls: collapsedIconCls,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        renderer: renderer,
        onNodeClick: onNodeClick,
        onNodeSelect: this.handleNodeSelect,
        onNodeDeselect: onNodeDeselect,
        onChange: this.handleChange,
        onPathChange: this.handlePathChange
      })), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return CascaderSelect;
}(_react.Component);

(0, _defineProperty2["default"])(CascaderSelect, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(CascaderSelect, "ExpandDirection", _HorizontalDirection["default"]);
(0, _defineProperty2["default"])(CascaderSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(CascaderSelect, "Position", _Position["default"]);
(0, _defineProperty2["default"])(CascaderSelect, "TipPosition", _Position["default"]);
CascaderSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,

  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,

  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  listWidth: _propTypes["default"].number,

  /**
   * The theme of the tree node select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The mode of tree node.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The direction of expansion.
   */
  expandDirection: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalDirection["default"])),

  /**
   * The name of the dropDownSelect.
   */
  name: _propTypes["default"].string,

  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,

  /**
   * The placeholder of the dropDownSelect.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerValue: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,

  /**
   * The options data.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,

    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    children: _propTypes["default"].array,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,

    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  })),

  /**
   * The invalid message of dropDownSelect.
   */
  invalidMsg: _propTypes["default"].string,

  /**
   * If true,the dropDownSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true, the tree will be at loading status.
   */
  isLoading: _propTypes["default"].bool,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * The message of the dropDownSelect.
   */
  infoMsg: _propTypes["default"].string,

  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,

  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  resetPopPositionWait: _propTypes["default"].number,
  renderer: _propTypes["default"].func,
  triggerRenderer: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),

  /**
   * Callback function fired when the button is touch-tapped.
   */
  onNodeClick: _propTypes["default"].func,

  /**
   * Callback function fired when the tree node selected.
   */
  onNodeSelect: _propTypes["default"].func,

  /**
   * Callback function fired when the tree node deselected.
   */
  onNodeDeselect: _propTypes["default"].func,

  /**
   * Callback function fired when the popup is closed.
   */
  onClosePopup: _propTypes["default"].func,

  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
CascaderSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  listWidth: 200,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  expandDirection: _HorizontalDirection["default"].RIGHT,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  disabled: false,
  isLoading: false,
  tipPosition: _Position["default"].BOTTOM,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: false,
  isSelectRecursive: true,
  allowCollapse: true,
  resetPopPositionWait: 250
};
var _default = CascaderSelect;
exports["default"] = _default;