"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Checkbox component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Checkbox =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Checkbox, _Component);

  function Checkbox(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Checkbox);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Checkbox)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clickHandler", function (e) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          onClick = _this$props.onClick;

      if (disabled) {
        return;
      }

      onClick && onClick(e);
      var checked = !_this.state.checked;

      _this.setState({
        checked: checked
      }, function () {
        var _this$props2 = _this.props,
            onChange = _this$props2.onChange,
            onCheck = _this$props2.onCheck,
            onUncheck = _this$props2.onUncheck;
        onChange && onChange(checked);

        if (checked) {
          onCheck && onCheck(e);
        } else {
          onUncheck && onUncheck(e);
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "mouseDownHandler", function (e) {
      if (_this.props.disabled) {
        return;
      }

      _this.checkboxIconInstance && _this.checkboxIconInstance.startRipple(e);

      _this.clickHandler();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "mouseUpHandler", function () {
      if (_this.props.disabled) {
        return;
      }

      _this.checkboxIconInstance && _this.checkboxIconInstance.endRipple();
    });
    _this.checkboxIcon = (0, _react.createRef)();
    _this.state = {
      checked: !!props.checked
    };
    return _this;
  }

  (0, _createClass2["default"])(Checkbox, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.checkboxIconInstance = this.checkboxIcon && this.checkboxIcon.current;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.checked !== this.state.checked) {
        this.setState({
          checked: !!nextProps.checked
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          theme = _this$props3.theme,
          name = _this$props3.name,
          label = _this$props3.label,
          value = _this$props3.value,
          disabled = _this$props3.disabled,
          disableTouchRipple = _this$props3.disableTouchRipple,
          indeterminate = _this$props3.indeterminate,
          uncheckedIconCls = _this$props3.uncheckedIconCls,
          checkedIconCls = _this$props3.checkedIconCls,
          indeterminateIconCls = _this$props3.indeterminateIconCls,
          tip = _this$props3.tip,
          tipPosition = _this$props3.tipPosition,
          checked = this.state.checked;
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        position: tipPosition
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('checkbox', (_classNames = {
          activated: checked,
          indeterminated: !checked && indeterminate
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled
      }, name ? _react["default"].createElement("input", {
        className: "hidden-checkbox",
        type: "checkbox",
        name: name,
        value: value,
        checked: checked,
        onChange: function onChange() {}
      }) : null, _react["default"].createElement("div", {
        className: "checkbox-icon-wrapper",
        onClick: this.clickHandler
      }, _react["default"].createElement(_IconButton["default"], {
        ref: this.checkboxIcon,
        className: "checkbox-bg-icon",
        iconCls: uncheckedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      }), _react["default"].createElement(_IconButton["default"], {
        className: "checkbox-indeterminate-icon",
        iconCls: indeterminateIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      }), _react["default"].createElement(_IconButton["default"], {
        className: "checkbox-icon",
        iconCls: checkedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      })), label ? _react["default"].createElement("div", {
        className: "checkbox-label",
        onMouseDown: this.mouseDownHandler,
        onMouseUp: this.mouseUpHandler,
        onMouseLeave: this.mouseUpHandler
      }, label) : null));
    }
  }]);
  return Checkbox;
}(_react.Component);

(0, _defineProperty2["default"])(Checkbox, "Theme", _Theme["default"]);
Checkbox.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The Checkbox theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The name of the checkbox.
   */
  name: _propTypes["default"].string,

  /**
   * Label for checkbox.
   */
  label: _propTypes["default"].any,

  /**
   * Value for checkbox.
   */
  value: _propTypes["default"].any,

  /**
   * If true,the checkbox will be checked.
   */
  checked: _propTypes["default"].bool,
  indeterminate: _propTypes["default"].bool,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,
  indeterminateIconCls: _propTypes["default"].string,

  /**
   * If true, the checkbox will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,
  tip: _propTypes["default"].any,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * Callback function fired when the checkbox status change.
   */
  onChange: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onUncheck: _propTypes["default"].func
};
Checkbox.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  value: '',
  checked: false,
  indeterminate: false,
  uncheckedIconCls: 'far fa-square',
  checkedIconCls: 'fas fa-check-square',
  indeterminateIconCls: 'fas fa-minus-square',
  disabled: false,
  disableTouchRipple: false,
  tipPosition: _Position["default"].BOTTOM
};
var _default = Checkbox;
exports["default"] = _default;