"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file CheckboxGroup component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var CheckboxGroup =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CheckboxGroup, _Component);

  function CheckboxGroup(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CheckboxGroup);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CheckboxGroup)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (item) {
      var value = (0, _cloneDeep["default"])(_this.state.value);

      if (!value || !(0, _isArray["default"])(value)) {
        value = [item];
      } else {
        var index = value.findIndex(function (v) {
          return v.value === item.value;
        });

        if (index > -1) {
          value.splice(index, 1);
        } else {
          value.push(item);
        }
      }

      _this.setState({
        value: value
      }, function () {
        var _this$props = _this.props,
            disabled = _this$props.disabled,
            onChange = _this$props.onChange;
        !disabled && onChange && onChange(value);
      });
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(CheckboxGroup, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value && nextProps.value !== this.state.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var data = this.props.data;

      if (!data) {
        return null;
      }

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          theme = _this$props2.theme,
          name = _this$props2.name,
          disabled = _this$props2.disabled,
          idProp = _this$props2.idProp,
          uncheckedIconCls = _this$props2.uncheckedIconCls,
          checkedIconCls = _this$props2.checkedIconCls,
          indeterminateIconCls = _this$props2.indeterminateIconCls,
          _onCheck = _this$props2.onCheck,
          _onUncheck = _this$props2.onUncheck,
          value = this.state.value;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('checkbox-group', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, data && data.map(function (item, index) {
        return _react["default"].createElement(_Checkbox["default"], {
          key: item && idProp in item ? item[idProp] : index,
          className: item.className ? item.className : '',
          style: item.style,
          theme: item.theme || theme,
          uncheckedIconCls: item.uncheckedIconCls || uncheckedIconCls,
          checkedIconCls: item.checkedIconCls || checkedIconCls,
          indeterminateIconCls: item.indeterminateIconCls || indeterminateIconCls,
          name: name,
          label: item.label,
          value: item.value,
          disabled: disabled || item.disabled,
          checked: value && value.findIndex(function (v) {
            return v.value === item.value;
          }) > -1,
          tip: item.tip,
          tipPosition: item.tipPosition,
          onChange: function onChange() {
            return _this2.handleChange(item);
          },
          onCheck: function onCheck(e) {
            return _onCheck && _onCheck(item, e);
          },
          onUncheck: function onUncheck(e) {
            return _onUncheck && _onUncheck(item, e);
          }
        });
      }));
    }
  }]);
  return CheckboxGroup;
}(_react.Component);

(0, _defineProperty2["default"])(CheckboxGroup, "Theme", _Theme["default"]);
CheckboxGroup.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,

  /**
   * The CheckboxGroup theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  name: _propTypes["default"].string,
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    style: _propTypes["default"].object,
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    label: _propTypes["default"].any,
    value: _propTypes["default"].any,
    disabled: _propTypes["default"].bool,
    tip: _propTypes["default"].any,
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"]))
  })).isRequired,
  value: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  idProp: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,
  indeterminateIconCls: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onUncheck: _propTypes["default"].func
};
CheckboxGroup.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  disabled: false,
  idProp: 'id'
};
var _default = CheckboxGroup;
exports["default"] = _default;