"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file CircularLoading component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var CircularLoading =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CircularLoading, _Component);

  function CircularLoading(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, CircularLoading);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CircularLoading)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(CircularLoading, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          size = _this$props.size,
          theme = _this$props.theme,
          type = _this$props.type,
          weight = _this$props.weight,
          border = {
        borderWidth: weight
      };
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-loading', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "circular-loading-size-".concat(size), size), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        type: type,
        style: style
      }, _react["default"].createElement("div", {
        className: "spinner"
      }, _react["default"].createElement("div", {
        className: "".concat(theme, " circle left border-").concat(type)
      }, _react["default"].createElement("div", {
        className: "".concat(type ? type : 'solid'),
        style: border
      })), _react["default"].createElement("div", {
        className: "gap"
      }, _react["default"].createElement("div", null)), _react["default"].createElement("div", {
        className: "".concat(theme, " circle right border-").concat(type)
      }, _react["default"].createElement("div", {
        className: "".concat(type ? type : 'solid'),
        style: border
      }))));
    }
  }]);
  return CircularLoading;
}(_react.Component);

(0, _defineProperty2["default"])(CircularLoading, "Size", {
  DEFAULT: '',
  SMALL: 'small',
  LARGE: 'large'
});
CircularLoading.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Set the size of loading,can use small or large.
   */
  size: _propTypes["default"].oneOf(_Util["default"].enumerateValue(CircularLoading.Size)),

  /**
   * Set the theme of loading,can use highlight,success,error,warning.
   */
  theme: _propTypes["default"].string,

  /**
   * Set the CircularLoading border-width.
   */
  weight: _propTypes["default"].number,

  /**
   * Set the border style of CircularLoading,can use solid,dotted.
   */
  type: _propTypes["default"].string
};
CircularLoading.defaultProps = {
  size: CircularLoading.Size.DEFAULT,
  theme: '',
  width: '1',
  type: 'solid'
};
var _default = CircularLoading;
exports["default"] = _default;