"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Percent = _interopRequireDefault(require("../_Percent"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var CircularProgress =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CircularProgress, _Component);

  function CircularProgress(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CircularProgress);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CircularProgress)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    _this.state = {
      percent: [0, 0]
    };
    return _this;
  }

  (0, _createClass2["default"])(CircularProgress, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          r = _this$props.r,
          width = _this$props.width,
          word = _this$props.word,
          percent = _this$props.percent,
          percentStyle = _this$props.percentStyle,
          l = 2 * r * Math.PI,
          svgStyle = _objectSpread({}, style, {
        width: (r + width) * 2,
        height: (r + width) * 2
      });

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-progress', (0, _defineProperty2["default"])({}, className, className)),
        style: svgStyle
      }, _react["default"].createElement("svg", {
        className: "circular-progress-svg"
      }, _react["default"].createElement("circle", {
        className: "circular-progress-circle",
        cx: r + width,
        cy: r + width,
        r: r,
        strokeWidth: width,
        fill: "none",
        style: {
          strokeDasharray: percent / 100 * l + ',' + l
        }
      })), word ? _react["default"].createElement(_Percent["default"], {
        endNum: percent,
        style: percentStyle
      }, children) : null);
    }
  }]);
  return CircularProgress;
}(_react.Component);

CircularProgress.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The style of the percent text description.
   */
  percentStyle: _propTypes["default"].object,

  /**
   * The radius of the progress in pixels.
   */
  r: _propTypes["default"].number,

  /**
   * Stroke width in pixels.
   */
  width: _propTypes["default"].number,

  /**
   * Override the progress's color.
   */
  // rgba: PropTypes.string,

  /**
   * The value of progress.
   */
  percent: _propTypes["default"].number,

  /**
   * If true,there will have a text description.
   */
  word: _propTypes["default"].bool
};
CircularProgress.defaultProps = {
  percentStyle: {},
  r: 48,
  width: 2,
  // rgba: 'rgb(0, 188, 212)',
  percent: 0,
  word: true
};
var _default = CircularProgress;
exports["default"] = _default;