"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _sum = _interopRequireDefault(require("lodash/sum"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

var _Color = _interopRequireDefault(require("../_vendors/Color"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file ColorPicker component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ColorPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ColorPicker, _Component);

  function ColorPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ColorPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ColorPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      _this.activated = true;

      _this.handleChange(e.pageX, e.pageY);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      if (_this.activated) {
        _this.handleChange(e.pageX, e.pageY);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseUp", function () {
      _this.activated = false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (mouseX, mouseY) {
      var hue = _this.props.hue,
          width = _this.colorPickerAreaEl.offsetWidth,
          height = _this.colorPickerAreaEl.offsetHeight,
          _Dom$getOffset = _Dom["default"].getOffset(_this.colorPickerAreaEl),
          left = _Dom$getOffset.left,
          top = _Dom$getOffset.top,
          x = _Valid["default"].range(mouseX - left, 0, width),
          y = _Valid["default"].range(mouseY - top, 0, height),
          s = x / width,
          b = 1 - y / height,
          value = _Color["default"].rgb2hex(_Color["default"].hsb2rgb([hue, s, b]));

      _this.setState({
        value: value,
        s: s,
        b: b,
        x: x,
        y: y
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.activated = false;
    _this.colorPickerArea = (0, _react.createRef)();
    _this.colorPickerAreaEl = null;

    var hsb = _Color["default"].rgb2hsb(_Color["default"].hex2rgb(props.value));

    _this.state = {
      value: props.value,
      s: hsb ? hsb[1] : 0,
      b: hsb ? hsb[2] : 0,
      x: hsb ? "".concat(hsb[1] * 100, "%") : 0,
      y: hsb ? "".concat((1 - hsb[2]) * 100, "%") : 0
    };
    return _this;
  }

  (0, _createClass2["default"])(ColorPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.colorPickerAreaEl = this.colorPickerArea && this.colorPickerArea.current;

      _Event["default"].addEvent(document, 'mousemove', this.handleMouseMove);

      _Event["default"].addEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.handleMouseMove);

      _Event["default"].removeEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "render",
    // handleHueChange = hue => {
    //
    //     const {hsb} = this.state;
    //     hsb[0] = hue;
    //
    //     const value = Color.hsb2rgb(hsb);
    //
    //     this.setState({
    //         value,
    //         hsb
    //     }, () => {
    //         const {onChange} = this.props;
    //         onChange && onChange(value);
    //     });
    //
    // };
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          hue = _this$props.hue,
          _this$state = this.state,
          value = _this$state.value,
          x = _this$state.x,
          y = _this$state.y,
          areaColor = _Color["default"].hue2rgb(hue);

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('color-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        ref: this.colorPickerArea,
        className: "color-picker-area",
        style: {
          background: areaColor ? "rgb(".concat(areaColor.join(', '), ")") : null
        },
        onMouseDown: this.handleMouseDown
      }, _react["default"].createElement("div", {
        className: "color-picker-area-white-overlay"
      }), _react["default"].createElement("div", {
        className: "color-picker-area-black-overlay"
      }), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('color-picker-cursor', {
          light: (0, _sum["default"])(_Color["default"].hex2rgb(value)) / 3 < 128
        }),
        style: {
          left: x,
          top: y
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value');

      if (value === state.value) {
        return null;
      }

      var hsb = _Color["default"].rgb2hsb(_Color["default"].hex2rgb(value));

      return {
        prevProps: props,
        value: value,
        s: hsb ? hsb[1] : 0,
        b: hsb ? hsb[2] : 0,
        x: hsb ? "".concat(hsb[1] * 100, "%") : 0,
        y: hsb ? "".concat((1 - hsb[2]) * 100, "%") : 0
      };
    }
  }]);
  return ColorPicker;
}(_react.Component);

ColorPicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * hue value (deg)
   */
  hue: _propTypes["default"].number,

  /**
   * rgb hex value
   */
  value: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
ColorPicker.defaultProps = {
  hue: 0,
  value: 'ff0000'
};
var _default = ColorPicker;
exports["default"] = _default;