"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Crumb = _interopRequireDefault(require("../_Crumb"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Crumbs component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Crumbs =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Crumbs, _Component);

  function Crumbs(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Crumbs);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Crumbs)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "itemRender", function (item, index) {
      if (item.renderer) {
        return item.renderer(item, index);
      }

      var _this$props = _this.props,
          itemRenderer = _this$props.itemRenderer,
          onItemClick = _this$props.onItemClick;

      if (itemRenderer) {
        return itemRenderer(item, index);
      }

      return _react["default"].createElement(_Crumb["default"], (0, _extends2["default"])({}, item, {
        onClick: function onClick(e) {
          item.onClick && item.onClick(e);
          onItemClick && onItemClick(e, item, index);
        }
      }));
    });
    return _this;
  }

  (0, _createClass2["default"])(Crumbs, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          data = _this$props2.data,
          separator = _this$props2.separator,
          showLastSeparator = _this$props2.showLastSeparator;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('crumbs', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, data && data.map(function (item, index) {
        return _react["default"].createElement("div", {
          key: index,
          className: "crumbs-item-wrapper"
        }, _this2.itemRender(item, index), !showLastSeparator && index === data.length - 1 ? null : _react["default"].createElement("div", {
          className: "crumbs-separator"
        }, separator));
      }));
    }
  }]);
  return Crumbs;
}(_react.Component);

(0, _defineProperty2["default"])(Crumbs, "Theme", _Theme["default"]);
Crumbs.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The theme of the Crumbs.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * Crumbs data config.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The url of crumb.
     */
    href: _propTypes["default"].string,

    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The list item's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true,the list item will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,

    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),

    /**
     * If true,the item will have center displayed ripple effect.
     */
    rippleDisplayCenter: _propTypes["default"].bool,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,

    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])).isRequired,
  separator: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]),
  showLastSeparator: _propTypes["default"].bool,

  /**
   * Crumbs data renderer callback.
   */
  itemRenderer: _propTypes["default"].func,
  onItemClick: _propTypes["default"].func
};
Crumbs.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  separator: '>',
  showLastSeparator: false
};
var _default = Crumbs;
exports["default"] = _default;