"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DayPicker = _interopRequireDefault(require("../_DayPicker"));

var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));

var _YearPicker = _interopRequireDefault(require("../_YearPicker"));

var _FlatButton = _interopRequireDefault(require("../FlatButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

/**
 * @file DatePicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var DateField =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DateField, _Component);

  function DateField(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DateField);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DateField)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (selectLevel) {
      _this.setState({
        datePickerLevel: selectLevel
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerChange", function (date) {
      var _this$props = _this.props,
          dateFormat = _this$props.dateFormat,
          onChange = _this$props.onChange;
      var state = (0, _cloneDeep["default"])(_this.state);
      state.value = (0, _moment["default"])(date.time, dateFormat);
      state.year = date.year;
      state.month = date.month;
      state.day = date.day;
      !_this.props.disabled && _this.setState(state, function () {
        onChange((0, _moment["default"])(date.time).format(dateFormat));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (date) {
      _this.setState({
        datePickerLevel: 'day',
        year: date.year,
        month: date.month
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (year) {
      _this.setState({
        datePickerLevel: 'month',
        year: year
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleToday", function () {
      var _this$props2 = _this.props,
          dateFormat = _this$props2.dateFormat,
          onChange = _this$props2.onChange;
      var year = (0, _moment["default"])().format('YYYY'),
          month = (0, _moment["default"])().format('MM'),
          day = (0, _moment["default"])().format('DD');
      var timer = (0, _moment["default"])((0, _moment["default"])(), dateFormat);

      _this.setState({
        value: timer,
        year: year,
        month: month,
        day: day
      }, function () {
        !_this.props.disabled && onChange(value && (0, _moment["default"])(value).format(_this.props.dateFormat));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "validValueFormat", function (value, dateFormat) {
      var state = (0, _cloneDeep["default"])(_this.state);

      if (value) {
        // debugger
        if ((0, _moment["default"])(value, dateFormat).isValid()) {
          var year = (0, _moment["default"])(value).format('YYYY'),
              month = (0, _moment["default"])(value).format('MM'),
              day = (0, _moment["default"])(value).format('DD');
          state.value = (0, _moment["default"])(value, dateFormat);
          state.year = year;
          state.month = month;
          state.day = day;

          _this.setState(state);
        } else {
          _this.validValue = false;
          console.error('Invalid date');
        }
      } else {
        state.value = '';
        state.year = (0, _moment["default"])(_this.defaultValue).format('YYYY');
        state.month = (0, _moment["default"])(_this.defaultValue).format('MM');
        state.day = (0, _moment["default"])(_this.defaultValue).format('DD');

        _this.setState(state);
      }
    });
    var defaultValue = props.value ? props.value : (0, _moment["default"])().format('YYYY-MM-DD');
    _this.state = {
      value: props.value,
      year: (0, _moment["default"])(defaultValue).format('YYYY'),
      month: (0, _moment["default"])(defaultValue).format('MM'),
      day: (0, _moment["default"])(defaultValue).format('DD'),
      datePickerLevel: 'day'
    };
    return _this;
  }

  (0, _createClass2["default"])(DateField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props3 = this.props,
          value = _this$props3.value,
          dateFormat = _this$props3.dateFormat;
      this.validValueFormat(value, dateFormat);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value && nextProps.value !== this.props.value || nextProps.dateFormat !== this.props.dateFormat) {
        this.validValueFormat(nextProps.value, nextProps.dateFormat);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          className = _this$props4.className,
          dateFormat = _this$props4.dateFormat,
          maxValue = _this$props4.maxValue,
          minValue = _this$props4.minValue,
          isFooter = _this$props4.isFooter,
          previousYearIconCls = _this$props4.previousYearIconCls,
          previousMonthIconCls = _this$props4.previousMonthIconCls,
          nextYearIconCls = _this$props4.nextYearIconCls,
          nextMonthIconCls = _this$props4.nextMonthIconCls,
          _this$state = this.state,
          value = _this$state.value,
          datePickerLevel = _this$state.datePickerLevel,
          year = _this$state.year,
          month = _this$state.month,
          day = _this$state.day;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('date-field', (0, _defineProperty2["default"])({}, className, className))
      }, datePickerLevel == 'day' ? _react["default"].createElement(_DayPicker["default"], {
        value: value,
        dateFormat: dateFormat,
        year: year,
        month: month,
        day: day,
        maxValue: maxValue,
        minValue: minValue,
        isFooter: isFooter,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleDayPickerChange,
        previousClick: this.handleDatePickerChange
      }) : datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: value,
        year: year,
        month: month,
        day: day,
        maxValue: maxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleMonthPickerChange,
        previousClick: this.handleDatePickerChange
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: value,
        year: year,
        month: month,
        day: day,
        maxValue: maxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleYearPickerChange
      }), isFooter && datePickerLevel == 'day' ? _react["default"].createElement("div", {
        className: "calendar-footer"
      }, minValue && (0, _moment["default"])(this.props.value).isBefore(minValue) || maxValue && (0, _moment["default"])(maxValue).isBefore(this.props.value) ? _react["default"].createElement("a", {
        href: "javascript:void(0);"
      }, _react["default"].createElement("span", {
        className: "item-gray"
      }, "Today")) : _react["default"].createElement(_FlatButton["default"], {
        className: "today-button",
        value: 'Today',
        onClick: this.handleToday
      })) : null);
    }
  }]);
  return DateField;
}(_react.Component);

(0, _defineProperty2["default"])(DateField, "Theme", _Theme["default"]);
DateField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].any,

  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].any,

  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].any,

  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isFooter: _propTypes["default"].bool,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,

  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
DateField.defaultProps = {
  maxValue: '',
  minValue: '',
  dateFormat: 'YYYY-MM-DD',
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right',
  isFooter: false
};
var _default = DateField;
exports["default"] = _default;