"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _DayPicker = _interopRequireDefault(require("../_DayPicker"));

var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));

var _YearPicker = _interopRequireDefault(require("../_YearPicker"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _reactDom = require("react-dom");

/**
 * @file DateRangePicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var DateRangePickerContent =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DateRangePickerContent, _Component);

  function DateRangePickerContent(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DateRangePickerContent);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DateRangePickerContent)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "datePickerChangeHandle", function (select, selectLevel) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = selectLevel;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dayPickerChangeHandle", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);

      if (state.endTime) {
        state[select].text = date.time;
        state[select].year = date.year;
        state[select].month = date.month;
        state[select].day = date.day;
        state.startTime = date.time;
        state.endTime = '';
        state.hoverTime = '';

        _this.setState(state);
      } else if (state.startTime) {
        var startTime = state.startTime;
        var endTime;

        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          endTime = date.time;
        } else {
          endTime = startTime;
          startTime = date.time;
        }

        state.right.text = endTime;
        state.left.text = startTime;
        state.endTime = endTime;
        state.startTime = startTime;
        state.historyStartTime = startTime;
        state.historyEndTime = endTime;
        state.hoverTime = '';
        state.value = [(0, _moment["default"])(state.startTime).format(_this.props.dateFormat), (0, _moment["default"])(state.endTime).format(_this.props.dateFormat)];

        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange([(0, _moment["default"])(state.startTime).format(_this.props.dateFormat), (0, _moment["default"])(state.endTime).format(_this.props.dateFormat)]);
        });
      } else {
        state[select].text = date.time;
        state[select].year = date.year;
        state[select].month = date.month;
        state[select].day = date.day;
        state.startTime = date.time;
        state.endTime = '';
        state.hoverTime = '';

        _this.setState(state);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dayPickerHoverHandle", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      var startTime = state.startTime;
      var endTime = state.endTime;

      if (startTime && endTime == '') {
        state.hoverTime = date.time;

        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          state.left.text = startTime;
          state.right.text = date.time;
        } else {
          state.right.text = startTime;
          state.left.text = date.time;
        }

        _this.setState(state);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "monthAndYearChangeHandle", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].year = date.year;
      state[select].month = date.month;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "monthPickerChangeHandle", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = 'day';
      state[select].year = date.year;
      state[select].month = date.month;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "yearPickerChangeHandle", function (select, year) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = 'month';
      state[select].year = year;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setDateRange", function (start, end) {
      if (start.year == end.year && start.month == end.month) {
        end.year = start.month == 12 ? +end.year + 1 : end.year;
        end.month = start.month == 12 ? 1 : +end.month + 1;
      } else {
        end.year = end.year;
        end.month = end.month;
      }

      return {
        start: start,
        end: end
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setValue", function (value, format) {
      var state = (0, _cloneDeep["default"])(_this.state);

      if (value && value.length > 1) {
        var leftValue = value[0],
            rightValue = value[1];

        if (!!leftValue) {
          if ((0, _moment["default"])(leftValue, format).isValid() || !!rightValue && (0, _moment["default"])(leftValue, format).isValid()) {
            state.left.text = leftValue;
            state.left.year = (0, _moment["default"])(value[0]).format('YYYY');
            state.left.month = (0, _moment["default"])(value[0]).format('MM');
            state.left.day = (0, _moment["default"])(value[0]).format('DD');
            state.right.text = rightValue;
            state.right.year = rightValue ? (0, _moment["default"])(value[1]).format('YYYY') : (0, _moment["default"])(value[0]).format('YYYY');
            state.right.month = rightValue ? (0, _moment["default"])(value[1]).format('MM') : (0, _moment["default"])(value[0]).format('MM');
            state.right.day = rightValue ? (0, _moment["default"])(value[1]).format('DD') : (0, _moment["default"])(value[0]).format('DD');
            state.left = _this.setDateRange(state.left, state.right).start;
            state.right = _this.setDateRange(state.left, state.right).end;
            state.startTime = leftValue;
            state.endTime = rightValue;
            state.historyStartTime = leftValue;
            state.historyEndTime = rightValue;

            _this.setState(state);
          } else {
            _this.validValue = false;
            console.error('Invalid date');
          }
        } else {
          state.left.text = '';
          state.right.text = '';
          state.left.year = (0, _moment["default"])().format('YYYY');
          state.left.month = (0, _moment["default"])().format('MM');
          state.left.day = (0, _moment["default"])().format('DD');
          state.right.year = (0, _moment["default"])().format('YYYY');
          state.right.month = (0, _moment["default"])().format('MM');
          state.right.day = (0, _moment["default"])().format('DD');
          state.startTime = '';
          state.endTime = '';
          state.historyStartTime = '';
          state.historyEndTime = '';
          state.left = _this.setDateRange(state.left, state.right).start;
          state.right = _this.setDateRange(state.left, state.right).end;

          _this.setState(state);
        }
      }
    });
    var initValue = (0, _moment["default"])();
    _this.validValue = true;
    _this.state = {
      value: props.value,
      // Moment object
      left: {
        text: '',
        datePickerLevel: 'day',
        year: initValue.format('YYYY'),
        month: initValue.format('MM'),
        day: initValue.format('DD')
      },
      right: {
        text: '',
        datePickerLevel: 'day',
        year: initValue.format('MM') == 12 ? +initValue.format('YYYY') + 1 : initValue.format('YYYY'),
        month: initValue.format('MM') == 12 ? 1 : +initValue.format('MM') + 1,
        day: initValue.format('DD')
      },
      startTime: '',
      endTime: '',
      historyStartTime: '',
      historyEndTime: '',
      hoverTime: ''
    };
    return _this;
  }

  (0, _createClass2["default"])(DateRangePickerContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          value = _this$props.value,
          dateFormat = _this$props.dateFormat;
      this.setValue(value, dateFormat);
      this.datePicker = this.refs.datePicker;
      this.triggerEl = (0, _reactDom.findDOMNode)(this.refs.trigger);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (JSON.stringify(nextProps.value) !== JSON.stringify(this.props.value) || nextProps.dateFormat !== this.props.dateFormat) {
        this.setValue(nextProps.value, nextProps.dateFormat);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          dateFormat = _this$props2.dateFormat,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          previousYearIconCls = _this$props2.previousYearIconCls,
          previousMonthIconCls = _this$props2.previousMonthIconCls,
          nextYearIconCls = _this$props2.nextYearIconCls,
          nextMonthIconCls = _this$props2.nextMonthIconCls,
          _this$state = this.state,
          left = _this$state.left,
          right = _this$state.right,
          startTime = _this$state.startTime,
          endTime = _this$state.endTime,
          hoverTime = _this$state.hoverTime;
      var maxYear = right.year,
          maxMonth = right.month;
      maxYear = maxMonth == 1 ? +maxYear - 1 : maxYear;
      maxMonth = maxMonth == 1 ? 11 : +maxMonth - 2;

      var maxDay = _Util["default"].MonthDays(maxYear)[maxMonth],
          leftMaxValue = maxValue && (0, _moment["default"])([maxYear, maxMonth, maxDay]).isAfter(maxValue) ? maxValue : (0, _moment["default"])([maxYear, maxMonth, maxDay]).format('YYYY-MM-DD'),
          minYear = left.year,
          minMonth = left.month;

      minYear = minMonth == 12 ? +minYear + 1 : minYear;
      minMonth = minMonth == 12 ? 1 : +minMonth + 1;
      var rightMinValue = minValue && (0, _moment["default"])([minYear, minMonth - 1, 1]).isBefore(minValue) ? minValue : (0, _moment["default"])([minYear, minMonth - 1, 1]).format('YYYY-MM-DD');
      return _react["default"].createElement("div", {
        className: "date-range-picker-content ".concat(className)
      }, left.datePickerLevel == 'day' ? _react["default"].createElement(_DayPicker["default"], {
        value: left.text,
        dateFormat: dateFormat,
        year: left.year,
        month: left.month,
        day: left.day,
        isFooter: false,
        isRange: true,
        maxValue: leftMaxValue,
        minValue: minValue,
        startTime: startTime,
        endTime: endTime,
        hoverTime: hoverTime,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        monthAndYearChange: function monthAndYearChange(obj) {
          _this2.monthAndYearChangeHandle('left', obj);
        },
        onChange: function onChange(obj) {
          _this2.dayPickerChangeHandle('left', obj);
        },
        previousClick: function previousClick(level) {
          _this2.datePickerChangeHandle('left', level);
        },
        hoverHandle: function hoverHandle(obj) {
          _this2.dayPickerHoverHandle('left', obj);
        }
      }) : left.datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: left.text,
        year: left.year,
        month: left.month,
        day: left.day,
        maxValue: leftMaxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.monthPickerChangeHandle('left', obj);
        },
        previousClick: function previousClick(level) {
          _this2.datePickerChangeHandle('left', level);
        }
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: left.text,
        year: left.year,
        month: left.month,
        day: left.day,
        maxValue: leftMaxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.yearPickerChangeHandle('left', obj);
        }
      }), right.datePickerLevel == 'day' ? _react["default"].createElement(_DayPicker["default"], {
        value: right.text,
        dateFormat: dateFormat,
        year: right.year,
        month: right.month,
        day: right.day,
        isFooter: false,
        isRange: true,
        startTime: startTime,
        endTime: endTime,
        hoverTime: hoverTime,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        monthAndYearChange: function monthAndYearChange(obj) {
          _this2.monthAndYearChangeHandle('right', obj);
        },
        onChange: function onChange(obj) {
          _this2.dayPickerChangeHandle('right', obj);
        },
        previousClick: function previousClick(level) {
          _this2.datePickerChangeHandle('right', level);
        },
        hoverHandle: function hoverHandle(obj) {
          _this2.dayPickerHoverHandle('left', obj);
        }
      }) : right.datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: right.text,
        year: right.year,
        month: right.month,
        day: right.day,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.monthPickerChangeHandle('right', obj);
        },
        previousClick: function previousClick(level) {
          _this2.datePickerChangeHandle('right', level);
        }
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: right.text,
        year: right.year,
        month: right.month,
        day: right.day,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.yearPickerChangeHandle('right', obj);
        }
      }));
    }
  }]);
  return DateRangePickerContent;
}(_react.Component);

(0, _defineProperty2["default"])(DateRangePickerContent, "Theme", _Theme["default"]);
DateRangePickerContent.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the popup element.
   */
  style: _propTypes["default"].object,

  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].array,

  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,

  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,

  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,

  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
DateRangePickerContent.defaultProps = {
  dateFormat: 'YYYY-MM-DD',
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right'
};
var _default = DateRangePickerContent;
exports["default"] = _default;