"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _moment = _interopRequireDefault(require("moment"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _DayPicker = _interopRequireDefault(require("../_DayPicker"));

var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));

var _YearPicker = _interopRequireDefault(require("../_YearPicker"));

var _Popup = _interopRequireDefault(require("../Popup"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));

/**
 * @file DateRangePicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var DateRangePicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DateRangePicker, _Component);

  function DateRangePicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DateRangePicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DateRangePicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (select, selectLevel) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = selectLevel;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTextFieldChange", function (select, text) {
      if (text && text.length) {
        var flag = (0, _moment["default"])(text, _this.props.dateFormat, true).isValid();

        if (flag) {
          var initValue = (0, _moment["default"])(text).format('YYYY-MM-DD');
          var selectYear = initValue.split('-')[0],
              selectMonth = initValue.split('-')[1],
              selectDay = initValue.split('-')[2];
          var state = (0, _cloneDeep["default"])(_this.state);

          if (select == 'left') {
            if ((0, _moment["default"])(text).isBefore(state.right.text)) {
              state.startTime = text;
              state.left.text = text;
              state.left.year = selectYear;
              state.left.month = selectMonth;
              state.left.day = selectDay;

              if (selectYear == state.right.year && selectMonth == state.right.month) {
                if (selectMonth == 12) {
                  state.right.month = 1;
                  state.right.year = +selectYear + 1;
                } else {
                  state.right.month = +selectMonth + 1;
                }
              }
            }

            _this.setState(state);
          } else {
            if ((0, _moment["default"])(state.startTime).isBefore(text)) {
              state.endTime = text;
              state.right.text = text;

              if (selectYear == state.left.year && selectMonth == state.left.month) {
                state.right.month = +selectMonth + 1;
              } else {
                state.right.year = selectYear;
                state.right.month = selectMonth;
                state.right.day = selectDay;
              }
            }

            _this.setState(state);
          }
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerChange", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);

      if (state.endTime) {
        state[select].text = date.time;
        state[select].year = date.year;
        state[select].month = date.month;
        state[select].day = date.day;
        state.startTime = date.time;
        state.endTime = '';
        state.hoverTime = '';

        _this.setState(state);
      } else if (state.startTime) {
        var startTime = state.startTime;
        var endTime;

        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          endTime = date.time;
        } else {
          endTime = startTime;
          startTime = date.time;
        }

        state.right.text = endTime;
        state.left.text = startTime;
        state.endTime = endTime;
        state.startTime = startTime;
        state.historyStartTime = startTime;
        state.historyEndTime = endTime;
        state.hoverTime = '';

        _this.setState(state);
      } else {
        state[select].text = date.time;
        state[select].year = date.year;
        state[select].month = date.month;
        state[select].day = date.day;
        state.startTime = date.time;
        state.endTime = '';
        state.hoverTime = '';

        _this.setState(state);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerHover", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      var startTime = state.startTime;
      var endTime = state.endTime;

      if (startTime && endTime == '') {
        state.hoverTime = date.time;

        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          state.left.text = startTime;
          state.right.text = date.time;
        } else {
          state.right.text = startTime;
          state.left.text = date.time;
        }

        _this.setState(state);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthAndYearChange", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].year = date.year;
      state[select].month = date.month;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (select, date) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = 'day';
      state[select].year = date.year;
      state[select].month = date.month;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (select, year) {
      var state = (0, _cloneDeep["default"])(_this.state);
      state[select].datePickerLevel = 'month';
      state[select].year = year;

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function (e) {
      if (_this.validValue) {
        _this.setState({
          popupVisible: !_this.state.popupVisible
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      var dateFormat = _this.props.dateFormat;
      var state = (0, _cloneDeep["default"])(_this.state);
      state.popupVisible = false;
      state.left.datePickerLevel = 'day';
      state.right.datePickerLevel = 'day';

      if (!state.endTime) {
        state.startTime = state.historyStartTime;
        state.endTime = state.historyEndTime;
        state.left.text = state.historyStartTime;
        state.right.text = state.historyEndTime;
        state.hoverTime = '';

        if (state.historyStartTime && state.historyEndTime) {
          state.left.year = (0, _moment["default"])(state.historyStartTime).format('YYYY');
          state.left.month = (0, _moment["default"])(state.historyStartTime).format('MM');
          state.left.day = (0, _moment["default"])(state.historyStartTime).format('DD');

          if ((0, _moment["default"])(state.historyStartTime).format('YYYY') == (0, _moment["default"])(state.historyEndTime).format('YYYY') && (0, _moment["default"])(state.historyStartTime).format('MM') == (0, _moment["default"])(state.historyEndTime).format('MM')) {
            if ((0, _moment["default"])(state.historyEndTime).format('MM') == 12) {
              state.right.year = +(0, _moment["default"])(state.historyEndTime).format('YYYY') + 1;
              state.right.month = 1;
            } else {
              state.right.year = (0, _moment["default"])(state.historyEndTime).format('YYYY');
              state.right.month = +(0, _moment["default"])(state.historyEndTime).format('MM') + 1;
            }
          } else {
            state.right.year = (0, _moment["default"])(state.historyEndTime).format('YYYY');
            state.right.month = (0, _moment["default"])(state.historyEndTime).format('MM');
          }

          state.right.day = (0, _moment["default"])(state.historyEndTime).format('DD');
        }
      }

      state.value = [(0, _moment["default"])(state.left.text, dateFormat), (0, _moment["default"])(state.right.text, dateFormat)];
      !_this.props.disabled && _this.setState(state, function () {
        _this.props.onChange && _this.props.onChange([(0, _moment["default"])(state.value[0]).format(_this.props.dateFormat), (0, _moment["default"])(state.value[1]).format(_this.props.dateFormat)]);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (pop) {
      if (_this.props.position) {
        return;
      }

      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(pop));

      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setDateRange", function (start, end) {
      if (start.year == end.year && start.month == end.month) {
        if (start.month == 12) {
          end.year = +end.year + 1;
          end.month = 1;
        } else {
          end.year = end.year;
          end.month = +end.month + 1;
        }
      } else {
        end.year = end.year;
        end.month = end.month;
      }

      return {
        start: start,
        end: end
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setValue", function (value, format) {
      var state = (0, _cloneDeep["default"])(_this.state);

      if (value && value.length > 1) {
        var leftValue = value[0],
            rightValue = value[1];

        if (!!leftValue) {
          if ((0, _moment["default"])(leftValue, format).isValid() || !!rightValue && (0, _moment["default"])(leftValue, format).isValid()) {
            state.left.text = leftValue;
            state.left.year = (0, _moment["default"])(value[0]).format('YYYY');
            state.left.month = (0, _moment["default"])(value[0]).format('MM');
            state.left.day = (0, _moment["default"])(value[0]).format('DD');
            state.right.text = rightValue;
            state.right.year = rightValue ? (0, _moment["default"])(value[1]).format('YYYY') : (0, _moment["default"])(value[0]).format('YYYY');
            state.right.month = rightValue ? (0, _moment["default"])(value[1]).format('MM') : (0, _moment["default"])(value[0]).format('MM');
            state.right.day = rightValue ? (0, _moment["default"])(value[1]).format('DD') : (0, _moment["default"])(value[0]).format('DD');
            state.left = _this.setDateRange(state.left, state.right).start;
            state.right = _this.setDateRange(state.left, state.right).end;
            state.startTime = leftValue;
            state.endTime = rightValue;
            state.historyStartTime = leftValue;
            state.historyEndTime = rightValue;

            _this.setState(state);
          } else {
            _this.validValue = false;
            console.error('Invalid date');
          }
        } else {
          state.left.text = '';
          state.right.text = '';
          state.left.year = (0, _moment["default"])().format('YYYY');
          state.left.month = (0, _moment["default"])().format('MM');
          state.left.day = (0, _moment["default"])().format('DD');
          state.right.year = (0, _moment["default"])().format('YYYY');
          state.right.month = (0, _moment["default"])().format('MM');
          state.right.day = (0, _moment["default"])().format('DD');
          state.startTime = '';
          state.endTime = '';
          state.historyStartTime = '';
          state.historyEndTime = '';
          state.left = _this.setDateRange(state.left, state.right).start;
          state.right = _this.setDateRange(state.left, state.right).end;

          _this.setState(state);
        }
      }
    });

    var _initValue = (0, _moment["default"])();

    _this.validValue = true;
    _this.trigger = (0, _react.createRef)();
    _this.triggerEl = null;
    var _startTime = '',
        _endTime = '';
    _this.state = {
      value: props.value,
      // Moment object
      popupVisible: false,
      isAbove: false,
      left: {
        text: _startTime,
        datePickerLevel: 'day',
        year: _initValue.format('YYYY'),
        month: _initValue.format('MM'),
        day: _initValue.format('DD')
      },
      right: {
        text: _endTime,
        datePickerLevel: 'day',
        year: _initValue.format('MM') == 12 ? +_initValue.format('YYYY') + 1 : _initValue.format('YYYY'),
        month: _initValue.format('MM') == 12 ? 1 : +_initValue.format('MM') + 1,
        day: _initValue.format('DD')
      },
      startTime: '',
      endTime: '',
      historyStartTime: '',
      historyEndTime: '',
      hoverTime: ''
    };
    return _this;
  }

  (0, _createClass2["default"])(DateRangePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          value = _this$props.value,
          dateFormat = _this$props.dateFormat;
      this.setValue(value, dateFormat);
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (JSON.stringify(nextProps.value) !== JSON.stringify(this.props.value) || nextProps.dateFormat !== this.props.dateFormat) {
        this.setValue(nextProps.value, nextProps.dateFormat);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          name = _this$props2.name,
          placeholder = _this$props2.placeholder,
          dateFormat = _this$props2.dateFormat,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          position = _this$props2.position,
          popupClassName = _this$props2.popupClassName,
          rightIconCls = _this$props2.rightIconCls,
          previousYearIconCls = _this$props2.previousYearIconCls,
          previousMonthIconCls = _this$props2.previousMonthIconCls,
          nextYearIconCls = _this$props2.nextYearIconCls,
          nextMonthIconCls = _this$props2.nextMonthIconCls,
          readOnly = _this$props2.readOnly,
          disabled = _this$props2.disabled,
          parentEl = _this$props2.parentEl,
          _this$state = this.state,
          popupVisible = _this$state.popupVisible,
          left = _this$state.left,
          right = _this$state.right,
          startTime = _this$state.startTime,
          endTime = _this$state.endTime,
          hoverTime = _this$state.hoverTime,
          isAbove = _this$state.isAbove;
      var textFieldValue = left.text && right.text ? left.text + '~ ' + right.text : '',
          maxYear = right.year,
          maxMonth = right.month;
      maxYear = maxMonth == 1 ? +maxYear - 1 : maxYear;
      maxMonth = maxMonth == 1 ? 11 : +maxMonth - 2;

      var maxDay = _Util["default"].MonthDays(maxYear)[maxMonth],
          leftMaxValue = maxValue && (0, _moment["default"])([maxYear, maxMonth, maxDay]).isAfter(maxValue) ? maxValue : (0, _moment["default"])([maxYear, maxMonth, maxDay]).format('YYYY-MM-DD'),
          minYear = left.year,
          minMonth = left.month;

      minYear = minMonth == 12 ? +minYear + 1 : minYear;
      minMonth = minMonth == 12 ? 1 : +minMonth + 1;
      var rightMinValue = minValue && (0, _moment["default"])([minYear, minMonth - 1, 1]).isBefore(minValue) ? minValue : (0, _moment["default"])([minYear, minMonth - 1, 1]).format('YYYY-MM-DD');
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('date-range-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: "date-range-picker-field",
        name: name,
        placeholder: placeholder,
        value: textFieldValue,
        readOnly: true,
        disabled: disabled,
        rightIconCls: rightIconCls,
        clearButtonVisible: false,
        isFocusedSelectAll: false,
        onClick: function onClick(e) {
          _this2.togglePopup(e);
        }
      }), _react["default"].createElement(_Popup["default"], {
        className: "date-range-picker-popup ".concat(popupClassName),
        visible: popupVisible,
        parentEl: parentEl,
        triggerEl: this.triggerEl,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        hasTriangle: false,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, _react["default"].createElement("div", {
        className: "calendar-date-input-wrap"
      }, _react["default"].createElement("div", {
        className: "DateRangePickerHeaderInput"
      }, _react["default"].createElement(_TextField["default"], {
        className: "fl calendar-input",
        placeholder: placeholder,
        value: left.text,
        clearButtonVisible: false,
        readOnly: readOnly,
        onChange: function onChange(text) {
          _this2.handleTextFieldChange('left', text);
        }
      }), _react["default"].createElement(_TextField["default"], {
        className: "fl calendar-input",
        placeholder: placeholder,
        value: right.text,
        clearButtonVisible: false,
        readOnly: readOnly,
        onChange: function onChange(text) {
          _this2.handleTextFieldChange('right', text);
        }
      }))), left.datePickerLevel == 'day' ? _react["default"].createElement(_DayPicker["default"], {
        value: left.text,
        dateFormat: dateFormat,
        year: left.year,
        month: left.month,
        day: left.day,
        isFooter: false,
        isRange: true,
        maxValue: leftMaxValue,
        minValue: minValue,
        startTime: startTime,
        endTime: endTime,
        hoverTime: hoverTime,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        monthAndYearChange: function monthAndYearChange(obj) {
          _this2.handleMonthAndYearChange('left', obj);
        },
        onChange: function onChange(obj) {
          _this2.handleDayPickerChange('left', obj);
        },
        previousClick: function previousClick(level) {
          _this2.handleDatePickerChange('left', level);
        },
        hoverHandle: function hoverHandle(obj) {
          _this2.handleDayPickerHover('left', obj);
        }
      }) : left.datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: left.text,
        year: left.year,
        month: left.month,
        day: left.day,
        maxValue: leftMaxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.handleMonthPickerChange('left', obj);
        },
        previousClick: function previousClick(level) {
          _this2.handleDatePickerChange('left', level);
        }
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: left.text,
        year: left.year,
        month: left.month,
        day: left.day,
        maxValue: leftMaxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.handleYearPickerChange('left', obj);
        }
      }), right.datePickerLevel == 'day' ? _react["default"].createElement(_DayPicker["default"], {
        value: right.text,
        dateFormat: dateFormat,
        year: right.year,
        month: right.month,
        day: right.day,
        isFooter: false,
        isRange: true,
        startTime: startTime,
        endTime: endTime,
        hoverTime: hoverTime,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        monthAndYearChange: function monthAndYearChange(obj) {
          _this2.handleMonthAndYearChange('right', obj);
        },
        onChange: function onChange(obj) {
          _this2.handleDayPickerChange('right', obj);
        },
        previousClick: function previousClick(level) {
          _this2.handleDatePickerChange('right', level);
        },
        hoverHandle: function hoverHandle(obj) {
          _this2.handleDayPickerHover('left', obj);
        }
      }) : right.datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: right.text,
        year: right.year,
        month: right.month,
        day: right.day,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.handleMonthPickerChange('right', obj);
        },
        previousClick: function previousClick(level) {
          _this2.handleDatePickerChange('right', level);
        }
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: right.text,
        year: right.year,
        month: right.month,
        day: right.day,
        minValue: rightMinValue,
        maxValue: maxValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: function onChange(obj) {
          _this2.handleYearPickerChange('right', obj);
        }
      })));
    }
  }]);
  return DateRangePicker;
}(_react.Component);

(0, _defineProperty2["default"])(DateRangePicker, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(DateRangePicker, "Position", _Position["default"]);
DateRangePicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * DateRangePicker input name.
   */
  name: _propTypes["default"].string,

  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].array,

  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,

  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,

  /**
   * DateRangePicker textField element placeholder.
   */
  placeholder: _propTypes["default"].string,

  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,

  /**
   * If true,dateRangePicker textField is readOnly.
   */
  readOnly: _propTypes["default"].bool,

  /**
   * If true,dateRangePicker textField is disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the date selection box will displayed.
   */
  popupVisible: _propTypes["default"].bool,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,

  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
DateRangePicker.defaultProps = {
  name: '',
  placeholder: 'Date',
  popupClassName: '',
  dateFormat: 'YYYY-MM-DD',
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right',
  position: _Position["default"].BOTTOM_LEFT,
  readOnly: false,
  disabled: false
};
var _default = DateRangePicker;
exports["default"] = _default;