"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PositionPop = _interopRequireDefault(require("../_PositionPop"));

var _Paper = _interopRequireDefault(require("../Paper"));

var _FlatButton = _interopRequireDefault(require("../FlatButton"));

var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _PopManagement = _interopRequireDefault(require("../_vendors/PopManagement"));

/**
 * @file Dialog component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Dialog =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Dialog, _Component);

  function Dialog(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Dialog);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Dialog)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      return _this.pop && _this.pop.current && _this.pop.current.getEl();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOkButtonClick", function () {
      var _this$props = _this.props,
          visible = _this$props.visible,
          onOKButtonClick = _this$props.onOKButtonClick;
      visible && onOKButtonClick && onOKButtonClick(function () {
        _this.setState({
          visible: false
        }, function () {
          var onRequestClose = _this.props.onRequestClose;
          onRequestClose && onRequestClose();
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCancelButtonClick", function () {
      var _this$props2 = _this.props,
          onCancelButtonClick = _this$props2.onCancelButtonClick,
          onRequestClose = _this$props2.onRequestClose;
      onCancelButtonClick && onCancelButtonClick();

      _this.setState({
        visible: false
      }, function () {
        onRequestClose && onRequestClose();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCloseButtonClick", function () {
      var _this$props3 = _this.props,
          onCloseButtonClick = _this$props3.onCloseButtonClick,
          onRequestClose = _this$props3.onRequestClose;
      onCloseButtonClick && onCloseButtonClick();

      _this.setState({
        visible: false
      }, function () {
        onRequestClose && onRequestClose();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      _PopManagement["default"].push((0, _assertThisInitialized2["default"])(_this), {
        shouldLockBody: _this.props.showModal
      });

      var onRender = _this.props.onRender;
      onRender && onRender.apply(void 0, arguments);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function () {
      _PopManagement["default"].pop((0, _assertThisInitialized2["default"])(_this));

      var onDestroy = _this.props.onDestroy;
      onDestroy && onDestroy.apply(void 0, arguments);
    });
    _this.pop = (0, _react.createRef)();
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(Dialog, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _PopManagement["default"].pop(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          className = _this$props4.className,
          modalClassName = _this$props4.modalClassName,
          position = _this$props4.position,
          disabled = _this$props4.disabled,
          showModal = _this$props4.showModal,
          title = _this$props4.title,
          buttons = _this$props4.buttons,
          isLoading = _this$props4.isLoading,
          visible = _this$props4.visible,
          okButtonVisible = _this$props4.okButtonVisible,
          okButtonText = _this$props4.okButtonText,
          okButtonIconCls = _this$props4.okButtonIconCls,
          okButtonTheme = _this$props4.okButtonTheme,
          okButtonDisabled = _this$props4.okButtonDisabled,
          okButtonIsLoading = _this$props4.okButtonIsLoading,
          cancelButtonVisible = _this$props4.cancelButtonVisible,
          cancelButtonText = _this$props4.cancelButtonText,
          cancelButtonIconCls = _this$props4.cancelButtonIconCls,
          cancelButtonDisabled = _this$props4.cancelButtonDisabled,
          cancelButtonIsLoading = _this$props4.cancelButtonIsLoading,
          cancelButtonTheme = _this$props4.cancelButtonTheme,
          closeButtonVisible = _this$props4.closeButtonVisible,
          closeIconCls = _this$props4.closeIconCls,
          isBlurClose = _this$props4.isBlurClose,
          isEscClose = _this$props4.isEscClose,
          onRequestClose = _this$props4.onRequestClose,
          onOKButtonClick = _this$props4.onOKButtonClick,
          onCloseButtonClick = _this$props4.onCloseButtonClick,
          onCancelButtonClick = _this$props4.onCancelButtonClick,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props4, ["children", "className", "modalClassName", "position", "disabled", "showModal", "title", "buttons", "isLoading", "visible", "okButtonVisible", "okButtonText", "okButtonIconCls", "okButtonTheme", "okButtonDisabled", "okButtonIsLoading", "cancelButtonVisible", "cancelButtonText", "cancelButtonIconCls", "cancelButtonDisabled", "cancelButtonIsLoading", "cancelButtonTheme", "closeButtonVisible", "closeIconCls", "isBlurClose", "isEscClose", "onRequestClose", "onOKButtonClick", "onCloseButtonClick", "onCancelButtonClick"]);
      return _react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('dialog', (0, _defineProperty2["default"])({}, className, className)),
        position: position,
        visible: visible,
        container: _react["default"].createElement(_Paper["default"], {
          depth: 6
        }),
        showModal: showModal,
        modalClassName: modalClassName,
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }), function (popEl) {
        return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("div", {
          className: "dialog-title"
        }, title, closeButtonVisible ? _react["default"].createElement(_IconButton["default"], {
          className: "dialog-title-close-button",
          iconCls: closeIconCls,
          disabled: disabled,
          onClick: _this2.handleCloseButtonClick
        }) : null), _react["default"].createElement("div", {
          className: "dialog-content"
        }, typeof children === 'function' ? children(popEl && popEl.querySelector('.dialog-content'), popEl) : children), _react["default"].createElement("div", {
          className: "dialog-buttons"
        }, buttons ? _react.Children.map(buttons, function (button) {
          return (0, _react.cloneElement)(button, {
            isLoading: isLoading,
            disabled: disabled
          });
        }) : null, !buttons && okButtonVisible ? _react["default"].createElement(_RaisedButton["default"], {
          className: "ok-button",
          value: okButtonText,
          iconCls: okButtonIconCls,
          theme: okButtonTheme,
          disabled: okButtonDisabled,
          isLoading: isLoading || okButtonIsLoading,
          disableTouchRipple: true,
          onClick: _this2.handleOkButtonClick
        }) : null, !buttons && cancelButtonVisible ? _react["default"].createElement(_FlatButton["default"], {
          className: "cancel-button",
          value: cancelButtonText,
          iconCls: cancelButtonIconCls,
          theme: cancelButtonTheme,
          disabled: cancelButtonDisabled,
          isLoading: isLoading || cancelButtonIsLoading,
          disableTouchRipple: true,
          onClick: _this2.handleCancelButtonClick
        }) : null));
      });
    }
  }]);
  return Dialog;
}(_react.Component);

(0, _defineProperty2["default"])(Dialog, "ButtonTheme", _Theme["default"]);
(0, _defineProperty2["default"])(Dialog, "Position", _Position["default"]);
Dialog.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The css class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The css class name of the modal.
   */
  modalClassName: _propTypes["default"].string,

  /**
   * The styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,

  /**
   * The dialog alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true,the element will disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,dialog box will display.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the pop-up box will be displayed in the mask layer, or the pop-up box will appear below the element.
   */
  showModal: _propTypes["default"].bool,

  /**
   * Set the title of dialog.
   */
  title: _propTypes["default"].any,

  /**
   * If true,when press down mouse the pop-up box will closed.
   */
  isBlurClose: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,

  /**
   * If true, the OK button will display.
   */
  okButtonVisible: _propTypes["default"].bool,

  /**
   * Set the text value of the OK button.
   */
  okButtonText: _propTypes["default"].string,

  /**
   * Set the icon class of the OK button.
   */
  okButtonIconCls: _propTypes["default"].string,

  /**
   * If true, the OK button will disabled.
   */
  okButtonDisabled: _propTypes["default"].bool,

  /**
   * If true, the ok button will have loading effect.
   */
  okButtonIsLoading: _propTypes["default"].bool,

  /**
   * Set theme of OK button.
   */
  okButtonTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * If true, the cancel button will display.
   */
  cancelButtonVisible: _propTypes["default"].bool,

  /**
   * Set the text value of the cancel button.
   */
  cancelButtonText: _propTypes["default"].string,

  /**
   * Set the icon class of the cancel button.
   */
  cancelButtonIconCls: _propTypes["default"].string,

  /**
   * If true, the cancel button will disabled.
   */
  cancelButtonDisabled: _propTypes["default"].bool,

  /**
   * If true, the cancel button will have loading effect.
   */
  cancelButtonIsLoading: _propTypes["default"].bool,

  /**
   * Set theme of cancel button.
   */
  cancelButtonTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * If true, the close button in title will display.
   */
  closeButtonVisible: _propTypes["default"].bool,
  closeIconCls: _propTypes["default"].string,
  isEscClose: _propTypes["default"].bool,

  /**
   * The buttons of Dialog.
   */
  buttons: _propTypes["default"].any,

  /**
   * The function of dialog render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function that trigger when click submit.
   */
  onRequestClose: _propTypes["default"].func,

  /**
   * Callback function fired when click the ok button.
   */
  onOKButtonClick: _propTypes["default"].func,

  /**
   * Callback function fired when click the cancel button.
   */
  onCancelButtonClick: _propTypes["default"].func,

  /**
   * Callback function fired when click the close button.
   */
  onCloseButtonClick: _propTypes["default"].func,
  onDestroy: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
Dialog.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].CENTER,
  disabled: false,
  visible: false,
  showModal: true,
  isBlurClose: false,
  isLoading: false,
  okButtonVisible: true,
  okButtonText: 'OK',
  okButtonDisabled: false,
  okButtonIsLoading: false,
  okButtonTheme: _Theme["default"].SUCCESS,
  cancelButtonVisible: true,
  cancelButtonText: 'Cancel',
  cancelButtonDisabled: false,
  cancelButtonIsLoading: false,
  cancelButtonTheme: _Theme["default"].DEFAULT,
  closeButtonVisible: true,
  closeIconCls: 'fas fa-times',
  isEscClose: true
};
var _default = Dialog;
exports["default"] = _default;