"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DotStepItem = _interopRequireDefault(require("../_DotStepItem"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var DotStep =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DotStep, _Component);

  function DotStep(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DotStep);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DotStep)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (activatedStep) {
      var onChange = _this.props.onChange;

      _this.setState({
        activatedStep: activatedStep
      }, function () {
        onChange && onChange({
          activatedStep: activatedStep,
          finishedStep: _this.state.finishedStep
        });
      });
    });
    _this.state = {
      activatedStep: props.activatedStep,
      finishedStep: props.finishedStep
    };
    return _this;
  }

  (0, _createClass2["default"])(DotStep, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.activatedStep !== this.state.activatedStep || nextProps.finishedStep !== this.state.finishedStep) {
        this.setState({
          activatedStep: nextProps.activatedStep,
          finishedStep: nextProps.finishedStep
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          steps = _this$props.steps,
          displayField = _this$props.displayField,
          finishedText = _this$props.finishedText,
          _this$state = this.state,
          activatedStep = _this$state.activatedStep,
          finishedStep = _this$state.finishedStep;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('dot-step', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement("span", {
        className: "dot-step-value"
      }, activatedStep < steps.length ? steps[activatedStep][displayField] : finishedText), _react["default"].createElement("div", {
        className: "dot-step-menu"
      }, steps && steps.map(function (item, index) {
        return _react["default"].createElement(_DotStepItem["default"], {
          key: index,
          index: index,
          className: item.className,
          style: _objectSpread({}, item.style, {
            zIndex: steps.length - index
          }),
          activatedStep: activatedStep,
          finishedStep: finishedStep,
          data: item,
          onClick: _this2.handleClick
        });
      })));
    }
  }]);
  return DotStep;
}(_react.Component);

DotStep.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The render content of step.
   */
  steps: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of step element.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the step element.
     */
    style: _propTypes["default"].object,

    /**
     * The text value of step.
     */
    title: _propTypes["default"].string
  })).isRequired,

  /**
   * The text of finished.
   */
  finishedText: _propTypes["default"].any,

  /**
   * Sets the step as active.
   */
  activatedStep: _propTypes["default"].number,

  /**
   * The final step.
   */
  finishedStep: _propTypes["default"].number,

  /**
   * Callback function fired when step change.
   */
  onChange: _propTypes["default"].func
};
DotStep.defaultProps = {
  steps: [],
  activatedStep: 0,
  finishedStep: 0,
  displayField: 'text',
  finishedText: ''
};
var _default = DotStep;
exports["default"] = _default;