"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DraggableGridItem = _interopRequireDefault(require("../_DraggableGridItem"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

/**
 * @file DraggableGrid component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var DraggableGrid =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DraggableGrid, _Component);

  function DraggableGrid(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DraggableGrid);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DraggableGrid)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "listItemMoveHandler", function (dragIndex, hoverIndex, props) {
      var data = _this.state.data,
          dragItem = data.splice(dragIndex, 1);
      data.splice.apply(data, [hoverIndex, 0].concat((0, _toConsumableArray2["default"])(dragItem)));

      _this.setState({
        data: data
      }, function () {
        var onSequenceChange = _this.props.onSequenceChange;
        onSequenceChange && onSequenceChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "listItemSelectHandler", function (item, index) {
      var selectMode = _this.props.selectMode;
      var value = _this.state.value;

      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        if (!value || !(0, _isArray["default"])(value)) {
          value = [];
        }

        value.push(item);
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        value = item;
      }

      _this.setState({
        value: value
      }, function () {
        var _this$props = _this.props,
            onItemSelect = _this$props.onItemSelect,
            onChange = _this$props.onChange;
        onItemSelect && onItemSelect(item, index);
        onChange && onChange(value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "listItemDeselectHandler", function (item, index) {
      var selectMode = _this.props.selectMode;

      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      var _this$props2 = _this.props,
          valueField = _this$props2.valueField,
          displayField = _this$props2.displayField;
      var value = _this.state.value;

      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        value = value.filter(function (valueItem) {
          return _Util["default"].getValueByValueField(valueItem, valueField, displayField) != _Util["default"].getValueByValueField(item, valueField, displayField);
        });
      }

      _this.setState({
        value: value
      }, function () {
        var _this$props3 = _this.props,
            onItemDeselect = _this$props3.onItemDeselect,
            onChange = _this$props3.onChange;
        onItemDeselect && onItemDeselect(item, index);
        onChange && onChange(value, index);
      });
    });
    _this.state = {
      data: props.data,
      value: _Calculation["default"].getInitValue(props)
    };
    return _this;
  }

  (0, _createClass2["default"])(DraggableGrid, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var state;

      if (nextProps.data !== this.state.data) {
        state = state ? state : {};
        state.data = nextProps.data;
      }

      if (nextProps.value !== this.state.value) {
        state = state ? state : {};
        state.value = _Calculation["default"].getInitValue(nextProps);
      }

      if (state) {
        this.setState(state);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          className = _this$props4.className,
          style = _this$props4.style,
          theme = _this$props4.theme,
          itemHeight = _this$props4.itemHeight,
          col = _this$props4.col,
          selectTheme = _this$props4.selectTheme,
          selectMode = _this$props4.selectMode,
          radioUncheckedIconCls = _this$props4.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props4.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props4.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props4.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props4.checkboxIndeterminateIconCls,
          valueField = _this$props4.valueField,
          displayField = _this$props4.displayField,
          descriptionField = _this$props4.descriptionField,
          disabled = _this$props4.disabled,
          isLoading = _this$props4.isLoading,
          renderer = _this$props4.renderer,
          onItemClick = _this$props4.onItemClick,
          _this$state = this.state,
          data = _this$state.data,
          value = _this$state.value;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('draggable-grid', (0, _defineProperty2["default"])({}, className, className)),
        disabled: disabled,
        style: style
      }, data && data.map(function (item, index) {
        return (0, _typeof2["default"])(item) === 'object' ? _react["default"].createElement(_DraggableGridItem["default"], (0, _extends2["default"])({
          key: index
        }, item, {
          index: index,
          style: {
            height: itemHeight
          },
          theme: item.theme || theme,
          col: col,
          selectTheme: item.selectTheme || selectTheme,
          radioUncheckedIconCls: item.radioUncheckedIconCls || radioUncheckedIconCls,
          radioCheckedIconCls: item.radioCheckedIconCls || radioCheckedIconCls,
          checkboxUncheckedIconCls: item.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
          checkboxCheckedIconCls: item.checkboxCheckedIconCls || checkboxCheckedIconCls,
          checkboxIndeterminateIconCls: item.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
          data: item,
          checked: _Calculation["default"].isItemChecked(item, value, _this2.props),
          value: _Util["default"].getValueByValueField(item, valueField, displayField),
          text: _Util["default"].getTextByDisplayField(item, displayField, valueField),
          desc: item[descriptionField] || null,
          disabled: disabled || item.disabled,
          isLoading: isLoading || item.isLoading,
          selectMode: selectMode,
          renderer: renderer,
          onMove: _this2.listItemMoveHandler,
          onClick: function onClick(e) {
            onItemClick && onItemClick(item, index, e);
            item.onClick && item.onClick(e);
          },
          onSelect: function onSelect() {
            return _this2.listItemSelectHandler(item, index);
          },
          onDeselect: function onDeselect() {
            return _this2.listItemDeselectHandler(item, index);
          }
        })) : _react["default"].createElement(_DraggableGridItem["default"], {
          key: index,
          index: index,
          style: {
            height: itemHeight
          },
          theme: item.theme || theme,
          col: col,
          selectTheme: item.selectTheme || selectTheme,
          radioUncheckedIconCls: item.radioUncheckedIconCls || radioUncheckedIconCls,
          radioCheckedIconCls: item.radioCheckedIconCls || radioCheckedIconCls,
          checkboxUncheckedIconCls: item.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
          checkboxCheckedIconCls: item.checkboxCheckedIconCls || checkboxCheckedIconCls,
          checkboxIndeterminateIconCls: item.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
          data: item,
          checked: _Calculation["default"].isItemChecked(item, value, _this2.props),
          value: item,
          text: item,
          disabled: disabled,
          isLoading: isLoading,
          selectMode: selectMode,
          renderer: renderer,
          onMove: _this2.listItemMoveHandler,
          onClick: function onClick(e) {
            return onItemClick && onItemClick(item, index, e);
          },
          onSelect: function onSelect() {
            return _this2.listItemSelectHandler(item, index);
          },
          onDeselect: function onDeselect() {
            return _this2.listItemDeselectHandler(item, index);
          }
        });
      }), children);
    }
  }]);
  return DraggableGrid;
}(_react.Component);

(0, _defineProperty2["default"])(DraggableGrid, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableGrid, "Theme", _Theme["default"]);
DraggableGrid.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The theme of the grid item.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme of the grid item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The mode of listItem.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * Children passed into the GridItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the grid button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the grid button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the grid button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the grid button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The grid item's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the grid button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true,the grid item will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,

    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),

    /**
     * If true,the item will have center displayed ripple effect.
     */
    rippleDisplayCenter: _propTypes["default"].bool,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,

    /**
     * Callback function fired when a grid item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].symbol])),
  value: _propTypes["default"].any,

  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * If true, the grid will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true, the grid will be at loading status.
   */
  isLoading: _propTypes["default"].bool,

  /**
   * The speed of scroll bar.
   */
  scrollSpeed: _propTypes["default"].number,

  /**
   * The number of overflows.
   */
  scrollBuffer: _propTypes["default"].number,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  col: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * Callback function fired when the grid-item touch tap.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when the grid-item select.
   */
  onItemSelect: _propTypes["default"].func,

  /**
   * Callback function fired when the grid-item deselect.
   */
  onItemDeselect: _propTypes["default"].func,

  /**
   * Callback function fired when the grid changed.
   */
  onChange: _propTypes["default"].func,

  /**
   * Callback function fired when select item sequence changed.
   */
  onSequenceChange: _propTypes["default"].func
};
DraggableGrid.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  scrollSpeed: 20,
  scrollBuffer: 40,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  col: 3
};
var _default = DraggableGrid;
exports["default"] = _default;