"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _contains = _interopRequireDefault(require("dom-helpers/contains"));

var _PositionPop = _interopRequireDefault(require("../_PositionPop"));

var _Paper = _interopRequireDefault(require("../Paper"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

var _PopManagement = _interopRequireDefault(require("../_vendors/PopManagement"));

/**
 * @file Drawer component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Drawer =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Drawer, _Component);

  function Drawer(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Drawer);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Drawer)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "drawerVisibleHandler", function (el, drawerEl, currentVisible, isBlurClose) {
      // el is missing
      if (el && !(0, _contains["default"])(document, el)) {
        return currentVisible;
      }

      if (drawerEl && el && (0, _contains["default"])(drawerEl, el)) {
        return currentVisible;
      }

      return isBlurClose ? false : currentVisible;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClose", function (e) {
      var _this$props = _this.props,
          visible = _this$props.visible,
          isBlurClose = _this$props.isBlurClose,
          drawerVisibleHandler = _this$props.drawerVisibleHandler,
          onRequestClose = _this$props.onRequestClose;

      if (!visible) {
        return;
      }

      var drawerEl = _this.drawerContent && _this.drawerContent.current && (0, _reactDom.findDOMNode)(_this.drawerContent.current);
      var currVisible;

      if (drawerVisibleHandler) {
        currVisible = drawerVisibleHandler(e.target, drawerEl, visible, isBlurClose);
      } else if (!_Dom["default"].isParent(e.target)) {
        currVisible = _this.drawerVisibleHandler(e.target, drawerEl, visible, isBlurClose);
      }

      if (currVisible === false) {
        onRequestClose && onRequestClose(e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      _PopManagement["default"].push((0, _assertThisInitialized2["default"])(_this), {
        shouldLockBody: _this.props.showModal
      });

      var onRender = _this.props.onRender;
      onRender && onRender.apply(void 0, arguments);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function () {
      _PopManagement["default"].pop((0, _assertThisInitialized2["default"])(_this));

      var onDestroy = _this.props.onDestroy;
      onDestroy && onDestroy.apply(void 0, arguments);
    });
    _this.drawerContent = (0, _react.createRef)();
    return _this;
  }

  (0, _createClass2["default"])(Drawer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (!prevProps.visible && this.props.visible) {
        _Event["default"].addEvent(document, 'click', this.handleClose);
      } else if (prevProps.visible && !this.props.visible) {
        _Event["default"].removeEvent(document, 'click', this.handleClose);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'click', this.handleClose);

      _PopManagement["default"].pop(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          depth = _this$props2.depth,
          isBlurClose = _this$props2.isBlurClose,
          isEscClose = _this$props2.isEscClose,
          onRender = _this$props2.onRender,
          onRequestClose = _this$props2.onRequestClose,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["className", "depth", "isBlurClose", "isEscClose", "onRender", "onRequestClose"]);
      return _react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('drawer', (0, _defineProperty2["default"])({}, className, className)),
        container: _react["default"].createElement(_Paper["default"], {
          ref: this.drawerContent
        }),
        depth: depth,
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }));
    }
  }]);
  return Drawer;
}(_react.Component);

(0, _defineProperty2["default"])(Drawer, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(Drawer, "Position", _Position["default"]);
Drawer.propTypes = {
  /**
   * The css class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The css class name of the modal.
   */
  modalClassName: _propTypes["default"].string,

  /**
   * The styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,

  /**
   * The drawer alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,

  /**
   * If true,the element will disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,drawer box will display.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the pop-up box will be displayed in the mask layer, or the pop-up box will appear below the element.
   */
  showModal: _propTypes["default"].bool,

  /**
   * If true,when press down mouse the pop-up box will closed.
   */
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,

  /**
   * The function of drawer render.
   */
  onRender: _propTypes["default"].func,
  onDestroy: _propTypes["default"].func,
  drawerVisibleHandler: _propTypes["default"].func,

  /**
   * The function that trigger when click submit.
   */
  onRequestClose: _propTypes["default"].func
};
Drawer.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].LEFT,
  depth: 2,
  disabled: false,
  visible: false,
  showModal: true,
  isBlurClose: true,
  isEscClose: true
};
var _default = Drawer;
exports["default"] = _default;