"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Dropdown = _interopRequireDefault(require("../Dropdown"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _GroupList = _interopRequireDefault(require("../GroupList"));

var _List = _interopRequireDefault(require("../List"));

var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var DropdownSelect =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DropdownSelect, _Component);

  function DropdownSelect(_props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DropdownSelect);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DropdownSelect)).call.apply(_getPrototypeOf2, [this, _props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdownInstance && _this.dropdownInstance.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.dropdownInstance && _this.dropdownInstance.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.closePopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getListHeight", function () {
      var result = _this.props.listHeight;

      if (!result) {
        return result;
      }

      if (_this.actions && _this.actions.current && _this.actions.current.offsetHeight) {
        result -= _this.actions.current.offsetHeight;
      }

      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        var el = _this.dropdown && _this.dropdown.current;
        el && el.resetPopupPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;

      if (!filter) {
        return data;
      }

      var _this$props = _this.props,
          displayField = _this$props.displayField,
          isGrouped = _this$props.isGrouped,
          filterCallback = _this$props.filterCallback,
          filterFunc = function filterFunc(originData) {
        return originData.filter(function (item) {
          return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
        });
      };

      if (filterCallback) {
        return filterCallback(filter, data);
      } // debugger


      if (isGrouped) {
        return data && data.map(function (group) {
          var children = filterFunc(group.children);

          if (children.length < 1) {
            return;
          } else {
            return _objectSpread({}, group, {
              children: children
            });
          }
        }).filter(function (item) {
          return !!item;
        });
      }

      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAllClick", function () {
      var data = _this.props.data,
          value = _this.state.value;

      if (!data) {
        return;
      }

      var isSelectAll = !value || value && value.length < data.length,
          newValue = isSelectAll ? data : [];

      _this.setState({
        value: newValue
      }, function () {
        _this.handleChange(newValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemClick", function () {
      var _this$props2 = _this.props,
          autoClose = _this$props2.autoClose,
          onItemClick = _this$props2.onItemClick;

      if (autoClose) {
        _this.closePopup();
      }

      onItemClick && onItemClick.apply(void 0, arguments);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var autoClose = _this.props.autoClose;

      if (autoClose) {
        _this.closePopup();
      }

      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });

      setTimeout(function () {
        _this.hiddenFilter && _this.hiddenFilter.current && _this.hiddenFilter.current.focus();
      }, 1000);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupOpen", function (e) {
      var _this$props3 = _this.props,
          isHiddenInputFilter = _this$props3.isHiddenInputFilter,
          useFilter = _this$props3.useFilter;

      if (isHiddenInputFilter) {
        _this.hiddenFilter && _this.hiddenFilter.current && _this.hiddenFilter.current.focus();
      } else if (useFilter) {
        _this.filter && _this.filter.current && _this.filter.current.focus();
      }

      _this.setState({
        popupVisible: true
      }, function () {
        var onOpenPopup = _this.props.onOpenPopup;
        onOpenPopup && onOpenPopup(e); // this.updateScrollHeight();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupClose", function (e) {
      _this.hiddenFilter && _this.hiddenFilter.current && _this.hiddenFilter.current.blur();

      _this.setState({
        popupVisible: false
      }, function () {
        var onClosePopup = _this.props.onClosePopup;
        onClosePopup && onClosePopup(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHiddenFilterChange", function (e) {
      var _this$props4 = _this.props,
          data = _this$props4.data,
          displayField = _this$props4.displayField,
          clearHiddenInputFilterInterval = _this$props4.clearHiddenInputFilterInterval;

      if (!data) {
        return;
      }

      var target = e.target,
          timer = setTimeout(function () {
        clearTimeout(timer);
        target.value = '';
      }, clearHiddenInputFilterInterval);
      var index = data.findIndex(function (item) {
        return (0, _typeof2["default"])(item) === 'object' ? item[displayField].toUpperCase().startsWith(target.value.toUpperCase()) : item.toUpperCase().startsWith(target.value.toUpperCase());
      });
      _this.scroller && _this.scroller.current && _this.scrollTo(_this.scroller.current, index * 40, 200);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollTo", function (element, to, duration) {
      if (!element) {
        return;
      } // jump to target if duration zero


      if (duration <= 0) {
        element.scrollTop = to;
        return;
      }

      var difference = to - element.scrollTop,
          perTick = difference / duration * 10;
      setTimeout(function () {
        element.scrollTop = element.scrollTop + perTick;
        if (element.scrollTop === to) return;

        _this.scrollTo(element, to, duration - 10);
      }, 10);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTriggerValue", function () {
      var _this$props5 = _this.props,
          placeholder = _this$props5.placeholder,
          triggerRenderer = _this$props5.triggerRenderer,
          renderer = _this$props5.renderer,
          valueField = _this$props5.valueField,
          displayField = _this$props5.displayField,
          selectMode = _this$props5.selectMode,
          value = _this.state.value,
          isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT;

      if (triggerRenderer) {
        return typeof triggerRenderer === 'function' ? triggerRenderer(value) : triggerRenderer;
      }

      if (!value) {
        return placeholder;
      }

      return isMultiSelect ? value.length > 0 ? value.length + ' selected' : placeholder : renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField);
    });
    _this.hiddenFilter = (0, _react.createRef)();
    _this.dropdown = (0, _react.createRef)();
    _this.dropdownInstance = null;
    _this.actions = (0, _react.createRef)();
    _this.filter = (0, _react.createRef)();
    _this.scroller = (0, _react.createRef)();
    _this.state = {
      value: _props.value,
      filter: '',
      popupVisible: false,
      scrollerHeight: 'auto'
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(DropdownSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownInstance = this.dropdown && this.dropdown.current;
    }
  }, {
    key: "render",

    /* eslint-disable complexity */
    value: function render() {
      var _this$props6 = this.props,
          className = _this$props6.className,
          triggerClassName = _this$props6.triggerClassName,
          popupClassName = _this$props6.popupClassName,
          style = _this$props6.style,
          name = _this$props6.name,
          popupTheme = _this$props6.popupTheme,
          data = _this$props6.data,
          triggerRenderer = _this$props6.triggerRenderer,
          useDynamicRenderList = _this$props6.useDynamicRenderList,
          listHeight = _this$props6.listHeight,
          itemHeight = _this$props6.itemHeight,
          scrollBuffer = _this$props6.scrollBuffer,
          renderer = _this$props6.renderer,
          listItemRenderer = _this$props6.listItemRenderer,
          selectMode = _this$props6.selectMode,
          itemDisabled = _this$props6.itemDisabled,
          useFilter = _this$props6.useFilter,
          filterIconCls = _this$props6.filterIconCls,
          useSelectAll = _this$props6.useSelectAll,
          selectAllText = _this$props6.selectAllText,
          valueField = _this$props6.valueField,
          displayField = _this$props6.displayField,
          descriptionField = _this$props6.descriptionField,
          popupChildren = _this$props6.popupChildren,
          isHiddenInputFilter = _this$props6.isHiddenInputFilter,
          noMatchedMsg = _this$props6.noMatchedMsg,
          isGrouped = _this$props6.isGrouped,
          radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props6.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
          v = _this$props6.value,
          clearHiddenInputFilterInterval = _this$props6.clearHiddenInputFilterInterval,
          onOpenPopup = _this$props6.onOpenPopup,
          onClosePopup = _this$props6.onClosePopup,
          onItemClick = _this$props6.onItemClick,
          onChange = _this$props6.onChange,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props6, ["className", "triggerClassName", "popupClassName", "style", "name", "popupTheme", "data", "triggerRenderer", "useDynamicRenderList", "listHeight", "itemHeight", "scrollBuffer", "renderer", "listItemRenderer", "selectMode", "itemDisabled", "useFilter", "filterIconCls", "useSelectAll", "selectAllText", "valueField", "displayField", "descriptionField", "popupChildren", "isHiddenInputFilter", "noMatchedMsg", "isGrouped", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "value", "clearHiddenInputFilterInterval", "onOpenPopup", "onClosePopup", "onItemClick", "onChange"]),
          _this$state = this.state,
          value = _this$state.value,
          filter = _this$state.filter,
          popupVisible = _this$state.popupVisible,
          scrollerHeight = _this$state.scrollerHeight,
          isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT,
          listData = this.filterData();
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('dropdown-select', (0, _defineProperty2["default"])({
          activated: popupVisible
        }, className, className)),
        style: style
      }, name ? _react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, isHiddenInputFilter ? _react["default"].createElement("input", {
        ref: this.hiddenFilter,
        className: "hiddenFilter",
        type: "text",
        onChange: this.handleHiddenFilterChange
      }) : null, _react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        triggerClassName: (0, _classnames["default"])((0, _defineProperty2["default"])({
          empty: !triggerRenderer && !value
        }, triggerClassName, triggerClassName)),
        popupClassName: 'dropdown-select-popup' + (popupClassName ? ' ' + popupClassName : ''),
        popupTheme: popupTheme,
        triggerValue: this.getTriggerValue(),
        onOpenPopup: this.handlePopupOpen,
        onClosePopup: this.handlePopupClose
      }), useFilter || isMultiSelect && useSelectAll ? _react["default"].createElement("div", {
        ref: this.actions,
        className: "dropdown-select-popup-actions"
      }, useFilter ? _react["default"].createElement(_TextField["default"], {
        ref: this.filter,
        className: "dropdown-select-filter",
        value: filter,
        rightIconCls: filterIconCls,
        onChange: this.handleFilterChange
      }) : null, isMultiSelect && useSelectAll ? _react["default"].createElement("div", {
        className: "list-item dropdown-select-all-wrapper",
        onClick: this.handleSelectAllClick
      }, _react["default"].createElement(_Checkbox["default"], {
        className: "list-item-select",
        checked: data && value && value.length === data.length,
        indeterminate: data && value && value.length > 0 && value.length < data.length,
        uncheckedIconCls: checkboxUncheckedIconCls,
        checkedIconCls: checkboxCheckedIconCls,
        indeterminateIconCls: checkboxIndeterminateIconCls
      }), selectAllText) : null) : null, _react["default"].createElement("div", {
        ref: this.scroller,
        className: "dropdown-select-list-scroller",
        style: {
          height: scrollerHeight
        }
      }, !listData || listData.length < 1 ? _react["default"].createElement("div", {
        className: "no-matched"
      }, noMatchedMsg ? noMatchedMsg : _react["default"].createElement("span", null, _react["default"].createElement("i", {
        className: "fas fa-exclamation-triangle no-matched-icon"
      }), "No matched value.")) : isGrouped ? _react["default"].createElement(_GroupList["default"], {
        className: "group-select-list",
        value: value,
        selectMode: selectMode,
        data: listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        itemHeight: itemHeight,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      }) : useDynamicRenderList ? _react["default"].createElement(_DynamicRenderList["default"], {
        className: "dropdown-select-list",
        theme: popupTheme,
        selectMode: selectMode,
        data: listData,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        listHeight: this.getListHeight(),
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      }) : _react["default"].createElement(_List["default"], {
        className: "dropdown-select-list",
        theme: popupTheme,
        selectMode: selectMode,
        data: listData,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      })), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return DropdownSelect;
}(_react.Component);

(0, _defineProperty2["default"])(DropdownSelect, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "Position", _Position["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "TipPosition", _Position["default"]);
DropdownSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,

  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,

  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * The name of the dropDownSelect.
   */
  name: _propTypes["default"].string,

  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,

  /**
   * The placeholder of the dropDownSelect.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerRenderer: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
  rightIconCls: _propTypes["default"].string,

  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([// not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    title: _propTypes["default"].string,

    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,

    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])), // grouped
  _propTypes["default"].array]),

  /**
   * The invalid message of dropDownSelect.
   */
  invalidMsg: _propTypes["default"].string,

  /**
   * If true,the dropDownSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the dropDownSelect will be loading.
   */
  isLoading: _propTypes["default"].bool,

  /**
   * List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

  /**
   * The select mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * The message of the dropDownSelect.
   */
  infoMsg: _propTypes["default"].string,

  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,

  /**
   * If true, the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,

  /**
   * If true, the drop-down box automatically closed when blur.
   */
  isBlurClose: _propTypes["default"].bool,

  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,

  /**
   * If true,the dropDownSelect will be grouped.
   */
  isGrouped: _propTypes["default"].bool,
  filterIconCls: _propTypes["default"].string,
  useSelectAll: _propTypes["default"].bool,
  selectAllText: _propTypes["default"].string,
  isHiddenInputFilter: _propTypes["default"].bool,
  clearHiddenInputFilterInterval: _propTypes["default"].number,

  /**
   * The message of no matching option.
   */
  noMatchedMsg: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  useDynamicRenderList: _propTypes["default"].bool,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  resetPopPositionWait: _propTypes["default"].number,
  autoPopupWidth: _propTypes["default"].bool,
  renderer: _propTypes["default"].func,
  listItemRenderer: _propTypes["default"].func,
  filterCallback: _propTypes["default"].func,

  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when the popup is open.
   */
  onOpenPopup: _propTypes["default"].func,

  /**
   * Callback function fired when the popup is close.
   */
  onClosePopup: _propTypes["default"].func,

  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
DropdownSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  data: [],
  disabled: false,
  isLoading: false,
  itemDisabled: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  tipPosition: _Position["default"].BOTTOM,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true,
  isBlurClose: true,
  useFilter: false,
  filterIconCls: 'fas fa-search',
  useSelectAll: false,
  selectAllText: 'Select All',
  useDynamicRenderList: false,
  isHiddenInputFilter: false,
  clearHiddenInputFilterInterval: 1000,
  isGrouped: false,
  resetPopPositionWait: 250,
  autoPopupWidth: true,
  listHeight: 200,
  itemHeight: 40,
  scrollBuffer: 6
};
var _default = DropdownSelect;
exports["default"] = _default;