"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _trim = _interopRequireDefault(require("lodash/trim"));

var _TextField = _interopRequireDefault(require("../TextField/TextField"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

/**
 * @file EditableField component
 * @author chao(chao.zhang@derbysoft.com)
 */
var EditableField =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(EditableField, _Component);

  function EditableField(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, EditableField);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(EditableField)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerElement", function (el, targetEl) {
      while (el) {
        if (el == targetEl) {
          return true;
        }

        el = el.parentNode;
      }

      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (text) {
      _this.setState({
        changeText: text
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showInput", function (e) {
      _this.setState({
        hide: false
      }, function () {
        _this.textField && _this.textField.current && _this.textField.current.focus();
        _this.props.onEditStart && _this.props.onEditStart(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDown", function (ev) {
      var oEvent = ev || event;

      if (_this.state.hide === false && !_this.triggerElement(oEvent.target, _this.editableFieldEl)) {
        _this.finishEdit(ev);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "finishEdit", function (ev) {
      var change = _this.state.text !== _this.state.changeText;

      if (change && _this.props.beforeChange && _this.props.beforeChange(_this.state.changeText) === false) {
        ev.preventDefault();
        return;
      }

      _this.setState({
        hide: true,
        text: (0, _trim["default"])(_this.state.changeText),
        changeText: (0, _trim["default"])(_this.state.changeText)
      }, function () {
        _this.props.onEditEnd && _this.props.onEditEnd(ev);
        change && _this.props.onChange && _this.props.onChange(_this.state.text);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyDown", function (ev) {
      var regExp = _this.props.regExp;

      if (regExp && !regExp.test(ev.key)) {
        event.preventDefault();
        return false;
      }

      if (ev.keyCode === 13) {
        _this.finishEdit(ev);
      }

      return true;
    });
    _this.editableField = (0, _react.createRef)();
    _this.editableFieldEl = null;
    _this.editableFieldText = (0, _react.createRef)();
    _this.editableFieldTextEl = null;
    _this.textField = (0, _react.createRef)();
    _this.state = {
      hide: true,
      text: props.value,
      changeText: props.value,
      inputAutoWidth: 0
    };
    return _this;
  }

  (0, _createClass2["default"])(EditableField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.editableFieldEl = this.editableField && this.editableField.current;
      this.editableFieldTextEl = this.editableFieldText && this.editableFieldText.current;

      _Event["default"].addEvent(document, 'mousedown', this.handleDown);

      _Event["default"].addEvent(document, 'keydown', this.handleKeyDown);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.value !== this.state.text) {
        this.setState({
          text: nextProps.value,
          changeText: nextProps.value
        });
      }

      if (nextProps.disabled === true && nextProps.disabled !== this.props.disabled) {
        this.setState({
          hide: true,
          changeText: this.state.text
        }, function () {
          _this2.props.onEditEnd && _this2.props.onEditEnd();
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var inputAutoWidth = this.state.inputAutoWidth;
      var newAutoWidth = this.editableFieldTextEl && this.editableFieldTextEl.offsetWidth;

      if (inputAutoWidth !== newAutoWidth) {
        this.setState({
          inputAutoWidth: newAutoWidth
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousedown', this.handleDown);

      _Event["default"].removeEvent(document, 'keydown', this.handleKeyDown);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          name = _this$props.name,
          disabled = _this$props.disabled,
          tip = _this$props.tip,
          tipPosition = _this$props.tipPosition,
          title = _this$props.title,
          onMouseDown = _this$props.onMouseDown,
          onClick = _this$props.onClick,
          showModal = _this$props.showModal,
          maxLength = _this$props.maxLength,
          autoWidth = _this$props.autoWidth,
          parentEl = _this$props.parentEl,
          _this$state = this.state,
          changeText = _this$state.changeText,
          text = _this$state.text,
          hide = _this$state.hide,
          inputAutoWidth = _this$state.inputAutoWidth;
      var inputStyle = autoWidth && typeof inputAutoWidth === 'number' ? {
        width: parseInt(inputAutoWidth) + 42
      } : {};
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, _react["default"].createElement("div", {
        ref: this.editableField,
        className: (0, _classnames["default"])('editable-field', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        title: "".concat(disabled ? '' : title),
        onMouseDown: onMouseDown,
        onClick: onClick
      }, _react["default"].createElement("span", {
        className: "editable-field-hidden-text",
        ref: this.editableFieldText,
        disabled: disabled
      }, changeText), _react["default"].createElement("span", {
        className: "editable-field-text",
        disabled: disabled
      }, text), hide === true ? _react["default"].createElement("span", {
        className: "editable-field-span",
        onClick: this.showInput
      }, text, _react["default"].createElement("i", {
        className: "fas fa-pencil-alt editable-field-icon",
        "aria-hidden": "true"
      })) : _react["default"].createElement(_TextField["default"], {
        ref: this.textField,
        style: inputStyle,
        className: 'editable-field-input',
        maxLength: maxLength,
        value: changeText,
        onChange: this.handleInputChange
      }), _react["default"].createElement("input", {
        type: "hidden",
        value: text,
        readOnly: true,
        name: name
      }), showModal && !hide ? _react["default"].createElement("div", {
        className: "editable-modal",
        onClick: this.finishEdit
      }) : null, children));
    }
  }]);
  return EditableField;
}(_react.Component);

EditableField.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The value of the editableField.
   */
  value: _propTypes["default"].string,

  /**
   * The name of the editableField.
   */
  name: _propTypes["default"].string,

  /**
   * The title of the editableField.
   */
  title: _propTypes["default"].string,

  /**
   * The maximum length of editableField to enter.
   */
  maxLength: _propTypes["default"].number,

  /**
   * The tip of the editableField.
   */
  tip: _propTypes["default"].string,

  /**
   * The tipPosition of the editableField.
   */
  tipPosition: _propTypes["default"].string,

  /**
   * The regular expression of the input.
   */
  regExp: _propTypes["default"].object,

  /**
   * If true, the input is disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true, the shadow is under the input.
   */
  showModal: _propTypes["default"].bool,

  /**
   * If true, the input will be auto width.
   */
  autoWidth: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  onMouseDown: _propTypes["default"].func,

  /**
   * Callback function when touch the editableField.
   */
  onClick: _propTypes["default"].func,

  /**
   * Callback function fired when the editableField blur.
   */
  onBlur: _propTypes["default"].func,

  /**
   * Callback function fired when the editableField change.
   */
  onChange: _propTypes["default"].func,

  /**
   * Callback function fired when start editableField change.
   */
  onEditStart: _propTypes["default"].func,

  /**
   * Callback function fired when end editableField change.
   */
  onEditEnd: _propTypes["default"].func,

  /**
   * Callback function fired when before editableField change.
   */
  beforeChange: _propTypes["default"].func
};
EditableField.defaultProps = {
  title: '',
  value: 'text',
  name: '',
  disabled: false,
  showModal: false,
  autoWidth: false
};
var _default = EditableField;
exports["default"] = _default;