"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _Popup = _interopRequireDefault(require("../Popup"));

var _List = _interopRequireDefault(require("../List"));

var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));

var _GroupList = _interopRequireDefault(require("../GroupList"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file EditableSelect component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var EditableSelect =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(EditableSelect, _Component);

  function EditableSelect(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, EditableSelect);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(EditableSelect)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChangeValue", function (value) {
      var useFilter = _this.props.useFilter;

      if (useFilter) {
        _this.setState({
          value: value,
          filter: value,
          listValue: ''
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(value);
        });
      } else {
        _this.setState({
          value: value,
          listValue: ''
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(value);
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "showPopup", function () {
      _this.setState({
        popupVisible: true
      }, function () {
        _this.props.onTriggerClick && _this.props.onTriggerClick(_this.state.popupVisible);
        _this.props.onFocus && _this.props.onFocus();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      }, function () {
        _this.props.onTriggerClick && _this.props.onTriggerClick(_this.state.popupVisible);
        _this.props.onPopupClosed && _this.props.onPopupClosed();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerHandler", function (el, triggerEl, popupEl, currentVisible, isBlurClose) {
      if (!triggerEl) {
        return true;
      }

      while (el) {
        if (el == popupEl) {
          return currentVisible;
        } else if (el == triggerEl) {
          return true;
        }

        el = el.parentNode;
      }

      return isBlurClose ? false : currentVisible;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;

      if (!filter) {
        return data;
      }

      var _this$props = _this.props,
          displayField = _this$props.displayField,
          isGrouped = _this$props.isGrouped,
          filterFunc = function filterFunc(originData) {
        return originData.filter(function (item) {
          return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
        });
      };

      if (isGrouped) {
        var result = Object.assign(data);

        for (var i = 0, len = result.length; i < len; i++) {
          var group = result[i];
          group.children = filterFunc(group.children);

          if (group.children.length < 1) {
            result.splice(i, 1);
            i--;
          }
        }
      }

      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.wrapperEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));

      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var _this$props2 = _this.props,
          valueField = _this$props2.valueField,
          renderer = _this$props2.renderer;
      var itemValue = renderer ? renderer(value) : (0, _typeof2["default"])(value) == 'object' ? value[valueField] : value;
      var autoClose = _this.props.autoClose,
          state = {
        value: itemValue,
        listValue: value
      };

      if (autoClose) {
        state.popupVisible = false;
      }

      _this.setState(state, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(itemValue);
      });
    });
    _this.wrapper = (0, _react.createRef)();
    _this.wrapperEl = null;
    _this.trigger = (0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      value: props.value,
      listValue: props.value,
      filter: '',
      popupVisible: false,
      isAbove: false
    };
    return _this;
  }

  (0, _createClass2["default"])(EditableSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          className = _this$props3.className,
          popupClassName = _this$props3.popupClassName,
          style = _this$props3.style,
          popupStyle = _this$props3.popupStyle,
          name = _this$props3.name,
          placeholder = _this$props3.placeholder,
          disabled = _this$props3.disabled,
          valueField = _this$props3.valueField,
          descriptionField = _this$props3.descriptionField,
          position = _this$props3.position,
          rightIconCls = _this$props3.rightIconCls,
          resetPopPositionWait = _this$props3.resetPopPositionWait,
          triggerTheme = _this$props3.triggerTheme,
          isGrouped = _this$props3.isGrouped,
          onItemClick = _this$props3.onItemClick,
          renderer = _this$props3.renderer,
          noMatchedMsg = _this$props3.noMatchedMsg,
          useDynamicRenderList = _this$props3.useDynamicRenderList,
          onMouseOver = _this$props3.onMouseOver,
          onMouseOut = _this$props3.onMouseOut,
          parentEl = _this$props3.parentEl,
          _this$state = this.state,
          value = _this$state.value,
          listValue = _this$state.listValue,
          popupVisible = _this$state.popupVisible,
          isAbove = _this$state.isAbove,
          isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove,
          listData = this.filterData();
      return _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('editable-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? _react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: value
      }) : null, _react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: (0, _classnames["default"])('editable-select-trigger', isAboveFinally ? 'above' : 'blow', {
          activated: popupVisible,
          empty: !value
        }),
        value: value,
        rightIconCls: "".concat(rightIconCls, " editable-select-trigger-icon"),
        placeholder: placeholder,
        disabled: disabled,
        theme: triggerTheme,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        onChange: this.handleChangeValue,
        onFocus: this.showPopup
      }), _react["default"].createElement(_Popup["default"], {
        className: (0, _classnames["default"])('editable-select-popup', isAboveFinally ? 'above' : 'blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        visible: popupVisible,
        triggerEl: this.triggerEl,
        triggerHandler: this.triggerHandler,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, listData.length < 1 ? _react["default"].createElement("div", {
        className: "no-matched"
      }, noMatchedMsg ? noMatchedMsg : _react["default"].createElement("span", null, _react["default"].createElement("i", {
        className: "fas fa-exclamation-triangle no-matched-icon"
      }), "No matched value.")) : isGrouped ? _react["default"].createElement(_GroupList["default"], {
        className: "editable-select-list",
        data: listData,
        value: listValue,
        valueField: valueField,
        displayField: valueField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: this.onItemClick,
        onChange: this.changeHandler
      }) : useDynamicRenderList ? _react["default"].createElement(_DynamicRenderList["default"], {
        className: "editable-select-list",
        data: listData,
        value: listValue,
        valueField: valueField,
        displayField: valueField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }) : _react["default"].createElement(_List["default"], {
        className: "editable-select-list",
        data: listData,
        valueField: valueField,
        value: listValue,
        displayField: valueField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: onItemClick,
        onChange: this.handleChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return EditableSelect;
}(_react.Component);

(0, _defineProperty2["default"])(EditableSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(EditableSelect, "Position", _Position["default"]);
EditableSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  rightIconCls: _propTypes["default"].string,

  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * The name of the editableSelect.
   */
  name: _propTypes["default"].string,

  /**
   * The value of the editableSelect.
   */
  value: _propTypes["default"].any,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * The placeholder of the editableSelect.
   */
  placeholder: _propTypes["default"].string,

  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([// not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,

    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])), // grouped
  _propTypes["default"].array]).isRequired,

  /**
   * The invalid message of editableSelect.
   */
  invalidMsg: _propTypes["default"].string,

  /**
   * If true,the editableSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * The message of the editableSelect.
   */
  infoMsg: _propTypes["default"].string,

  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,

  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,

  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,

  /**
   * The theme of editableSelect.Can be primary,highlight,success,warning,error.
   */
  triggerTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * If true,the drop-down box will be have group selection.
   */
  isGrouped: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  noMatchedMsg: _propTypes["default"].string,
  useDynamicRenderList: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,

  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onTriggerClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onPopupClosed: _propTypes["default"].func
};
EditableSelect.defaultProps = {
  name: '',
  value: '',
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  data: [],
  invalidMsg: '',
  disabled: false,
  displayField: 'text',
  descriptionField: 'desc',
  infoMsg: '',
  autoClose: true,
  useFilter: false,
  useDynamicRenderList: false,
  triggerTheme: _Theme["default"].DEFAULT,
  isGrouped: false,
  resetPopPositionWait: 250
};
var _default = EditableSelect;
exports["default"] = _default;