"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Grid = _interopRequireDefault(require("../Grid"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

/**
 * @file GroupGrid component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var GroupGrid =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(GroupGrid, _Component);

  function GroupGrid(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, GroupGrid);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(GroupGrid)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    _this.state = {
      value: _Calculation["default"].getInitValue(props)
    };
    return _this;
  }

  (0, _createClass2["default"])(GroupGrid, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.state.value) {
        this.setState({
          value: _Calculation["default"].getInitValue(nextProps)
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          data = _this$props.data,
          disabled = _this$props.disabled,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["children", "className", "style", "data", "disabled"]),
          value = this.state.value;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('group-grid', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, data && data.map(function (item, index) {
        return _react["default"].createElement("div", {
          key: index
        }, _react["default"].createElement("div", {
          className: "group-grid-group-title"
        }, item.name), _react["default"].createElement(_Grid["default"], (0, _extends2["default"])({}, restProps, {
          data: item.children,
          value: value
        })));
      }), children);
    }
  }]);
  return GroupGrid;
}(_react.Component);

(0, _defineProperty2["default"])(GroupGrid, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(GroupGrid, "Theme", _Theme["default"]);
GroupGrid.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme of the list item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * Children passed into the ListItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    // group name
    name: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    children: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
      /**
       * The CSS class name of the list button.
       */
      className: _propTypes["default"].string,

      /**
       * Override the styles of the list button.
       */
      style: _propTypes["default"].object,

      /**
       * The theme of the list button.
       */
      theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

      /**
       * The text value of the list button.Type can be string or number.
       */
      value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

      /**
       * The list item's display text. Type can be string, number or bool.
       */
      text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

      /**
       * The desc value of the list button. Type can be string or number.
       */
      desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

      /**
       * If true,the list item will be disabled.
       */
      disabled: _propTypes["default"].bool,

      /**
       * If true,the button will be have loading effect.
       */
      isLoading: _propTypes["default"].bool,

      /**
       * If true,the element's ripple effect will be disabled.
       */
      disableTouchRipple: _propTypes["default"].bool,

      /**
       * Use this property to display an icon. It will display on the left.
       */
      iconCls: _propTypes["default"].string,

      /**
       * Use this property to display an icon. It will display on the right.
       */
      rightIconCls: _propTypes["default"].string,

      /**
       * The message of tip.
       */
      tip: _propTypes["default"].string,

      /**
       * The position of tip.
       */
      tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),

      /**
       * If true,the item will have center displayed ripple effect.
       */
      rippleDisplayCenter: _propTypes["default"].bool,

      /**
       * You can create a complicated renderer callback instead of value and desc prop.
       */
      itemRenderer: _propTypes["default"].func,

      /**
       * Callback function fired when a list item touch-tapped.
       */
      onClick: _propTypes["default"].func
    }), _propTypes["default"].string, _propTypes["default"].number]))
  }), _propTypes["default"].symbol])).isRequired,

  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * If true, the list will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true, the list will be at loading status.
   */
  isLoading: _propTypes["default"].bool,

  /**
   * The mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * Callback function fired when the list-item select.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when the list changed.
   */
  onChange: _propTypes["default"].func
};
GroupGrid.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  data: [],
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  radioUncheckedIconCls: 'fas fa-check',
  radioCheckedIconCls: 'fas fa-check',
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = GroupGrid;
exports["default"] = _default;