"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _LazyLoadStatus = _interopRequireDefault(require("../_statics/LazyLoadStatus"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var LazyImage =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(LazyImage, _Component);

  function LazyImage(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, LazyImage);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(LazyImage)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", (0, _debounce["default"])(function () {
      if (_this.state.status > _LazyLoadStatus["default"].PENDING || !_this.wrapperEl || _this.wrapperEl.getBoundingClientRect().top > window.innerHeight) {
        return;
      }

      var onImageLoadStart = _this.props.onImageLoadStart;
      var result;

      if (onImageLoadStart) {
        result = onImageLoadStart();
      }

      if (result === false) {
        return;
      }

      _this.setState({
        status: _LazyLoadStatus["default"].LOADING
      }, function () {
        var image = new Image();

        _Event["default"].addEvent(image, 'load', function (e) {
          _this.setState({
            status: _LazyLoadStatus["default"].FINISH
          }, function () {
            var onImageLoaded = _this.props.onImageLoaded;
            onImageLoaded && onImageLoaded(e);
          });
        });

        image.src = _this.props.src;
      });
    }, 250));
    _this.wrapper = (0, _react.createRef)();
    _this.state = {
      status: _LazyLoadStatus["default"].PENDING
    };
    return _this;
  }

  (0, _createClass2["default"])(LazyImage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;

      _Event["default"].addEvent(this.props.scrollEl, 'scroll', this.handleScroll);

      this.handleScroll();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(this.props.scrollEl, 'scroll', this.handleScroll);

      if (this.handleScroll) {
        this.handleScroll.cancel();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          src = _this$props.src,
          alt = _this$props.alt,
          loadingWidth = _this$props.loadingWidth,
          loadingHeight = _this$props.loadingHeight,
          width = _this$props.width,
          height = _this$props.height,
          placeholder = _this$props.placeholder,
          status = this.state.status,
          isFinish = status === _LazyLoadStatus["default"].FINISH;
      return _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('lazy-image', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread({}, style, {
          width: isFinish ? width : loadingWidth,
          height: isFinish ? height : loadingHeight
        })
      }, _react["default"].createElement("img", {
        className: "lazy-image-img",
        src: isFinish ? src : '',
        alt: alt,
        width: width,
        height: height
      }), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('lazy-image-placeholder', {
          hidden: isFinish
        })
      }, placeholder ? placeholder : _react["default"].createElement(_CircularLoading["default"], {
        className: "lazy-image-loading"
      })));
    }
  }]);
  return LazyImage;
}(_react.Component);

(0, _defineProperty2["default"])(LazyImage, "Status", _LazyLoadStatus["default"]);
LazyImage.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Image src url.
   */
  src: _propTypes["default"].string.isRequired,

  /**
   * Image alt text.
   */
  alt: _propTypes["default"].string,

  /**
   * Loading width.
   */
  loadingWidth: _propTypes["default"].number,

  /**
   * Loading height.
   */
  loadingHeight: _propTypes["default"].number,

  /**
   * Image width.
   */
  width: _propTypes["default"].number,

  /**
   * Image height.
   */
  height: _propTypes["default"].number,

  /**
   * Image placeholder.
   */
  placeholder: _propTypes["default"].any,
  scrollEl: _propTypes["default"].object,

  /**
   * Image load start callback.
   */
  onImageLoadStart: _propTypes["default"].func,

  /**
   * Image load end callback.
   */
  onImageLoaded: _propTypes["default"].func
};
LazyImage.defaultProps = {
  alt: '',
  placeholder: '',
  scrollEl: document,
  loadingWidth: 100,
  loadingHeight: 100
};
var _default = LazyImage;
exports["default"] = _default;