"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Percent = _interopRequireDefault(require("../_Percent"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file LinearProgress component
 * @author chao(chao.zhang@derbysoft.com)
 */
var LinearProgress =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(LinearProgress, _Component);

  function LinearProgress(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, LinearProgress);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(LinearProgress)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getProgressWidth", function () {
      return _this.wrapperEl ? parseInt(_this.wrapperEl.offsetWidth) / 2 : 0;
    });
    _this.wrapper = (0, _react.createRef)();
    _this.wrapperEl = null;
    return _this;
  }

  (0, _createClass2["default"])(LinearProgress, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          className = _this$props.className,
          highlightWidth = _this$props.highlightWidth,
          style = _this$props.style,
          word = _this$props.word,
          wordStyle = _this$props.wordStyle,
          theme = _this$props.theme,
          animation = _this$props.animation,
          status = _this$props.status,
          showIcon = _this$props.showIcon,
          successIcon = _this$props.successIcon,
          failureIcon = _this$props.failureIcon;
      return _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('linear-progress', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, wordStyle, wordStyle), (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), (0, _defineProperty2["default"])(_classNames, status, status), _classNames)),
        style: style
      }, word && wordStyle === LinearProgress.WordStyle.FOLLOW ? _react["default"].createElement(_Percent["default"], {
        endNum: parseInt(highlightWidth),
        status: status,
        showIcon: showIcon,
        successIcon: successIcon,
        failureIcon: failureIcon,
        move: true
      }) : null, word && wordStyle === LinearProgress.WordStyle.FRONT ? _react["default"].createElement(_Percent["default"], {
        endNum: parseInt(highlightWidth),
        status: status,
        showIcon: showIcon,
        successIcon: successIcon,
        failureIcon: failureIcon
      }) : null, _react["default"].createElement("div", {
        className: "linear-progress-background"
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('linear-progress-highlight', {
          'linear-progress-animate': animation
        }),
        style: {
          width: highlightWidth
        }
      }, wordStyle === LinearProgress.WordStyle.MIDDLE ? _react["default"].createElement(_Percent["default"], {
        className: "linear-progress-word",
        style: {
          marginLeft: this.getProgressWidth()
        },
        status: status,
        showIcon: showIcon,
        successIcon: successIcon,
        failureIcon: failureIcon,
        endNum: parseInt(highlightWidth)
      }) : null)), word && wordStyle === LinearProgress.WordStyle.END ? _react["default"].createElement(_Percent["default"], {
        endNum: parseInt(highlightWidth),
        status: status,
        showIcon: showIcon,
        successIcon: successIcon,
        failureIcon: failureIcon
      }) : null);
    }
  }]);
  return LinearProgress;
}(_react.Component);

(0, _defineProperty2["default"])(LinearProgress, "WordStyle", {
  FRONT: 'linear-progress-one',
  MIDDLE: 'linear-progress-two',
  FOLLOW: 'linear-progress-three',
  END: 'linear-progress-four'
});
(0, _defineProperty2["default"])(LinearProgress, "Theme", _Theme["default"]);
LinearProgress.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The progress theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The highlight width of linearProgress.
   */
  highlightWidth: _propTypes["default"].string,

  /**
   * If true,there will have a text description.
   */
  word: _propTypes["default"].bool,

  /**
   * The percent text location.Desirable values include front,middle,follow.
   */
  wordStyle: _propTypes["default"].oneOf(Object.keys(LinearProgress.WordStyle).map(function (key) {
    return LinearProgress.WordStyle[key];
  })),

  /**
   * If true, the linearProgress will have animation.
   */
  animation: _propTypes["default"].bool
};
LinearProgress.defaultProps = {
  style: {
    width: '200px',
    height: '2px'
  },
  highlightWidth: '50%',
  word: false,
  wordStyle: LinearProgress.WordStyle.FRONT,
  animation: false
};
var _default = LinearProgress;
exports["default"] = _default;