"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ListItem = _interopRequireDefault(require("../_ListItem"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _ListSeparator = _interopRequireDefault(require("../_statics/ListSeparator"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file List component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var List =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(List, _Component);

  function List(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, List);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(List)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "adjustScroll", function () {
      var data = _this.props.data,
          value = _this.state.value,
          index = data.indexOf(value);

      if (index < 0) {
        return;
      }

      var listHeight = _this.listEl.clientHeight,
          listScrollTop = _this.listEl.scrollTop,
          itemEl = _this.listEl.childNodes[index],
          itemHeight = itemEl.clientHeight,
          itemTop = itemEl.offsetTop;

      if (itemTop < listScrollTop) {
        _this.listEl.scrollTop = itemTop;
      } else if (itemTop + itemHeight > listScrollTop + listHeight) {
        _this.listEl.scrollTop = itemTop + itemHeight - listHeight;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemSelect", function (item, index) {
      var selectMode = _this.props.selectMode,
          value = _this.state.value,
          state = {};

      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value ? value.slice() : value;

        if (!result || !(0, _isArray["default"])(result)) {
          result = [];
        }

        result.push(item);
        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        state.value = item;
      }

      _this.setState(state, function () {
        var _this$props = _this.props,
            onItemSelect = _this$props.onItemSelect,
            onChange = _this$props.onChange;
        onItemSelect && onItemSelect(item, index);
        onChange && onChange(state.value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemDeselect", function (item, index) {
      var selectMode = _this.props.selectMode;

      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      var _this$props2 = _this.props,
          valueField = _this$props2.valueField,
          displayField = _this$props2.displayField,
          stateValue = _this.state.value;
      var value = stateValue ? stateValue.slice() : stateValue;

      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        value = value.filter(function (valueItem) {
          return _Util["default"].getValueByValueField(valueItem, valueField, displayField) != _Util["default"].getValueByValueField(item, valueField, displayField);
        });
      }

      _this.setState({
        value: value
      }, function () {
        var _this$props3 = _this.props,
            onItemDeselect = _this$props3.onItemDeselect,
            onChange = _this$props3.onChange;
        onItemDeselect && onItemDeselect(item, index);
        onChange && onChange(value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isListDisabled", function (listDisabled) {
      var data = _this.props.data,
          value = _this.state.value;
      return typeof listDisabled === 'function' ? listDisabled(value, data) : listDisabled;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemDisabled", function (listItemDisabled, item, itemDisabled) {
      var data = _this.props.data,
          value = _this.state.value;
      return listItemDisabled != undefined && (typeof listItemDisabled === 'function' ? listItemDisabled(item, value, data) : listItemDisabled) || itemDisabled != undefined && (typeof itemDisabled === 'function' ? itemDisabled(item, value, data) : itemDisabled);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderListItem", function (item, index) {
      if (!item) {
        return;
      }

      var _this$props4 = _this.props,
          theme = _this$props4.theme,
          activatedTheme = _this$props4.activatedTheme,
          itemHeight = _this$props4.itemHeight,
          idField = _this$props4.idField,
          valueField = _this$props4.valueField,
          displayField = _this$props4.displayField,
          descriptionField = _this$props4.descriptionField,
          disabled = _this$props4.disabled,
          itemDisabled = _this$props4.itemDisabled,
          isLoading = _this$props4.isLoading,
          renderer = _this$props4.renderer,
          autoSelect = _this$props4.autoSelect,
          disableTouchRipple = _this$props4.disableTouchRipple,
          selectTheme = _this$props4.selectTheme,
          selectMode = _this$props4.selectMode,
          parentEl = _this$props4.parentEl,
          indeterminateCallback = _this$props4.indeterminateCallback,
          radioUncheckedIconCls = _this$props4.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props4.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props4.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props4.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props4.checkboxIndeterminateIconCls,
          onItemClick = _this$props4.onItemClick,
          value = _this.state.value;
      return (0, _typeof2["default"])(item) === 'object' ? _react["default"].createElement(_ListItem["default"], (0, _extends2["default"])({
        key: idField in item && item[idField] || index
      }, item, {
        index: index,
        parentEl: parentEl,
        style: {
          height: itemHeight
        },
        theme: item.theme || theme,
        activatedTheme: item.activatedTheme || activatedTheme,
        selectTheme: item.selectTheme || selectTheme,
        radioUncheckedIconCls: item.radioUncheckedIconCls || radioUncheckedIconCls,
        radioCheckedIconCls: item.radioCheckedIconCls || radioCheckedIconCls,
        checkboxUncheckedIconCls: item.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
        checkboxCheckedIconCls: item.checkboxCheckedIconCls || checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: item.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
        data: item,
        checked: _Calculation["default"].isItemChecked(item, value, _this.props),
        value: _Util["default"].getValueByValueField(item, valueField, displayField),
        text: _Util["default"].getTextByDisplayField(item, displayField, valueField),
        desc: item[descriptionField] || null,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item, item.disabled),
        isLoading: isLoading || item.isLoading,
        selectMode: selectMode,
        renderer: renderer,
        autoSelect: autoSelect,
        disableTouchRipple: item.disableTouchRipple || disableTouchRipple,
        indeterminateCallback: indeterminateCallback,
        onClick: function onClick(e) {
          onItemClick && onItemClick(item, index, e);
          item.onClick && item.onClick(e);
        },
        onSelect: function onSelect() {
          return _this.handleListItemSelect(item, index);
        },
        onDeselect: function onDeselect() {
          return _this.handleListItemDeselect(item, index);
        }
      })) : _react["default"].createElement(_ListItem["default"], {
        key: index,
        index: index,
        parentEl: parentEl,
        style: {
          height: itemHeight
        },
        theme: theme,
        activatedTheme: activatedTheme,
        selectTheme: selectTheme,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        data: item,
        checked: _Calculation["default"].isItemChecked(item, value, _this.props),
        value: item,
        text: item,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item),
        isLoading: isLoading,
        selectMode: selectMode,
        renderer: renderer,
        autoSelect: autoSelect,
        disableTouchRipple: disableTouchRipple,
        indeterminateCallback: indeterminateCallback,
        onClick: function onClick(e) {
          return onItemClick && onItemClick(item, index, e);
        },
        onSelect: function onSelect() {
          return _this.handleListItemSelect(item, index);
        },
        onDeselect: function onDeselect() {
          return _this.handleListItemDeselect(item, index);
        }
      });
    });
    _this.list = (0, _react.createRef)();
    _this.listEl = null;
    _this.state = {
      value: _Calculation["default"].getInitValue(props)
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(List, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.listEl = this.list && this.list.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          children = _this$props5.children,
          className = _this$props5.className,
          style = _this$props5.style,
          data = _this$props5.data,
          disabled = _this$props5.disabled,
          activatedTheme = _this$props5.activatedTheme,
          selectTheme = _this$props5.selectTheme,
          selectMode = _this$props5.selectMode,
          idField = _this$props5.idField,
          valueField = _this$props5.valueField,
          displayField = _this$props5.displayField,
          descriptionField = _this$props5.descriptionField,
          itemDisabled = _this$props5.itemDisabled,
          disableTouchRipple = _this$props5.disableTouchRipple,
          autoSelect = _this$props5.autoSelect,
          isLoading = _this$props5.isLoading,
          itemHeight = _this$props5.itemHeight,
          parentEl = _this$props5.parentEl,
          radioUncheckedIconCls = _this$props5.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props5.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props5.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props5.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props5.checkboxIndeterminateIconCls,
          indeterminateCallback = _this$props5.indeterminateCallback,
          renderer = _this$props5.renderer,
          onItemClick = _this$props5.onItemClick,
          onItemSelect = _this$props5.onItemSelect,
          onItemDeselect = _this$props5.onItemDeselect,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props5, ["children", "className", "style", "data", "disabled", "activatedTheme", "selectTheme", "selectMode", "idField", "valueField", "displayField", "descriptionField", "itemDisabled", "disableTouchRipple", "autoSelect", "isLoading", "itemHeight", "parentEl", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "indeterminateCallback", "renderer", "onItemClick", "onItemSelect", "onItemDeselect"]);
      return _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        ref: this.list,
        className: (0, _classnames["default"])('list', (0, _defineProperty2["default"])({}, className, className)),
        disabled: this.isListDisabled(disabled),
        style: style
      }), data && data.map(function (item, index) {
        return item === _ListSeparator["default"] ? _react["default"].createElement("div", {
          key: index,
          className: "list-separator"
        }) : _this2.renderListItem(item, index);
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return List;
}(_react.Component);

(0, _defineProperty2["default"])(List, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(List, "LIST_SEPARATOR", _ListSeparator["default"]);
(0, _defineProperty2["default"])(List, "Theme", _Theme["default"]);
List.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The theme of the list item.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme of the list item activated.
   */
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme of the list item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The mode of listItem.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * Children passed into the ListItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The theme of the list button activated.
     */
    activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The list item's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The title value of the list button.
     */
    title: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true, the list item will be disabled.
     */
    disabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true, the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true, the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * The message of tip.
     */
    tip: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),

    /**
     * If true, the item will have center displayed ripple effect.
     */
    rippleDisplayCenter: _propTypes["default"].bool,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,

    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].symbol])),
  value: _propTypes["default"].any,

  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * If true, the list will be disabled.
   */
  disabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

  /**
   * List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,

  /**
   * If true, the list will be at loading status.
   */
  isLoading: _propTypes["default"].bool,

  /**
   * Whether select when item clicked.
   */
  autoSelect: _propTypes["default"].bool,
  itemHeight: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * Callback function fired when the list-item touch tap.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when the list-item select.
   */
  onItemSelect: _propTypes["default"].func,

  /**
   * Callback function fired when the list-item deselect.
   */
  onItemDeselect: _propTypes["default"].func,

  /**
   * Callback function fired when the list changed.
   */
  onChange: _propTypes["default"].func,
  indeterminateCallback: _propTypes["default"].func
};
List.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  itemDisabled: false,
  disableTouchRipple: false,
  autoSelect: true,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = List;
exports["default"] = _default;