"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _isNumber = _interopRequireDefault(require("lodash/isNumber"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _Popup = _interopRequireDefault(require("../Popup"));

var _List = _interopRequireDefault(require("../List"));

var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

/**
 * @file LocalAutoComplete component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var LocalAutoComplete =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(LocalAutoComplete, _Component);

  function LocalAutoComplete(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, LocalAutoComplete);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(LocalAutoComplete)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNoMatch", function () {
      var onNoMatch = _this.props.onNoMatch,
          _this$state = _this.state,
          listData = _this$state.listData,
          filter = _this$state.filter;

      if (!listData || listData.length < 1) {
        onNoMatch && onNoMatch(filter);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterFocus", function () {
      if (_this.props.disabled) {
        return;
      }

      var _this$props = _this.props,
          minFilterLength = _this$props.minFilterLength,
          onFocus = _this$props.onFocus,
          _this$state2 = _this.state,
          filter = _this$state2.filter,
          listData = _this$state2.listData,
          state = {
        filterFocused: true
      };
      onFocus && onFocus.apply(void 0, arguments);

      if (filter !== null && filter.length >= minFilterLength) {
        state.popupVisible = true;
        state.tempSelectIndex = listData.length > 0 ? 0 : null;
      }

      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterBlur", function () {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      _this.setState({
        filterFocused: false
      }, function () {
        var onBlur = _this.props.onBlur;
        onBlur && onBlur.apply(void 0, args);

        _this.handleNoMatch();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterKeyDown", function (e) {
      var useDynamicRenderList = _this.props.useDynamicRenderList,
          _this$state3 = _this.state,
          tempSelectIndex = _this$state3.tempSelectIndex,
          listData = _this$state3.listData;
      var index = tempSelectIndex;

      if (e.keyCode === 38) {
        // up
        index--;
      } else if (e.keyCode === 40) {
        // down
        index++;
      }

      var newTempSelectIndex = _Valid["default"].range(index, 0, listData.length - 1);

      _this.setState({
        tempSelectIndex: newTempSelectIndex
      }, function () {
        var onFilterKeyDown = _this.props.onFilterKeyDown,
            listInstance = useDynamicRenderList ? _this.dynamicRenderList && _this.dynamicRenderList.current : _this.list && _this.list.current;
        onFilterKeyDown && onFilterKeyDown(e);
        listInstance && listInstance.adjustScroll();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterPressEnter", function (e, filter) {
      var autoClose = _this.props.autoClose,
          state = {};

      if (autoClose) {
        state.popupVisible = false;
      }

      _this.setState(state, function () {
        var onFilterPressEnter = _this.props.onFilterPressEnter;
        onFilterPressEnter && onFilterPressEnter(filter);

        _this.handleNoMatch();

        _this.update();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      var _this$props2 = _this.props,
          data = _this$props2.data,
          minFilterLength = _this$props2.minFilterLength,
          state = {
        filter: filter,
        popupVisible: filter !== null && filter.length >= minFilterLength
      };

      if (!filter) {
        state.listData = data;
        state.tempSelectIndex = null;
      } else {
        state.listData = _Calculation["default"].filterLocalAutoCompleteData(filter, _this.props);
        state.tempSelectIndex = state.listData.length > 0 ? 0 : null;
      }

      _this.setState(state, function () {
        var onFilterChange = _this.props.onFilterChange;
        onFilterChange && onFilterChange(filter);
        _this.pop && _this.pop.current && _this.pop.current.resetPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      }, function () {
        var onPopupClosed = _this.props.onPopupClosed;
        onPopupClosed && onPopupClosed();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "popupRenderHandler", function (popupEl) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.wrapperEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));

      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemClick", function (value) {
      var _this$props3 = _this.props,
          autoClose = _this$props3.autoClose,
          valueField = _this$props3.valueField,
          displayField = _this$props3.displayField,
          renderer = _this$props3.renderer,
          filter = renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField),
          state = {
        tempSelectIndex: null,
        value: value,
        filter: filter,
        listData: _Calculation["default"].filterLocalAutoCompleteData(filter, _this.props)
      },
          isChanged = _this.state.value != value;

      if (autoClose) {
        state.popupVisible = false;
      }

      _this.setState(state, function () {
        var _this$props4 = _this.props,
            onItemClick = _this$props4.onItemClick,
            onChange = _this$props4.onChange;
        onItemClick && onItemClick(value);
        isChanged && onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "update", function () {
      var _this$props5 = _this.props,
          displayField = _this$props5.displayField,
          valueField = _this$props5.valueField,
          renderer = _this$props5.renderer,
          _this$state4 = _this.state,
          filter = _this$state4.filter,
          tempSelectIndex = _this$state4.tempSelectIndex,
          listData = _this$state4.listData;
      var index = (0, _isNumber["default"])(tempSelectIndex) ? tempSelectIndex : 0,
          state = {
        tempSelectIndex: null
      },
          value,
          filterChanged = false,
          valueChanged = false;

      if (listData && listData.length > 0) {
        value = listData[index];
        state.filter = renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField);
        filterChanged = state.filter !== filter;

        if (filterChanged) {
          state.listData = _Calculation["default"].filterLocalAutoCompleteData(state.filter, _this.props);
        }

        if (_Util["default"].getValueByValueField(_this.state.value, valueField, displayField) !== _Util["default"].getValueByValueField(value, valueField, displayField)) {
          valueChanged = true;
          state.value = listData[index];
        }
      }

      _this.setState(state, function () {
        if (filterChanged) {
          var onFilterChange = _this.props.onFilterChange;
          onFilterChange && onFilterChange(state.filter);
        }

        if (valueChanged) {
          var onChange = _this.props.onChange;
          onChange && onChange(state.value);
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      if (_this.state.filterFocused && !_Dom["default"].isParent(e.target, _this.wrapperEl) && _this.pop && _this.pop.current && !_Dom["default"].isParent(e.target, (0, _reactDom.findDOMNode)(_this.pop.current))) {
        _this.update();
      }
    });
    _this.wrapper = (0, _react.createRef)();
    _this.wrapperEl = null;
    _this.trigger = (0, _react.createRef)();
    _this.triggerEl = null;
    _this.pop = (0, _react.createRef)();
    _this.dynamicRenderList = (0, _react.createRef)();
    _this.list = (0, _react.createRef)();
    _this.state = {
      tempSelectIndex: null,
      value: props.value,
      filter: props.filter,
      filterFocused: false,
      popupVisible: false,
      isAbove: false,
      listData: _Calculation["default"].filterLocalAutoCompleteData(props.filter, props)
    };
    return _this;
  }

  (0, _createClass2["default"])(LocalAutoComplete, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);

      _Event["default"].addEvent(document, 'mousedown', this.handleMouseDown);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousedown', this.handleMouseDown);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          className = _this$props6.className,
          triggerClassName = _this$props6.triggerClassName,
          popupClassName = _this$props6.popupClassName,
          style = _this$props6.style,
          popupStyle = _this$props6.popupStyle,
          popupTheme = _this$props6.popupTheme,
          name = _this$props6.name,
          position = _this$props6.position,
          valueField = _this$props6.valueField,
          displayField = _this$props6.displayField,
          descriptionField = _this$props6.descriptionField,
          noMatchedPopupVisible = _this$props6.noMatchedPopupVisible,
          noMatchedMsg = _this$props6.noMatchedMsg,
          popupChildren = _this$props6.popupChildren,
          renderer = _this$props6.renderer,
          useDynamicRenderList = _this$props6.useDynamicRenderList,
          listHeight = _this$props6.listHeight,
          itemHeight = _this$props6.itemHeight,
          scrollBuffer = _this$props6.scrollBuffer,
          resetPopPositionWait = _this$props6.resetPopPositionWait,
          onFilterClear = _this$props6.onFilterClear,
          parentEl = _this$props6.parentEl,
          data = _this$props6.data,
          propsFilter = _this$props6.filter,
          filterInitValue = _this$props6.filterInitValue,
          minFilterLength = _this$props6.minFilterLength,
          autoClose = _this$props6.autoClose,
          filterCallback = _this$props6.filterCallback,
          onFilterPressEnter = _this$props6.onFilterPressEnter,
          onFilterChange = _this$props6.onFilterChange,
          onNoMatch = _this$props6.onNoMatch,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props6, ["className", "triggerClassName", "popupClassName", "style", "popupStyle", "popupTheme", "name", "position", "valueField", "displayField", "descriptionField", "noMatchedPopupVisible", "noMatchedMsg", "popupChildren", "renderer", "useDynamicRenderList", "listHeight", "itemHeight", "scrollBuffer", "resetPopPositionWait", "onFilterClear", "parentEl", "data", "filter", "filterInitValue", "minFilterLength", "autoClose", "filterCallback", "onFilterPressEnter", "onFilterChange", "onNoMatch"]),
          _this$state5 = this.state,
          isAbove = _this$state5.isAbove,
          tempSelectIndex = _this$state5.tempSelectIndex,
          value = _this$state5.value,
          filter = _this$state5.filter,
          popupVisible = _this$state5.popupVisible,
          listData = _this$state5.listData,
          isEmpty = listData && listData.length < 1,
          isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove;
      return _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('local-auto-complete', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? _react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, _react["default"].createElement(_TextField["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.trigger,
        className: (0, _classnames["default"])('local-auto-complete-trigger', isEmpty && !noMatchedPopupVisible ? '' : popupVisible ? ' activated' : '', isAboveFinally ? ' above' : ' blow', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        value: filter,
        onFocus: this.handleFilterFocus,
        onClick: this.handleFilterFocus,
        onBlur: this.handleFilterBlur,
        onChange: this.handleFilterChange,
        onKeyDown: this.handleFilterKeyDown,
        onPressEnter: this.handleFilterPressEnter,
        onClear: onFilterClear,
        onRightIconClick: this.handleFilterPressEnter
      })), isEmpty && !noMatchedPopupVisible ? null : _react["default"].createElement(_Popup["default"], {
        ref: this.pop,
        className: (0, _classnames["default"])('local-auto-complete-popup', isAboveFinally ? ' above' : ' blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        theme: popupTheme,
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        onRender: this.popupRenderHandler,
        onRequestClose: this.closePopup
      }, isEmpty ? _react["default"].createElement(_List["default"], {
        className: "local-auto-complete-list",
        theme: popupTheme,
        data: [{
          itemRenderer: function itemRenderer() {
            return _react["default"].createElement("div", {
              className: "no-matched-list-item"
            }, noMatchedMsg ? noMatchedMsg : _react["default"].createElement("span", null, _react["default"].createElement("i", {
              className: "fas fa-exclamation-triangle no-matched-list-item-icon"
            }), "No matched value."));
          },
          disableTouchRipple: true
        }]
      }) : useDynamicRenderList ? _react["default"].createElement(_DynamicRenderList["default"], {
        ref: this.dynamicRenderList,
        className: "local-auto-complete-list",
        theme: popupTheme,
        data: listData,
        value: listData[tempSelectIndex],
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        listHeight: listHeight,
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        onItemClick: this.handleItemClick
      }) : _react["default"].createElement(_List["default"], {
        ref: this.list,
        className: "local-auto-complete-list",
        theme: popupTheme,
        data: listData,
        value: listData[tempSelectIndex],
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: this.handleItemClick
      }), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var filter = _ComponentUtil["default"].getDerivedState(props, state, 'filter');

      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        filter: filter,
        listData: _Calculation["default"].filterLocalAutoCompleteData(filter, props)
      };
    }
  }]);
  return LocalAutoComplete;
}(_react.Component);

(0, _defineProperty2["default"])(LocalAutoComplete, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(LocalAutoComplete, "Position", _Position["default"]);
LocalAutoComplete.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,

  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,

  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * The name of the auto complete.
   */
  name: _propTypes["default"].string,

  /**
   * The title of the auto complete.
   */
  title: _propTypes["default"].string,

  /**
   * The placeholder of the field.
   */
  placeholder: _propTypes["default"].string,

  /**
   * Children passed into the List.
   */
  data: _propTypes["default"].oneOfType([// not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,

    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,

    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,

    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])), // grouped
  _propTypes["default"].array]).isRequired,

  /**
   * The value of LocalAutoComplete.
   */
  value: _propTypes["default"].any,

  /**
   * If true, the auto complete will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,

  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,

  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,

  /**
   * If true, the popup list automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  minFilterLength: _propTypes["default"].number,

  /**
   * Callback function fired when filter changed.
   */
  filterCallback: _propTypes["default"].func,

  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,

  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,

  /**
   * The visiblity of no matched popup.
   */
  noMatchedPopupVisible: _propTypes["default"].bool,

  /**
   * The message of no matched value.
   */
  noMatchedMsg: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  filter: _propTypes["default"].string,
  useDynamicRenderList: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  filterInitValue: _propTypes["default"].string,

  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,

  /**
   * The function that trigger when filter key down.
   */
  onFilterKeyDown: _propTypes["default"].func,

  /**
   * The function that trigger when press enter.
   */
  onFilterPressEnter: _propTypes["default"].func,

  /**
   * The function that trigger when filter changes.
   */
  onFilterChange: _propTypes["default"].func,

  /**
   * The function that trigger when filter cleared.
   */
  onFilterClear: _propTypes["default"].func,

  /**
   * The function that trigger when value changed.
   */
  onChange: _propTypes["default"].func,

  /**
   * The function that trigger when touch-tap the list items.
   */
  onItemClick: _propTypes["default"].func,

  /**
   * Callback function fired when LocalAutoComplete get focus.
   */
  onFocus: _propTypes["default"].func,

  /**
   * Callback function fired when LocalAutoComplete lose focus.
   */
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onNoMatch: _propTypes["default"].func,
  onPopupClosed: _propTypes["default"].func
};
LocalAutoComplete.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  data: [],
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true,
  minFilterLength: 1,
  rightIconCls: 'fas fa-search',
  noMatchedPopupVisible: true,
  filter: '',
  useDynamicRenderList: false,
  resetPopPositionWait: 250
};
var _default = LocalAutoComplete;
exports["default"] = _default;