"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _moment = _interopRequireDefault(require("moment"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _classnames = _interopRequireDefault(require("classnames"));

var _MaterialDatePickerTextField = _interopRequireDefault(require("../_MaterialDatePickerTextField"));

var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));

var _YearPicker = _interopRequireDefault(require("../_YearPicker"));

var _Popup = _interopRequireDefault(require("../Popup"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file MaterialMonthPicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var MaterialMonthPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MaterialMonthPicker, _Component);

  function MaterialMonthPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MaterialMonthPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MaterialMonthPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (selectLevel) {
      _this.setState({
        datePickerLevel: selectLevel
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTextFieldChange", function (text) {
      var _this$props = _this.props,
          minValue = _this$props.minValue,
          maxValue = _this$props.maxValue,
          dateFormat = _this$props.dateFormat;

      if (text && text.length) {
        if ((0, _moment["default"])(text, _this.props.dateFormat, true).isValid()) {
          if (minValue && (0, _moment["default"])(text).isBefore(minValue) || maxValue && (0, _moment["default"])(text).isAfter(maxValue)) {//
          } else {
            var year = (0, _moment["default"])(text).format('YYYY'),
                month = (0, _moment["default"])(text).format('MM');

            _this.setState({
              value: (0, _moment["default"])(text, dateFormat),
              year: year,
              month: month
            }, function () {
              _this.props.onChange && _this.props.onChange(text && (0, _moment["default"])(text).format(dateFormat));
            });
          }
        }
      } else {
        _this.setState({
          value: ''
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (date) {
      var _this$props2 = _this.props,
          dateFormat = _this$props2.dateFormat,
          autoClose = _this$props2.autoClose,
          onChange = _this$props2.onChange;
      var state = (0, _cloneDeep["default"])(_this.state);
      state.popupVisible = !autoClose;
      state.value = (0, _moment["default"])("".concat(date.year, "-").concat(date.month), dateFormat);
      state.year = date.year;
      state.month = date.month;

      _this.setState(state, function () {
        onChange((0, _moment["default"])(state.value).format(dateFormat));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (year) {
      _this.setState({
        datePickerLevel: 'month',
        year: year
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function (e) {
      if (_this.validValue) {
        _this.setState({
          popupVisible: !_this.state.popupVisible
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      !_this.props.disabled && _this.setState({
        popupVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      if (_this.props.position) {
        return;
      }

      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));

      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    _this.validValue = true;
    _this.trigger = (0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      value: props.value,
      popupVisible: false,
      isAbove: false,
      year: (0, _moment["default"])(props.value).format('YYYY'),
      month: (0, _moment["default"])(props.value).format('MM'),
      datePickerLevel: 'month',
      marginLeft: 0
    };
    return _this;
  }

  (0, _createClass2["default"])(MaterialMonthPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current); // debugger

      var _this$props3 = this.props,
          value = _this$props3.value,
          dateFormat = _this$props3.dateFormat;
      var state = (0, _cloneDeep["default"])(this.state);

      if (value) {
        if ((0, _moment["default"])(value, dateFormat).isValid()) {
          var year = (0, _moment["default"])(value).format('YYYY'),
              month = (0, _moment["default"])(value).format('MM');
          state.value = (0, _moment["default"])(value, dateFormat);
          state.year = year;
          state.month = month;
          this.setState(state);
        } else {
          console.error('Invalid date');
          this.validValue = false;
        }
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value || nextProps.dateFormat !== this.props.dateFormat) {
        this.setState({
          value: (0, _moment["default"])(nextProps.value, nextProps.dateFormat),
          dateFormat: nextProps.dateFormat,
          year: (0, _moment["default"])(nextProps.value).format('YYYY'),
          month: (0, _moment["default"])(nextProps.value).format('MM')
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          className = _this$props4.className,
          name = _this$props4.name,
          placeholder = _this$props4.placeholder,
          dateFormat = _this$props4.dateFormat,
          maxValue = _this$props4.maxValue,
          minValue = _this$props4.minValue,
          label = _this$props4.label,
          isLabelAnimate = _this$props4.isLabelAnimate,
          position = _this$props4.position,
          theme = _this$props4.theme,
          popupClassName = _this$props4.popupClassName,
          rightIconCls = _this$props4.rightIconCls,
          previousYearIconCls = _this$props4.previousYearIconCls,
          previousMonthIconCls = _this$props4.previousMonthIconCls,
          nextYearIconCls = _this$props4.nextYearIconCls,
          nextMonthIconCls = _this$props4.nextMonthIconCls,
          readOnly = _this$props4.readOnly,
          disabled = _this$props4.disabled,
          parentEl = _this$props4.parentEl,
          _this$state = this.state,
          value = _this$state.value,
          popupVisible = _this$state.popupVisible,
          datePickerLevel = _this$state.datePickerLevel,
          year = _this$state.year,
          month = _this$state.month,
          isAbove = _this$state.isAbove,
          textValue = value && (0, _moment["default"])(value).format(dateFormat);
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-month-picker', (0, _defineProperty2["default"])({}, className, className))
      }, _react["default"].createElement(_MaterialDatePickerTextField["default"], {
        ref: this.trigger,
        theme: theme,
        name: name,
        placeholder: placeholder,
        value: textValue,
        readOnly: readOnly ? readOnly : !popupVisible,
        clearButtonVisible: false,
        isFocusedSelectAll: false,
        disabled: disabled,
        popupVisible: popupVisible,
        label: label,
        isLabelAnimate: isLabelAnimate,
        rightIconCls: rightIconCls,
        onChange: this.handleTextFieldChange,
        onClick: function onClick(e) {
          _this2.togglePopup(e);
        }
      }), _react["default"].createElement(_Popup["default"], {
        className: "material-month-picker-popup ".concat(popupClassName),
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        hasTriangle: false,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, datePickerLevel == 'month' ? _react["default"].createElement(_MonthPicker["default"], {
        value: value,
        year: year,
        month: month,
        maxValue: maxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleMonthPickerChange,
        previousClick: this.handleDatePickerChange
      }) : _react["default"].createElement(_YearPicker["default"], {
        value: value,
        year: year,
        month: month,
        maxValue: maxValue,
        minValue: minValue,
        previousYearIconCls: previousYearIconCls,
        previousMonthIconCls: previousMonthIconCls,
        nextYearIconCls: nextYearIconCls,
        nextMonthIconCls: nextMonthIconCls,
        onChange: this.handleYearPickerChange
      })));
    }
  }]);
  return MaterialMonthPicker;
}(_react.Component);

(0, _defineProperty2["default"])(MaterialMonthPicker, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialMonthPicker, "Position", _Position["default"]);
MaterialMonthPicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * Date picker input name.
   */
  name: _propTypes["default"].string,

  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].any,

  /**
   * The label of the MaterialMonthPicker.
   */
  label: _propTypes["default"].any,

  /**
   * The animate of the MaterialMonthPicker.
   */
  isLabelAnimate: _propTypes["default"].bool,

  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].any,

  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].any,

  /**
   * MaterialMonthPicker textField element placeholder.
   */
  placeholder: _propTypes["default"].string,

  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,

  /**
   * If true,hide date display.
   */
  autoClose: _propTypes["default"].bool,

  /**
   * If true,materialMonthPicker textField is readOnly.
   */
  readOnly: _propTypes["default"].bool,

  /**
   * If true,materialMonthPicker textField is disabled.
   */
  disabled: _propTypes["default"].bool,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,

  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
MaterialMonthPicker.defaultProps = {
  name: '',
  maxValue: '',
  minValue: '',
  popupClassName: '',
  placeholder: 'Date',
  dateFormat: 'YYYY-MM',
  autoClose: true,
  isFooter: true,
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right',
  position: _Position["default"].BOTTOM_LEFT,
  readOnly: false,
  disabled: false
};
var _default = MaterialMonthPicker;
exports["default"] = _default;