"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _MaterialFieldSeparator = _interopRequireDefault(require("../_MaterialFieldSeparator"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var MaterialProvider =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MaterialProvider, _Component);

  function MaterialProvider(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MaterialProvider);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MaterialProvider)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setFocused", function (isFocus) {
      _this.setState({
        isFocus: isFocus
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setHovered", function (isHover) {
      _this.setState({
        isHover: isHover
      });
    });
    _this.state = {
      isHover: false,
      isFocus: false
    };
    return _this;
  }

  (0, _createClass2["default"])(MaterialProvider, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          theme = _this$props.theme,
          label = _this$props.label,
          isLabelAnimate = _this$props.isLabelAnimate,
          hasValue = _this$props.hasValue,
          disabled = _this$props.disabled,
          required = _this$props.required,
          useSeparator = _this$props.useSeparator,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["children", "className", "theme", "label", "isLabelAnimate", "hasValue", "disabled", "required", "useSeparator"]),
          _this$state = this.state,
          isHover = _this$state.isHover,
          isFocus = _this$state.isFocus;
      return _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('material-provider', (0, _defineProperty2["default"])({
          'has-label': label,
          'has-value': hasValue,
          'has-separator': useSeparator,
          animated: isLabelAnimate,
          focused: isFocus
        }, className, className)),
        disabled: disabled
      }), _react["default"].createElement("div", {
        className: "material-provider-label-wrapper"
      }, _react["default"].createElement("span", {
        className: "material-provider-label"
      }, label), required ? _react["default"].createElement("div", {
        className: "material-provider-required-dot"
      }) : null), _react.Children.map(children, function (child) {
        var _child$props = child.props,
            triggerClassName = _child$props.triggerClassName,
            placeholderClassName = _child$props.placeholderClassName,
            restProps = (0, _objectWithoutProperties2["default"])(_child$props, ["triggerClassName", "placeholderClassName"]),
            props = _objectSpread({}, restProps, {
          className: (0, _classnames["default"])('material-provider-field', (0, _defineProperty2["default"])({}, restProps.className, restProps.className)),
          onFocus: function onFocus() {
            restProps.onFocus && restProps.onFocus.apply(restProps, arguments);

            _this2.setFocused(true);
          },
          onBlur: function onBlur() {
            restProps.onBlur && restProps.onBlur.apply(restProps, arguments);

            _this2.setFocused(false);
          },
          onMouseOver: function onMouseOver() {
            restProps.onMouseOver && restProps.onMouseOver.apply(restProps, arguments);

            _this2.setHovered(true);
          },
          onMouseOut: function onMouseOut() {
            restProps.onMouseOut && restProps.onMouseOut.apply(restProps, arguments);

            _this2.setHovered(false);
          }
        }); // react component element


        if (typeof child.type !== 'string') {
          props.triggerClassName = (0, _classnames["default"])('material-provider-field-trigger', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName));
          props.placeholderClassName = (0, _classnames["default"])('material-provider-field-placeholder', (0, _defineProperty2["default"])({}, placeholderClassName, placeholderClassName));
        }

        return (0, _react.cloneElement)(child, props);
      }), useSeparator ? _react["default"].createElement(_MaterialFieldSeparator["default"], {
        theme: theme,
        isHover: isHover,
        isFocus: isFocus,
        disabled: disabled
      }) : null);
    }
  }]);
  return MaterialProvider;
}(_react.Component);

MaterialProvider.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  label: _propTypes["default"].any,
  isLabelAnimate: _propTypes["default"].bool,
  hasValue: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  useSeparator: _propTypes["default"].bool
};
MaterialProvider.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isLabelAnimate: true,
  hasValue: false,
  disabled: false,
  required: false,
  useSeparator: true
};
var _default = MaterialProvider;
exports["default"] = _default;