"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file OpacityPicker component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var OpacityPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(OpacityPicker, _Component);

  function OpacityPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, OpacityPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(OpacityPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calcSliderLeft", function () {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.value;
      var barEl = _this.huePickerBarEl,
          sliderEl = _this.huePickerSliderEl;

      if (!value || !barEl || !sliderEl) {
        return 0;
      }

      var barWidth = barEl.offsetWidth,
          sliderWidth = sliderEl.offsetWidth,
          width = barWidth - sliderWidth;
      return value * width;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      _this.activated = true;

      _this.handleChange(e.pageX);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      if (_this.activated) {
        _this.handleChange(e.pageX);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseUp", function () {
      _this.activated = false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (mouseX) {
      var _Dom$getOffset = _Dom["default"].getOffset(_this.huePickerBarEl),
          left = _Dom$getOffset.left,
          barWidth = _this.huePickerBarEl.offsetWidth,
          sliderWidth = _this.huePickerSliderEl.offsetWidth,
          halfSliderWidth = sliderWidth / 2,
          width = barWidth - sliderWidth,
          offsetX = _Valid["default"].range(mouseX - halfSliderWidth - left, 0, width),
          value = Math.round(offsetX / width * 100) / 100;

      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.activated = false;
    _this.huePickerBar = (0, _react.createRef)();
    _this.huePickerBarEl = null;
    _this.huePickerSlider = (0, _react.createRef)();
    _this.huePickerSliderEl = null;
    _this.state = {
      value: props.value
    };
    return _this;
  }
  /**
   * get slider css left by opacity value
   * @param value
   * @returns {number}
   */


  (0, _createClass2["default"])(OpacityPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.huePickerBarEl = this.huePickerBar && this.huePickerBar.current;
      this.huePickerSliderEl = this.huePickerSlider && this.huePickerSlider.current;

      _Event["default"].addEvent(document, 'mousemove', this.handleMouseMove);

      _Event["default"].addEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.handleMouseMove);

      _Event["default"].removeEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          color = _this$props.color;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('opacity-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        ref: this.huePickerBar,
        className: "opacity-picker-bar",
        onMouseDown: this.handleMouseDown
      }, _react["default"].createElement("div", {
        className: "opacity-picker-color-overlay",
        style: {
          background: "linear-gradient(90deg, transparent, #".concat(color, ")")
        }
      }), _react["default"].createElement("div", {
        ref: this.huePickerSlider,
        className: "opacity-picker-slider",
        style: {
          left: this.calcSliderLeft()
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return OpacityPicker;
}(_react.Component);

OpacityPicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Transparency value ( range: [0, 1] ).
   */
  value: _propTypes["default"].number,

  /**
   * Color hex value
   */
  color: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
OpacityPicker.defaultProps = {
  value: 1,
  color: '000000'
};
var _default = OpacityPicker;
exports["default"] = _default;