"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CSSTransition = _interopRequireDefault(require("react-transition-group/CSSTransition"));

/**
 * @file PageLoading component
 * @author chao(chao.zhang@derbysoft.com)
 */
var PageLoading =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(PageLoading, _Component);

  function PageLoading(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, PageLoading);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(PageLoading)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setLoading", function () {
      var progress = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.loadingProgress;
      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var _progress$index = progress[index],
          width = _progress$index.width,
          timeout = _progress$index.timeout,
          highlightStyle = {};
      highlightStyle.width = width + '%';
      highlightStyle.transition = 'width ' + timeout + 'ms linear 0ms';

      _this.setState({
        highlightStyle: highlightStyle
      }, function () {
        if (index < progress.length - 1) {
          _this.clearProgress();

          _this.progressTimeout = setTimeout(function () {
            _this.setLoading(progress, index + 1);
          }, width === 100 ? 0 : timeout);
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearProgress", function () {
      _this.progressTimeout && clearTimeout(_this.progressTimeout);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function () {
      _this.clearProgress();

      _this.setState({
        highlightStyle: _this.defaultHighlightStyle
      }, function () {
        _this.setLoading();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExit", function () {
      _this.clearProgress();

      _this.setLoading([{
        width: 100,
        timeout: _this.props.finishDuration
      }]);
    });
    _this.progressTimeout = null;
    _this.defaultHighlightStyle = {
      width: 0,
      transition: 'width 0s'
    };
    _this.state = {
      highlightStyle: _this.defaultHighlightStyle
    };
    return _this;
  }

  (0, _createClass2["default"])(PageLoading, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearProgress();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          visible = _this$props.visible,
          duration = _this$props.duration,
          finishDuration = _this$props.finishDuration,
          showStripes = _this$props.showStripes,
          highlightStyle = this.state.highlightStyle;
      return _react["default"].createElement(_CSSTransition["default"], {
        "in": visible,
        timeout: {
          exit: duration + finishDuration
        },
        classNames: "page-loading",
        onEnter: this.handleEnter,
        onExit: this.handleExit
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('page-loading', (0, _defineProperty2["default"])({
          striped: showStripes
        }, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        className: "page-loading-bar",
        style: highlightStyle
      })));
    }
  }]);
  return PageLoading;
}(_react.Component);

PageLoading.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  visible: _propTypes["default"].bool,
  duration: _propTypes["default"].number,
  finishDuration: _propTypes["default"].number,
  showStripes: _propTypes["default"].bool,
  loadingProgress: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    width: _propTypes["default"].number,
    timeout: _propTypes["default"].number
  }))
};
PageLoading.defaultProps = {
  visible: false,
  duration: 250,
  finishDuration: 100,
  showStripes: true,
  loadingProgress: [{
    width: 0,
    timeout: 0
  }, {
    width: 50,
    timeout: 200
  }, {
    width: 80,
    timeout: 2000
  }, {
    width: 90,
    timeout: 2500
  }, {
    width: 95,
    timeout: 25000
  }]
};
var _default = PageLoading;
exports["default"] = _default;