"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PaginationSize = _interopRequireDefault(require("../_PaginationSize"));

var _PaginationPage = _interopRequireDefault(require("../_PaginationPage"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file Pagination component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Pagination =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Pagination, _Component);

  function Pagination(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Pagination);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Pagination)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageChange", function (page) {
      _this.setState({
        page: page
      }, function () {
        var _this$props = _this.props,
            onPageChange = _this$props.onPageChange,
            onChange = _this$props.onChange;
        onPageChange && onPageChange(page);
        onChange && onChange({
          page: page,
          pageSize: _this.state.pageSize
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageSizeChange", function (pageSize) {
      var pageSizeValueField = _this.props.pageSizeValueField,
          originPageSizeValue = _TableCalculation["default"].getPageSizeValue(_this.state.pageSize, pageSizeValueField),
          pageSizeValue = _TableCalculation["default"].getPageSizeValue(pageSize, pageSizeValueField);

      if (pageSizeValue && originPageSizeValue !== pageSizeValue) {
        var _this$props2 = _this.props,
            onPageSizeChange = _this$props2.onPageSizeChange,
            onChange = _this$props2.onChange;
        onPageSizeChange && onPageSizeChange(pageSizeValue);

        var totalPage = Math.ceil(_this.props.total / pageSizeValue),
            page = _Valid["default"].range(_this.state.page, 0, totalPage - 1);

        if (page !== _this.state.page) {
          var onPageChange = _this.props.onPageChange;
          onPageChange && onPageChange(page);
          onChange && onChange({
            page: page,
            pageSize: pageSizeValue
          });
        } else {
          onChange && onChange({
            page: _this.state.page,
            pageSize: pageSizeValue
          });
        }
      }
    });
    _this.state = {
      page: props.page,
      pageSize: props.pageSize
    };
    return _this;
  }

  (0, _createClass2["default"])(Pagination, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          total = _this$props3.total,
          pageSizes = _this$props3.pageSizes,
          pageSizeValueField = _this$props3.pageSizeValueField,
          pageSizeDisplayField = _this$props3.pageSizeDisplayField,
          selectedCount = _this$props3.selectedCount,
          selectionVisible = _this$props3.selectionVisible,
          totalVisible = _this$props3.totalVisible,
          pageVisible = _this$props3.pageVisible,
          pageSizeVisible = _this$props3.pageSizeVisible,
          pageSizeRightIconCls = _this$props3.pageSizeRightIconCls,
          prevIconCls = _this$props3.prevIconCls,
          nextIconCls = _this$props3.nextIconCls,
          firstIconCls = _this$props3.firstIconCls,
          lastIconCls = _this$props3.lastIconCls,
          selectionRenderer = _this$props3.selectionRenderer,
          totalRenderer = _this$props3.totalRenderer,
          parentEl = _this$props3.parentEl,
          _this$state = this.state,
          page = _this$state.page,
          pageSize = _this$state.pageSize,
          totalPage = Math.ceil(total / pageSize);
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('pagination', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        className: "pagination-left"
      }, selectionVisible ? _react["default"].createElement("div", {
        className: "pagination-selected"
      }, selectionRenderer ? selectionRenderer(selectedCount, total, page, totalPage, pageSize, pageSizes) : "Selected: ".concat(selectedCount)) : null, totalVisible ? _react["default"].createElement("div", {
        className: "pagination-total"
      }, totalRenderer ? totalRenderer(total, page, totalPage, pageSize, pageSizes) : "Total: ".concat(total)) : null), _react["default"].createElement("div", {
        className: "pagination-right"
      }, pageSizeVisible ? _react["default"].createElement(_PaginationSize["default"], {
        pageSize: pageSize,
        pageSizes: pageSizes,
        valueField: pageSizeValueField,
        displayField: pageSizeDisplayField,
        parentEl: parentEl,
        rightIconCls: pageSizeRightIconCls,
        onPageSizeChange: this.handlePageSizeChange
      }) : null, pageVisible ? _react["default"].createElement(_PaginationPage["default"], {
        page: page,
        totalPage: totalPage,
        prevIconCls: prevIconCls,
        nextIconCls: nextIconCls,
        firstIconCls: firstIconCls,
        lastIconCls: lastIconCls,
        onPageChange: this.handlePageChange
      }) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        page: _ComponentUtil["default"].getDerivedState(props, state, 'page'),
        pageSize: _ComponentUtil["default"].getDerivedState(props, state, 'pageSize')
      };
    }
  }]);
  return Pagination;
}(_react.Component);

Pagination.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The total of data.
   */
  total: _propTypes["default"].number,

  /**
   * The valid page.
   */
  page: _propTypes["default"].number,

  /**
   * The number of per page.
   */
  pageSize: _propTypes["default"].number,

  /**
   * The array of pageSize.
   */
  pageSizes: _propTypes["default"].array,

  /**
   * The value field name of PageSize. (default: "value")
   */
  pageSizeValueField: _propTypes["default"].string,

  /**
   * The display field name of PageSize. (default: "text")
   */
  pageSizeDisplayField: _propTypes["default"].string,

  /**
   * The total count of selected.
   */
  selectedCount: _propTypes["default"].number,

  /**
   * If true, the selectedCount will show.
   */
  selectionVisible: _propTypes["default"].bool,

  /**
   * If true, the total will show.
   */
  totalVisible: _propTypes["default"].bool,

  /**
   * If false, the pageSize choice box will not show.
   */
  pageVisible: _propTypes["default"].bool,

  /**
   * If false, the pageSizes selection will not show.
   */
  pageSizeVisible: _propTypes["default"].bool,

  /**
   * Use this property to set page size right icon.
   */
  pageSizeRightIconCls: _propTypes["default"].string,

  /**
   * Use this property to set prev button icon.
   */
  prevIconCls: _propTypes["default"].string,

  /**
   * Use this property to set next button icon.
   */
  nextIconCls: _propTypes["default"].string,

  /**
   * Use this property to set first button icon.
   */
  firstIconCls: _propTypes["default"].string,

  /**
   * Use this property to set last button icon.
   */
  lastIconCls: _propTypes["default"].string,
  selectionRenderer: _propTypes["default"].func,
  totalRenderer: _propTypes["default"].func,
  parentEl: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  onPageChange: _propTypes["default"].func,
  onPageSizeChange: _propTypes["default"].func
};
Pagination.defaultProps = {
  total: 0,
  page: 0,
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  pageSizeValueField: 'value',
  pageSizeDisplayField: 'text',
  selectedCount: 0,
  selectionVisible: false,
  totalVisible: true,
  pageVisible: true,
  pageSizeVisible: true,
  pageSizeRightIconCls: 'fas fa-angle-down',
  prevIconCls: 'fas fa-angle-left',
  nextIconCls: 'fas fa-angle-right',
  firstIconCls: 'fas fa-angle-double-left',
  lastIconCls: 'fas fa-angle-double-right'
};
var _default = Pagination;
exports["default"] = _default;