"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

/**
 * @file Paper component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Paper =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Paper, _Component);

  function Paper(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, Paper);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Paper)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(Paper, [{
    key: "formatDepth",
    value: function formatDepth(depth) {
      if (!depth || isNaN(depth)) {
        return 0;
      }

      return _Valid["default"].range(depth, 0, 7);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          theme = _this$props.theme,
          depth = _this$props.depth,
          nonRounded = _this$props.nonRounded,
          isCircular = _this$props.isCircular,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "theme", "depth", "nonRounded", "isCircular"]);
      return _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('paper', nonRounded ? 'nonRounded' : isCircular ? 'circular' : '', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "depth-".concat(this.formatDepth(depth)), depth), (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }));
    }
  }]);
  return Paper;
}(_react.Component);

(0, _defineProperty2["default"])(Paper, "Theme", _Theme["default"]);
Paper.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Theme of the root element.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * This number represents the zDepth of the paper shadow.
   */
  depth: _propTypes["default"].number,

  /**
   * If true,the paper container will have no border radius.
   */
  nonRounded: _propTypes["default"].bool,

  /**
   * If true,the paper shape is circle.
   */
  isCircular: _propTypes["default"].bool
};
Paper.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  depth: 1,
  nonRounded: false,
  isCircular: false
};
var _default = Paper;
exports["default"] = _default;