"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TriggerPop = _interopRequireDefault(require("../_TriggerPop"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Popover component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Popover =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Popover, _Component);

  function Popover(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Popover);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Popover)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      _this.popInstance && _this.popInstance.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearCloseTimeout", function () {
      if (_this.closeTimeout) {
        clearTimeout(_this.closeTimeout);
        _this.closeTimeout = null;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function () {
      _this.clearCloseTimeout();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      var onRequestClose = _this.props.onRequestClose;

      _this.clearCloseTimeout();

      _this.closeTimeout = setTimeout(function () {
        onRequestClose && onRequestClose(e);
      }, 1000 / 6);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function (el) {
      var triggerEl = _this.props.triggerEl;

      _Event["default"].addEvent(triggerEl, 'mouseover', _this.handleMouseOver);

      _Event["default"].addEvent(triggerEl, 'mouseout', _this.handleMouseOut);

      _Event["default"].addEvent(el, 'mouseover', _this.handleMouseOver);

      _Event["default"].addEvent(el, 'mouseout', _this.handleMouseOut);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function (el) {
      var triggerEl = _this.props.triggerEl;

      _Event["default"].removeEvent(triggerEl, 'mouseover', _this.handleMouseOver);

      _Event["default"].removeEvent(triggerEl, 'mouseout', _this.handleMouseOut);

      _Event["default"].removeEvent(el, 'mouseover', _this.handleMouseOver);

      _Event["default"].removeEvent(el, 'mousemove', _this.handleMouseOut);
    });
    _this.closeTimeout = null;
    _this.pop = (0, _react.createRef)();
    _this.popInstance = null;
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(Popover, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.popInstance = this.pop && this.pop.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearCloseTimeout();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          contentClassName = _this$props.contentClassName,
          onRequestClose = _this$props.onRequestClose,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "contentClassName", "onRequestClose"]);
      return _react["default"].createElement(_TriggerPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('popover', (0, _defineProperty2["default"])({}, className, className)),
        contentClassName: (0, _classnames["default"])('popover-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName)),
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }));
    }
  }]);
  return Popover;
}(_react.Component);

(0, _defineProperty2["default"])(Popover, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Popover, "Theme", _Theme["default"]);
Popover.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,

  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,

  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,

  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The popover alignment.The value can be Popover.Position.LEFT or Popover.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true, popover will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,

  /**
   * The function of popover render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of popover rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of popover destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of popover destroyed.
   */
  onDestroyed: _propTypes["default"].func,

  /**
   * Callback function fired when the popover is requested to be closed.
   */
  onRequestClose: _propTypes["default"].func,

  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func
};
Popover.defaultProps = {
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  isBlurClose: true,
  shouldFollowScroll: false,
  resetPositionWait: 250,
  showModal: false
};
var _default = Popover;
exports["default"] = _default;