"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _PortalManagement = _interopRequireDefault(require("../_vendors/PortalManagement"));

/**
 * @file Portal component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Portal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Portal, _Component);

  function Portal(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Portal);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Portal)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderWrapper", function () {
      if (_this.wrapper) {
        return _this.wrapper;
      }

      var _this$props = _this.props,
          className = _this$props.className,
          parentEl = _this$props.parentEl,
          children = _this$props.children,
          visible = _this$props.visible,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "parentEl", "children", "visible"]);

      if (!parentEl) {
        return null;
      }

      _this.wrapper = document.createElement('div');
      _this.wrapper.className = (0, _classnames["default"])('portal', (0, _defineProperty2["default"])({}, className, className));

      for (var key in restProps) {
        _this.wrapper[key] = restProps[key];
      } // handle all portals in portalManagement


      _PortalManagement["default"].push(parentEl, _this.wrapper);

      return parentEl.appendChild(_this.wrapper);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderPortal", function () {
      if (!_this.renderWrapper()) {
        return null;
      }

      return _this.portal = (0, _reactDom.createPortal)(_this.props.children, _this.wrapper);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "unmountWrapper", function () {
      var parentEl = _this.props.parentEl;

      if (_this.wrapper && parentEl) {
        parentEl.removeChild(_this.wrapper); // handle all portals in portalManagement

        _PortalManagement["default"].pop(parentEl, _this.wrapper);

        _this.wrapper = null;
      }
    });
    _this.wrapper = null;
    _this.portal = null;
    return _this;
  }
  /**
   * render portal element to dom and return it
   * @returns {*}
   */


  (0, _createClass2["default"])(Portal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (!this.props.visible) {
        this.unmountWrapper();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmountWrapper();
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.visible ? this.renderPortal() : null;
    }
  }]);
  return Portal;
}(_react.Component);

Portal.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  visible: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object
};
Portal.defaultProps = {
  visible: false,
  parentEl: document.body
};
var _default = Portal;
exports["default"] = _default;