"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file Radio component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Radio =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Radio, _Component);

  function Radio(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Radio);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Radio)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          onClick = _this$props.onClick;

      if (disabled) {
        return;
      }

      onClick && onClick(e);
      var checked = _this.state.checked;

      if (checked) {
        var onCheck = _this.props.onCheck;
        onCheck && onCheck(e);
        return;
      }

      _this.setState({
        checked: true
      }, function () {
        var _this$props2 = _this.props,
            onChange = _this$props2.onChange,
            onCheck = _this$props2.onCheck;
        onChange && onChange(true);
        onCheck && onCheck(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      if (_this.props.disabled) {
        return;
      }

      _this.radioIconInstance && _this.radioIconInstance.startRipple(e);

      _this.handleClick();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseUp", function (e) {
      if (_this.props.disabled) {
        return;
      }

      _this.radioIconInstance && _this.radioIconInstance.endRipple(e);
    });
    _this.radioIcon = (0, _react.createRef)();
    _this.radioIconInstance = null;
    _this.state = {
      checked: !!props.checked
    };
    return _this;
  }

  (0, _createClass2["default"])(Radio, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.radioIconInstance = this.radioIcon && this.radioIcon.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          theme = _this$props3.theme,
          name = _this$props3.name,
          label = _this$props3.label,
          value = _this$props3.value,
          uncheckedIconCls = _this$props3.uncheckedIconCls,
          checkedIconCls = _this$props3.checkedIconCls,
          disabled = _this$props3.disabled,
          disableTouchRipple = _this$props3.disableTouchRipple,
          tip = _this$props3.tip,
          tipPosition = _this$props3.tipPosition,
          checked = this.state.checked;
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        position: tipPosition
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('radio', (_classNames = {
          activated: checked
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled
      }, name ? _react["default"].createElement("input", {
        className: "hidden-radio",
        type: "radio",
        name: name,
        value: value,
        checked: checked,
        onChange: function onChange() {}
      }) : null, _react["default"].createElement("div", {
        className: "radio-icon-wrapper",
        onClick: this.handleClick
      }, _react["default"].createElement(_IconButton["default"], {
        ref: this.radioIcon,
        className: "radio-bg-icon",
        iconCls: uncheckedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      }), _react["default"].createElement(_IconButton["default"], {
        className: "radio-icon",
        iconCls: checkedIconCls,
        disabled: disabled,
        disableTouchRipple: disableTouchRipple
      })), label ? _react["default"].createElement("div", {
        className: "radio-label",
        onMouseDown: this.handleMouseDown,
        onMouseUp: this.handleMouseUp,
        onMouseLeave: this.handleMouseUp
      }, label) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        checked: _ComponentUtil["default"].getDerivedState(props, state, 'checked')
      };
    }
  }]);
  return Radio;
}(_react.Component);

(0, _defineProperty2["default"])(Radio, "Theme", _Theme["default"]);
Radio.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The Radio theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The name of the radio.
   */
  name: _propTypes["default"].string,

  /**
   * Label for radio.
   */
  label: _propTypes["default"].any,

  /**
   * Value for radio.
   */
  value: _propTypes["default"].any,

  /**
   * If true,the radio will be checked.
   */
  checked: _propTypes["default"].bool,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,

  /**
   * If true, the radio will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the element's ripple effect will be disabled.
   */
  disableTouchRipple: _propTypes["default"].bool,
  tip: _propTypes["default"].any,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * Callback function fired when the radio status change.
   */
  onChange: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onClick: _propTypes["default"].func
};
Radio.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  value: '',
  checked: false,
  uncheckedIconCls: 'far fa-circle',
  checkedIconCls: 'fas fa-dot-circle',
  disabled: false,
  disableTouchRipple: false,
  tipPosition: _Position["default"].BOTTOM
};
var _default = Radio;
exports["default"] = _default;