"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Radio = _interopRequireDefault(require("../Radio"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file RadioGroup component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var RadioGroup =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(RadioGroup, _Component);

  function RadioGroup(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, RadioGroup);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(RadioGroup)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (item) {
      _this.setState({
        value: item.value
      }, function () {
        !_this.props.disabled && _this.props.onChange && _this.props.onChange(item.value);
      });
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(RadioGroup, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.state.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          theme = _this$props.theme,
          name = _this$props.name,
          uncheckedIconCls = _this$props.uncheckedIconCls,
          checkedIconCls = _this$props.checkedIconCls,
          disabled = _this$props.disabled,
          data = _this$props.data,
          _onCheck = _this$props.onCheck,
          value = this.state.value;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('radio-group', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, data && data.map(function (item, index) {
        return _react["default"].createElement(_Radio["default"], {
          key: index,
          className: item.className ? item.className : '',
          style: item.style,
          uncheckedIconCls: item.uncheckedIconCls || uncheckedIconCls,
          checkedIconCls: item.checkedIconCls || checkedIconCls,
          theme: item.theme || theme,
          name: name,
          label: item.label,
          value: item.value,
          checked: item.value === value,
          disabled: disabled || item.disabled,
          tip: item.tip,
          tipPosition: item.tipPosition,
          onChange: function onChange() {
            return _this2.handleChange(item);
          },
          onCheck: function onCheck(e) {
            return _onCheck && _onCheck(item, e);
          }
        });
      }));
    }
  }]);
  return RadioGroup;
}(_react.Component);

(0, _defineProperty2["default"])(RadioGroup, "Theme", _Theme["default"]);
RadioGroup.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The RadioGroup theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The name of Radio.
   */
  name: _propTypes["default"].string,

  /**
   * The data of GroupRadio.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of Radio component.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of Radio component.
     */
    style: _propTypes["default"].object,

    /**
     * The RadioGroup theme.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The label text of Radio component.
     */
    label: _propTypes["default"].any,

    /**
     * The value of Radio component.
     */
    value: _propTypes["default"].any,

    /**
     * If true,the Radio will be disabled.
     */
    disabled: _propTypes["default"].bool,
    tip: _propTypes["default"].any,
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"]))
  })).isRequired,

  /**
   * The value of RadioGroup component.
   */
  value: _propTypes["default"].any,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,

  /**
   * If true,the RadioGroup will be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * Callback function fired when the value of RadioGroup changed.
   */
  onChange: _propTypes["default"].func,
  onCheck: _propTypes["default"].func
};
RadioGroup.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  name: '',
  data: [],
  uncheckedIconCls: 'far fa-circle',
  checkedIconCls: 'fas fa-dot-circle',
  disabled: false
};
var _default = RadioGroup;
exports["default"] = _default;