"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file SpanLoading component
 * @author wendy(wendy.wei@derbysoft.com)
 */
var SpanLoading =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(SpanLoading, _Component);

  function SpanLoading(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, SpanLoading);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(SpanLoading)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    _this.state = {
      spanning: props.spanning
    };
    return _this;
  }

  (0, _createClass2["default"])(SpanLoading, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var spanning = nextProps.spanning;
      var delay = this.props.delay;

      if (spanning && delay && !isNaN(Number(delay))) {
        this.delayTimeout = setTimeout(function () {
          return _this2.setState({
            spanning: spanning
          });
        }, delay);
      } else {
        this.setState({
          spanning: spanning
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.delayTimeout && clearTimeout(this.delayTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          description = _this$props.description,
          size = _this$props.size,
          children = _this$props.children,
          spanning = this.state.spanning;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('span-loading', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "span-loading-".concat(size), size), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }, spanning ? _react["default"].createElement("span", {
        className: "span-loading-dot ".concat(size ? size : '')
      }, _react["default"].createElement("i", null), _react["default"].createElement("i", null), _react["default"].createElement("i", null), _react["default"].createElement("i", null)) : null, children, description ? _react["default"].createElement("div", {
        className: "span-loading-text"
      }, description) : null);
    }
  }]);
  return SpanLoading;
}(_react.Component);

SpanLoading.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * If true,will show a span loading animation.
   */
  spanning: _propTypes["default"].bool,

  /**
   * Set the tip text,there will be a description under the loading.
   */
  tip: _propTypes["default"].string,

  /**
   * Set the size of loading,can use small or large.
   */
  size: _propTypes["default"].string,

  /**
   * Set the delay time of loading animation.
   */
  delay: _propTypes["default"].number,
  description: _propTypes["default"].any
};
SpanLoading.defaultProps = {
  spanning: true,
  tip: '',
  type: ''
};
var _default = SpanLoading;
exports["default"] = _default;