"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file Switcher component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Switcher =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Switcher, _Component);

  function Switcher(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Switcher);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Switcher)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          isLoading = _this$props.isLoading,
          beforeChange = _this$props.beforeChange,
          onClick = _this$props.onClick;

      if (disabled || isLoading) {
        return;
      }

      onClick && onClick(e);

      var value = !_this.state.value,
          callback = function callback() {
        _this.setState({
          value: value
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(value, e);
        });
      };

      if (beforeChange) {
        beforeChange(value) !== false && callback();
      } else {
        callback();
      }
    });
    _this.state = {
      value: !!props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(Switcher, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          theme = _this$props2.theme,
          disabled = _this$props2.disabled,
          isLoading = _this$props2.isLoading,
          size = _this$props2.size,
          labelVisible = _this$props2.labelVisible,
          tip = _this$props2.tip,
          triggerEl = _this$props2.triggerEl,
          parentEl = _this$props2.parentEl,
          tipPosition = _this$props2.tipPosition,
          beforeChange = _this$props2.beforeChange,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["className", "style", "theme", "disabled", "isLoading", "size", "labelVisible", "tip", "triggerEl", "parentEl", "tipPosition", "beforeChange"]),
          value = this.state.value;
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        triggerEl: triggerEl,
        parentEl: parentEl,
        position: tipPosition
      }, _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('switcher', (_classNames = {
          activated: value,
          small: size === Switcher.Size.SMALL
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled || isLoading,
        onClick: this.handleClick
      }), labelVisible ? _react["default"].createElement("div", {
        className: "switcher-label"
      }) : null, _react["default"].createElement(_IconButton["default"], {
        className: "switcher-slider-wrapper",
        disableTouchRipple: disabled || isLoading
      }, _react["default"].createElement("div", {
        className: "switcher-slider"
      }, isLoading ? _react["default"].createElement(_CircularLoading["default"], null) : null))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return Switcher;
}(_react.Component);

(0, _defineProperty2["default"])(Switcher, "Size", {
  DEFAULT: '',
  SMALL: 'small'
});
(0, _defineProperty2["default"])(Switcher, "Theme", _Theme["default"]);
Switcher.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The Switcher theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * If true,the switcher will be in active status.
   */
  value: _propTypes["default"].bool,

  /**
   * Disables the switcher if set to true.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the switcher will be have loading effect.
   */
  isLoading: _propTypes["default"].bool,
  labelVisible: _propTypes["default"].bool,

  /**
   * The size of switcher.The value can be small or default.
   */
  size: _propTypes["default"].oneOf(_Util["default"].enumerateValue(Switcher.Size)),
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerEl: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,

  /**
   * Callback function fired when the switcher touch-tapped.
   */
  onClick: _propTypes["default"].func,

  /**
   * Callback function fired before the switcher touch-tapped.
   */
  beforeChange: _propTypes["default"].func,

  /**
   * Callback function fired when the switcher touch-tapped.
   */
  onChange: _propTypes["default"].func
};
Switcher.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  value: false,
  disabled: false,
  isLoading: false,
  labelVisible: false,
  size: Switcher.Size.DEFAULT,
  tipPosition: _Position["default"].BOTTOM
};
var _default = Switcher;
exports["default"] = _default;