"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _FlatButton = _interopRequireDefault(require("../FlatButton"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file Tab component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tab =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tab, _Component);

  function Tab(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Tab);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tab)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabClick", function (item, activatedIndex) {
      _this.setState({
        activatedIndex: activatedIndex
      }, function () {
        item.onActive && item.onActive(item, activatedIndex);
        var _this$props = _this.props,
            onTabClick = _this$props.onTabClick,
            onIndexChange = _this$props.onIndexChange;
        onTabClick && onTabClick(item, activatedIndex);
        onIndexChange && onIndexChange(activatedIndex, item);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRenderer", function (item) {
      if (!item || !item.renderer) {
        return null;
      }

      return typeof item.renderer === 'function' ? item.renderer(item) : item.renderer;
    });
    _this.state = {
      activatedIndex: props.activatedIndex
    };
    return _this;
  }

  (0, _createClass2["default"])(Tab, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          isTabFullWidth = _this$props2.isTabFullWidth,
          tabs = _this$props2.tabs,
          isAnimated = _this$props2.isAnimated,
          activatedIndex = this.state.activatedIndex,
          tabWidthPerCent = 100 / tabs.length;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('tab', (0, _defineProperty2["default"])({
          animated: isAnimated
        }, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('tabs', {
          'auto-width': !isTabFullWidth
        })
      }, tabs && tabs.map(function (item, index) {
        var renderer = item.renderer,
            onActive = item.onActive,
            restProps = (0, _objectWithoutProperties2["default"])(item, ["renderer", "onActive"]);
        return _react["default"].createElement(_FlatButton["default"], (0, _extends2["default"])({}, restProps, {
          key: index,
          className: (0, _classnames["default"])('tab-button', {
            activated: activatedIndex === index
          }),
          style: {
            width: isTabFullWidth ? "".concat(tabWidthPerCent, "%") : 'auto'
          },
          onClick: function onClick() {
            return _this2.handleTabClick(item, index);
          }
        }));
      }), isTabFullWidth ? _react["default"].createElement("div", {
        className: "ink-bar",
        style: {
          width: "".concat(tabWidthPerCent, "%"),
          transform: "translate(".concat(activatedIndex * 100, "%, 0)")
        }
      }) : null), _react["default"].createElement("div", {
        className: "tab-content-wrapper"
      }, isAnimated ? _react["default"].createElement("div", {
        className: "tab-content-scroller",
        style: {
          width: "".concat(tabs.length * 100, "%"),
          transform: "translate(".concat(-activatedIndex * tabWidthPerCent, "%, 0)")
        }
      }, tabs && tabs.map(function (item, index) {
        return _react["default"].createElement("div", {
          key: index,
          className: "tab-content",
          style: {
            width: "".concat(tabWidthPerCent, "%")
          }
        }, _this2.getRenderer(item));
      })) : _react["default"].createElement("div", {
        className: "tab-content"
      }, tabs && this.getRenderer(tabs[activatedIndex]))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        activatedIndex: _ComponentUtil["default"].getDerivedState(props, state, 'activatedIndex')
      };
    }
  }]);
  return Tab;
}(_react.Component);

Tab.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Children passed into the TabsItem.
   */
  tabs: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The text value of the tab.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),

    /**
     * If true, the tab will be disabled.
     */
    disabled: _propTypes["default"].bool,

    /**
     * If true,the tab will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,

    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,

    /**
     * Use this property to display an icon.It will display on the left.
     */
    iconCls: _propTypes["default"].string,

    /**
     * The position of the icon.
     */
    iconPosition: _propTypes["default"].string,

    /**
     * The render content in tab.
     */
    renderer: _propTypes["default"].any,

    /**
     * Callback function fired when click onActive tab.
     */
    onActive: _propTypes["default"].func
  })).isRequired,

  /**
   * Activated tab index.
   */
  activatedIndex: _propTypes["default"].number,

  /**
   * If true,the tabs is FullWidth.
   */
  isTabFullWidth: _propTypes["default"].bool,
  isAnimated: _propTypes["default"].bool,
  onIndexChange: _propTypes["default"].func,
  onTabClick: _propTypes["default"].func
};
Tab.defaultProps = {
  tabs: [],
  activatedIndex: 0,
  isTabFullWidth: true,
  isAnimated: true
};
var _default = Tab;
exports["default"] = _default;