"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TableContent = _interopRequireDefault(require("../_TableContent"));

var _TablePagination = _interopRequireDefault(require("../_TablePagination"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

/**
 * @file Table component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
// import Header from '../_TableHeader';
// import Footer from '../_TableFooter';
var Table =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Table, _Component);

  function Table(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Table);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Table)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "fixLayout", function () {
      _this.content && _this.content.current && _this.content.current.fixLayout();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceFixLayout", function () {
      _this.content && _this.content.current && _this.content.current.debounceFixLayout();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "collapseAllRows", function () {
      _this.setState({
        expandRows: []
      }, function () {
        var onExpandChange = _this.props.onExpandChange;
        onExpandChange && onExpandChange([]);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInit", function () {
      _this.state.isInitialing && _this.setState({
        isInitialing: false
      }, function () {
        var onInit = _this.props.onInit;
        onInit && onInit();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value, rowIndex) {
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value, rowIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSortChange", function (sorting) {
      _this.setState({
        sorting: sorting
      }, function () {
        var onSortChange = _this.props.onSortChange;
        onSortChange && onSortChange(sorting);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePaginationChange", function (pagination) {
      _this.setState(pagination, function () {
        var onPaginationChange = _this.props.onPaginationChange;
        onPaginationChange && onPaginationChange(pagination);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExpandChange", function (expandRows, callback) {
      _this.setState({
        expandRows: expandRows
      }, function () {
        var onExpandChange = _this.props.onExpandChange;
        onExpandChange && onExpandChange(expandRows);
        callback && callback();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRowHover", function (hoverRowIndex) {
      _this.setState({
        hoverRowIndex: hoverRowIndex
      });
    });
    _this.content = (0, _react.createRef)();
    _this.state = {
      isInitialing: props.hasInitFadeOut,
      sorting: props.sorting,
      page: props.page,
      pageSize: props.pageSize,
      expandRows: props.expandRows,
      value: props.value,
      hoverRowIndex: null
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(Table, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.debounceFixLayout();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          selectMode = _this$props.selectMode,
          data = _this$props.data,
          isPaginated = _this$props.isPaginated,
          pageSizes = _this$props.pageSizes,
          useFullPagination = _this$props.useFullPagination,
          pageSizeValueField = _this$props.pageSizeValueField,
          pageSizeDisplayField = _this$props.pageSizeDisplayField,
          paginationSelectionVisible = _this$props.paginationSelectionVisible,
          paginationTotalVisible = _this$props.paginationTotalVisible,
          paginationPageVisible = _this$props.paginationPageVisible,
          paginationPageSizeVisible = _this$props.paginationPageSizeVisible,
          paginationPageSizeRightIconCls = _this$props.paginationPageSizeRightIconCls,
          paginationPrevIconCls = _this$props.paginationPrevIconCls,
          paginationNextIconCls = _this$props.paginationNextIconCls,
          paginationFirstIconCls = _this$props.paginationFirstIconCls,
          paginationLastIconCls = _this$props.paginationLastIconCls,
          paginationSelectionRenderer = _this$props.paginationSelectionRenderer,
          paginationTotalRenderer = _this$props.paginationTotalRenderer,
          onPageChange = _this$props.onPageChange,
          onPageSizeChange = _this$props.onPageSizeChange,
          hasInitFadeOut = _this$props.hasInitFadeOut,
          propsPageSize = _this$props.pageSize,
          onPaginationChange = _this$props.onPaginationChange,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "selectMode", "data", "isPaginated", "pageSizes", "useFullPagination", "pageSizeValueField", "pageSizeDisplayField", "paginationSelectionVisible", "paginationTotalVisible", "paginationPageVisible", "paginationPageSizeVisible", "paginationPageSizeRightIconCls", "paginationPrevIconCls", "paginationNextIconCls", "paginationFirstIconCls", "paginationLastIconCls", "paginationSelectionRenderer", "paginationTotalRenderer", "onPageChange", "onPageSizeChange", "hasInitFadeOut", "pageSize", "onPaginationChange"]),
          _this$state = this.state,
          isInitialing = _this$state.isInitialing,
          sorting = _this$state.sorting,
          page = _this$state.page,
          pageSize = _this$state.pageSize,
          expandRows = _this$state.expandRows,
          value = _this$state.value,
          hoverRowIndex = _this$state.hoverRowIndex;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('table', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, _react["default"].createElement(_TableContent["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.content,
        data: data,
        sorting: sorting,
        isPaginated: isPaginated,
        page: page,
        pageSize: pageSize,
        expandRows: expandRows,
        value: value,
        hoverRowIndex: hoverRowIndex,
        selectMode: selectMode,
        isInitialing: isInitialing,
        onInit: this.handleInit,
        onChange: this.handleChange,
        onSortChange: this.handleSortChange,
        onExpandChange: this.handleExpandChange,
        onRowHover: this.handleRowHover
      })), isPaginated ? _react["default"].createElement(_TablePagination["default"], {
        selectMode: selectMode,
        data: data,
        page: page,
        pageSize: pageSize,
        pageSizes: pageSizes,
        value: value,
        useFullPagination: useFullPagination,
        pageSizeValueField: pageSizeValueField,
        pageSizeDisplayField: pageSizeDisplayField,
        paginationSelectionVisible: paginationSelectionVisible,
        paginationTotalVisible: paginationTotalVisible,
        paginationPageVisible: paginationPageVisible,
        paginationPageSizeVisible: paginationPageSizeVisible,
        paginationPageSizeRightIconCls: paginationPageSizeRightIconCls,
        paginationPrevIconCls: paginationPrevIconCls,
        paginationNextIconCls: paginationNextIconCls,
        paginationFirstIconCls: paginationFirstIconCls,
        paginationLastIconCls: paginationLastIconCls,
        paginationSelectionRenderer: paginationSelectionRenderer,
        paginationTotalRenderer: paginationTotalRenderer,
        onPageChange: onPageChange,
        onPageSizeChange: onPageSizeChange,
        onPaginationChange: this.handlePaginationChange
      }) : null, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('table-init-loading-wrapper', {
          'fade-out': !isInitialing
        })
      }, isInitialing ? _react["default"].createElement(_CircularLoading["default"], {
        className: "table-init-loading"
      }) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var page = _ComponentUtil["default"].getDerivedState(props, state, 'page'),
          pageSize = _ComponentUtil["default"].getDerivedState(props, state, 'pageSize');

      return {
        prevProps: props,
        sorting: _ComponentUtil["default"].getDerivedState(props, state, 'sorting'),
        page: _TableCalculation["default"].handlePage(page, pageSize, props.data),
        pageSize: pageSize,
        expandRows: _ComponentUtil["default"].getDerivedState(props, state, 'expandRows'),
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return Table;
}(_react.Component);

(0, _defineProperty2["default"])(Table, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(Table, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Table, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Table, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Table, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Table, "SortingType", _SortingType["default"]);
Table.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  idProp: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  hasInitFadeOut: _propTypes["default"].bool,
  noDataText: _propTypes["default"].string,

  /**
   * expand
   */
  expandRows: _propTypes["default"].array,
  expandIconCls: _propTypes["default"].string,

  /**
   * multi select
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  selectColumn: _propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' )
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"]))
  }),
  isSelectRecursive: _propTypes["default"].bool,
  selectUncheckedIconCls: _propTypes["default"].string,
  selectCheckedIconCls: _propTypes["default"].string,
  selectIndeterminateIconCls: _propTypes["default"].string,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  autoSorting: _propTypes["default"].bool,
  sortingFunc: _propTypes["default"].func,

  /**
   * pagination
   */
  isPaginated: _propTypes["default"].bool,
  page: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  pageSizes: _propTypes["default"].array,
  pageSizeValueField: _propTypes["default"].string,
  pageSizeDisplayField: _propTypes["default"].string,
  useFullPagination: _propTypes["default"].bool,
  paginationSelectionVisible: _propTypes["default"].bool,
  paginationTotalVisible: _propTypes["default"].bool,
  paginationPageVisible: _propTypes["default"].bool,
  paginationPageSizeVisible: _propTypes["default"].bool,
  paginationPageSizeRightIconCls: _propTypes["default"].string,
  paginationPrevIconCls: _propTypes["default"].string,
  paginationNextIconCls: _propTypes["default"].string,
  paginationFirstIconCls: _propTypes["default"].string,
  paginationLastIconCls: _propTypes["default"].string,
  paginationSelectionRenderer: _propTypes["default"].func,
  paginationTotalRenderer: _propTypes["default"].func,

  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,

  /**
   * fixed
   */
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,

  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),

  /**
   * callback
   */
  onInit: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onSelectAll: _propTypes["default"].func,
  onDeselectAll: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onDataUpdate: _propTypes["default"].func,
  onPaginationChange: _propTypes["default"].func,
  onPageChange: _propTypes["default"].func,
  onPageSizeChange: _propTypes["default"].func
};
Table.defaultProps = {
  disabled: false,
  hasInitFadeOut: true,
  noDataText: 'No Data',

  /**
   * expand
   */
  expandRows: [],
  expandIconCls: 'fas fa-chevron-right',

  /**
   * multi select
   */
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  isSelectRecursive: false,
  selectUncheckedIconCls: 'far fa-square',
  selectCheckedIconCls: 'fas fa-check-square',
  selectIndeterminateIconCls: 'fas fa-minus-square',

  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  autoSorting: true,

  /**
   * pagination
   */
  isPaginated: true,
  page: 0,
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  useFullPagination: false,
  pageSizeValueField: 'value',
  pageSizeDisplayField: 'text',
  paginationSelectionVisible: false,
  paginationTotalVisible: true,
  paginationPageVisible: true,
  paginationPageSizeVisible: true,
  paginationPageSizeRightIconCls: 'fas fa-angle-down',
  paginationPrevIconCls: 'fas fa-angle-left',
  paginationNextIconCls: 'fas fa-angle-right',
  paginationFirstIconCls: 'fas fa-angle-double-left',
  paginationLastIconCls: 'fas fa-angle-double-right',

  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,

  /**
   * fixed
   */
  isHeadFixed: false,
  isFootFixed: false
};
var _default = Table;
exports["default"] = _default;