"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _FieldMsg = _interopRequireDefault(require("../FieldMsg"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _FieldType = _interopRequireDefault(require("../_statics/FieldType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Valid = _interopRequireDefault(require("../_vendors/Valid"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file TextField component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var TextField =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TextField, _Component);

  function TextField(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TextField);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TextField)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      _this.inputEl && _this.inputEl.focus();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blur", function () {
      _this.inputEl && _this.inputEl.blur();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (e) {
      var _this$props = _this.props,
          onValid = _this$props.onValid,
          onInvalid = _this$props.onInvalid,
          value = e.target.value,
          invalidMsgs = _Valid["default"].fieldValid(value, _this.props);

      _this.setState({
        value: value,
        invalidMsgs: invalidMsgs
      }, function () {
        _this.props.onChange && _this.props.onChange(value, e);
        invalidMsgs && invalidMsgs.length > 0 ? onInvalid && onInvalid() : onValid && onValid();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyDown", function (e) {
      var onKeyDown = _this.props.onKeyDown,
          value = _this.state.value;
      onKeyDown && onKeyDown(e, value);

      if (e.keyCode === 13) {
        var onPressEnter = _this.props.onPressEnter;
        onPressEnter && onPressEnter(e, value);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearValue", function () {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          clearButtonVisible = _this$props2.clearButtonVisible,
          onClear = _this$props2.onClear,
          onChange = _this$props2.onChange,
          onValid = _this$props2.onValid,
          onInvalid = _this$props2.onInvalid,
          invalidMsgs = _Valid["default"].fieldValid('', _this.props);

      !disabled && clearButtonVisible && _this.setState({
        value: '',
        invalidMsgs: invalidMsgs
      }, function () {
        _this.focus();

        onClear && onClear();
        onChange && onChange('');
        invalidMsgs && invalidMsgs.length > 0 ? onInvalid && onInvalid() : onValid && onValid();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePasswordVisible", function () {
      var _this$props3 = _this.props,
          disabled = _this$props3.disabled,
          passwordButtonVisible = _this$props3.passwordButtonVisible,
          onPasswordVisible = _this$props3.onPasswordVisible,
          onPasswordInvisible = _this$props3.onPasswordInvisible,
          passwordVisible = !_this.state.passwordVisible;
      !disabled && passwordButtonVisible && _this.setState({
        passwordVisible: passwordVisible
      }, function () {
        _this.focus();

        passwordVisible ? onPasswordVisible && onPasswordVisible() : onPasswordInvisible && onPasswordInvisible();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      _this.setState({
        infoVisible: true,
        errorVisible: true
      }, function () {
        var onMouseOver = _this.props.onMouseOver,
            value = _this.state.value;
        onMouseOver && onMouseOver(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      _this.setState({
        infoVisible: false,
        errorVisible: false
      }, function () {
        var onMouseOut = _this.props.onMouseOut,
            value = _this.state.value;
        onMouseOut && onMouseOut(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFocus", function (e) {
      _this.setState({
        isFocused: true
      }, function () {
        var _this$props4 = _this.props,
            isFocusedSelectAll = _this$props4.isFocusedSelectAll,
            onFocus = _this$props4.onFocus,
            value = _this.state.value;
        onFocus && onFocus(e, value);
        isFocusedSelectAll && _this.inputEl && _this.inputEl.setSelectionRange(0, value ? value.length : 0);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBlur", function (e) {
      if (_this.clearButton && _this.clearButton.current && e.relatedTarget && e.relatedTarget == (0, _reactDom.findDOMNode)(_this.clearButton.current)) {
        return;
      }

      _this.setState({
        isFocused: false
      }, function () {
        var onBlur = _this.props.onBlur,
            value = _this.state.value;
        onBlur && onBlur(e, value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRightIconClick", function (e) {
      var onRightIconClick = _this.props.onRightIconClick,
          value = _this.state.value;
      onRightIconClick && onRightIconClick(e, value);
    });
    _this.input = (0, _react.createRef)();
    _this.inputEl = null;
    _this.clearButton = (0, _react.createRef)();
    _this.state = {
      value: props.value,
      isFocused: props.autoFocus ? true : false,
      passwordVisible: false,
      infoVisible: false,
      errorVisible: false,
      invalidMsgs: ''
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(TextField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.inputEl = this.input && this.input.current;

      if (this.props.autoFocus === true) {
        this.inputEl.focus();
      }
    }
  }, {
    key: "render",

    /* eslint-disable complexity */
    value: function render() {
      var _this$props5 = this.props,
          children = _this$props5.children,
          className = _this$props5.className,
          triggerClassName = _this$props5.triggerClassName,
          placeholderClassName = _this$props5.placeholderClassName,
          style = _this$props5.style,
          theme = _this$props5.theme,
          type = _this$props5.type,
          iconCls = _this$props5.iconCls,
          disabled = _this$props5.disabled,
          infoMsg = _this$props5.infoMsg,
          placeholder = _this$props5.placeholder,
          clearButtonVisible = _this$props5.clearButtonVisible,
          rightIconCls = _this$props5.rightIconCls,
          passwordButtonVisible = _this$props5.passwordButtonVisible,
          fieldMsgVisible = _this$props5.fieldMsgVisible,
          maxLength = _this$props5.maxLength,
          isStrictMaxLength = _this$props5.isStrictMaxLength,
          parentEl = _this$props5.parentEl,
          onIconClick = _this$props5.onIconClick,
          onRightIconClick = _this$props5.onRightIconClick,
          v = _this$props5.value,
          autoFocus = _this$props5.autoFocus,
          pattern = _this$props5.pattern,
          patternInvalidMsg = _this$props5.patternInvalidMsg,
          isFocusedSelectAll = _this$props5.isFocusedSelectAll,
          onPressEnter = _this$props5.onPressEnter,
          onValid = _this$props5.onValid,
          onInvalid = _this$props5.onInvalid,
          onClear = _this$props5.onClear,
          onPasswordVisible = _this$props5.onPasswordVisible,
          onPasswordInvisible = _this$props5.onPasswordInvisible,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props5, ["children", "className", "triggerClassName", "placeholderClassName", "style", "theme", "type", "iconCls", "disabled", "infoMsg", "placeholder", "clearButtonVisible", "rightIconCls", "passwordButtonVisible", "fieldMsgVisible", "maxLength", "isStrictMaxLength", "parentEl", "onIconClick", "onRightIconClick", "value", "autoFocus", "pattern", "patternInvalidMsg", "isFocusedSelectAll", "onPressEnter", "onValid", "onInvalid", "onClear", "onPasswordVisible", "onPasswordInvisible"]),
          _this$state = this.state,
          value = _this$state.value,
          isFocused = _this$state.isFocused,
          passwordVisible = _this$state.passwordVisible,
          infoVisible = _this$state.infoVisible,
          errorVisible = _this$state.errorVisible,
          invalidMsgs = _this$state.invalidMsgs,
          isPassword = type === _FieldType["default"].PASSWORD,
          empty = !value || value.length <= 0;
      var inputType = type;

      if (inputType === _FieldType["default"].PASSWORD) {
        inputType = passwordVisible ? _FieldType["default"].TEXT : _FieldType["default"].PASSWORD;
      } else if (_Valid["default"].isNumberType(type)) {
        inputType = 'text';
      }

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('text-field', empty ? 'empty' : 'not-empty', invalidMsgs && invalidMsgs.length > 0 ? ' theme-error' : theme ? " theme-".concat(theme) : '', (0, _defineProperty2["default"])({
          password: isPassword,
          'has-icon': iconCls,
          'has-right-icon': rightIconCls,
          focused: isFocused,
          'has-clear-button': clearButtonVisible
        }, className, className)),
        style: style,
        disabled: disabled
      }, iconCls ? _react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-field-left-icon', {
          deactivated: !onIconClick
        }),
        iconCls: iconCls,
        disableTouchRipple: !onIconClick,
        onClick: onIconClick
      }) : null, placeholder !== '' && placeholder !== null && !isFocused && (value === '' || value === null) ? _react["default"].createElement("input", {
        className: (0, _classnames["default"])('text-field-placeholder', (0, _defineProperty2["default"])({}, placeholderClassName, placeholderClassName)),
        value: placeholder,
        disabled: true
      }) : null, _react["default"].createElement("input", (0, _extends2["default"])({}, restProps, {
        ref: this.input,
        className: (0, _classnames["default"])('text-field-input', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        type: inputType,
        value: value,
        disabled: disabled,
        maxLength: isStrictMaxLength ? maxLength : null,
        onChange: this.handleChange,
        onKeyDown: this.handleKeyDown,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      })), clearButtonVisible ? _react["default"].createElement(_IconButton["default"], {
        ref: this.clearButton,
        className: (0, _classnames["default"])('clear-icon', {
          hidden: disabled || !value || value.length < 1
        }),
        iconCls: "fas fa-times-circle",
        onClick: this.clearValue
      }) : null, isPassword && passwordButtonVisible ? _react["default"].createElement(_IconButton["default"], {
        className: "password-visible-icon",
        iconCls: passwordVisible ? 'fas fa-eye' : 'far fa-eye-slash',
        onClick: this.togglePasswordVisible
      }) : null, rightIconCls ? _react["default"].createElement(_IconButton["default"], {
        className: (0, _classnames["default"])('text-field-right-icon', {
          deactivated: !onRightIconClick
        }),
        rightIconCls: rightIconCls,
        disableTouchRipple: !onRightIconClick,
        onClick: this.handleRightIconClick
      }) : null, _react["default"].createElement(_FieldMsg["default"], {
        type: "info",
        msg: infoMsg,
        visible: !!(fieldMsgVisible && infoVisible && infoMsg),
        triggerEl: this.inputEl,
        parentEl: parentEl,
        position: _FieldMsg["default"].Position.TOP_LEFT
      }), _react["default"].createElement(_FieldMsg["default"], {
        type: "error",
        msg: invalidMsgs && invalidMsgs.join(', '),
        visible: !!(fieldMsgVisible && errorVisible && invalidMsgs && invalidMsgs.length > 0),
        triggerEl: this.inputEl,
        parentEl: parentEl
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return TextField;
}(_react.Component);

(0, _defineProperty2["default"])(TextField, "Type", _FieldType["default"]);
(0, _defineProperty2["default"])(TextField, "Theme", _Theme["default"]);
TextField.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the input element.
   */
  triggerClassName: _propTypes["default"].string,

  /**
   * The CSS class name of the placeholder element.
   */
  placeholderClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The TextField theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * Specifies the type of input to display such as "password" or "text".
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_FieldType["default"])),

  /**
   * The name of the text field.
   */
  name: _propTypes["default"].string,

  /**
   * The placeholder of the text field.
   */
  placeholder: _propTypes["default"].string,

  /**
   * The value of the TextField.Type can be string or number.
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,

  /**
   * Disables the textField if set to true.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the textField will can't editable.
   */
  readOnly: _propTypes["default"].bool,

  /**
   * If true,the textField will autoFocus.
   */
  autoFocus: _propTypes["default"].bool,

  /**
   * The message of the textField.
   */
  infoMsg: _propTypes["default"].string,
  isFocusedSelectAll: _propTypes["default"].bool,

  /**
   * If true,clearButton will display when the textField is not empty.
   */
  clearButtonVisible: _propTypes["default"].bool,

  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,

  /**
   * If true, passwordButton will display.
   */
  passwordButtonVisible: _propTypes["default"].bool,
  // valid

  /**
   * If true,the textField must be required.
   */
  required: _propTypes["default"].bool,

  /**
   * The maximum length of textField to enter.
   */
  maxLength: _propTypes["default"].number,

  /**
   * Maximum number of textField that can be entered.
   */
  max: _propTypes["default"].number,

  /**
   * Minimum number of textField that can be entered.
   */
  min: _propTypes["default"].number,

  /**
   * The matching rule of textField.
   */
  pattern: _propTypes["default"].object,

  /**
   * The invalid message of textField.
   */
  patternInvalidMsg: _propTypes["default"].string,
  isStrictMaxLength: _propTypes["default"].bool,
  fieldMsgVisible: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,

  /**
   * Callback function fired when the textField is changed.
   */
  onChange: _propTypes["default"].func,

  /**
   * Callback function fired when key down.
   */
  onKeyDown: _propTypes["default"].func,

  /**
   * Callback function fired when press enter.
   */
  onPressEnter: _propTypes["default"].func,

  /**
   * Callback function fired when textField valid.
   */
  onValid: _propTypes["default"].func,

  /**
   * Callback function fired when textField invalid.
   */
  onInvalid: _propTypes["default"].func,

  /**
   * Callback function fired when textField focus.
   */
  onFocus: _propTypes["default"].func,

  /**
   * Callback function fired when textField blur.
   */
  onBlur: _propTypes["default"].func,

  /**
   * Callback function fired when textField clear.
   */
  onClear: _propTypes["default"].func,

  /**
   * Callback function fired when password visible.
   */
  onPasswordVisible: _propTypes["default"].func,

  /**
   * Callback function fired when password invisible.
   */
  onPasswordInvisible: _propTypes["default"].func,
  onIconClick: _propTypes["default"].func,
  onRightIconClick: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
TextField.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  type: 'text',
  value: '',
  disabled: false,
  readOnly: false,
  autoFocus: false,
  isFocusedSelectAll: false,
  clearButtonVisible: true,
  passwordButtonVisible: true,
  // valid
  required: false,
  autoComplete: 'off',
  autoCorrect: 'off',
  autoCapitalize: 'off',
  spellCheck: 'false',
  isStrictMaxLength: true,
  fieldMsgVisible: false
};
var _default = TextField;
exports["default"] = _default;