"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TimelineItem = _interopRequireDefault(require("../_TimelineItem"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file TimeLine component
 * @author wendy(wendy.wei@derbysoft.com)
 */
var TimeLine =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TimeLine, _Component);

  function TimeLine(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, TimeLine);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TimeLine)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(TimeLine, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          style = _this$props.style,
          className = _this$props.className;
      return _react["default"].createElement("ul", {
        className: (0, _classnames["default"])('time-line', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, data && data.map(function (item, index) {
        return _react["default"].createElement(_TimelineItem["default"], {
          key: index,
          theme: item.theme,
          type: item.type,
          title: item.title,
          date: item.date,
          hasBorder: item.hasBorder,
          contentText: item.contentText,
          headerText: item.headerText
        });
      }));
    }
  }]);
  return TimeLine;
}(_react.Component);

(0, _defineProperty2["default"])(TimeLine, "Type", _TimelineItem["default"].Type);
(0, _defineProperty2["default"])(TimeLine, "Theme", _Theme["default"]);
TimeLine.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The items data.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The TimeLine theme.Can be primary,highlight,success,warning,error.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

    /**
     * The TimeLine type.Can be header or title.
     */
    type: _propTypes["default"].string,

    /**
     * The text value of TimeLine header.
     */
    headerText: _propTypes["default"].string,

    /**
     * The date value of TimeLine.
     */
    date: _propTypes["default"].string,

    /**
     * If true,the right content will have border style.
     */
    hasBorder: _propTypes["default"].bool,

    /**
     * The text value of right content.
     */
    contentText: _propTypes["default"].string
  })).isRequired
};
TimeLine.defaultProps = {
  hasBorder: true,
  title: '',
  type: ''
};
var _default = TimeLine;
exports["default"] = _default;