"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TriggerPop = _interopRequireDefault(require("../_TriggerPop"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Tip component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tip =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tip, _Component);

  function Tip(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, Tip);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tip)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(Tip, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          contentClassName = _this$props.contentClassName,
          parentEl = _this$props.parentEl,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "contentClassName", "parentEl"]);
      return _react["default"].createElement(_TriggerPop["default"], (0, _extends2["default"])({}, restProps, {
        parentEl: parentEl,
        className: (0, _classnames["default"])('tip', (0, _defineProperty2["default"])({}, className, className)),
        contentClassName: (0, _classnames["default"])('tip-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName))
      }));
    }
  }]);
  return Tip;
}(_react.Component);

(0, _defineProperty2["default"])(Tip, "Position", _Position["default"]);
Tip.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,

  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,

  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,

  /**
   * The popover alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true, menu will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,

  /**
   * The function of tip render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of tip rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of tip destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of tip destroyed.
   */
  onDestroyed: _propTypes["default"].func,

  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func
};
Tip.defaultProps = {
  theme: _Theme["default"].DARK,
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  shouldFollowScroll: false,
  resetPositionWait: 250,
  showModal: false
};
var _default = Tip;
exports["default"] = _default;