"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _Tip = _interopRequireDefault(require("../Tip"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file TipProvider component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
// components
// statics
// vendors
var TipProvider =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TipProvider, _Component);

  function TipProvider(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TipProvider);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TipProvider)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "show", function () {
      if (!_this.state.visible) {
        _this.setState({
          visible: true
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hide", function () {
      _this.setState({
        visible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      var children = _this.props.children;

      if (children && children.props && children.props.onMouseOver && typeof children.props.onMouseOver === 'function') {
        children.props.onMouseOver(e);
      }

      _this.show();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      var children = _this.props.children;

      if (children && children.props && children.props.onMouseOut && typeof children.props.onMouseOut === 'function') {
        children.props.onMouseOut(e);
      }

      _this.hide();
    });
    _this.trigger = (0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      visible: props.visible
    };
    return _this;
  }

  (0, _createClass2["default"])(TipProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          tipContent = _this$props.tipContent,
          parentEl = _this$props.parentEl,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["children", "tipContent", "parentEl"]),
          visible = this.state.visible;

      if (!tipContent) {
        return children;
      }

      return _react["default"].createElement(_react.Fragment, null, (0, _react.cloneElement)(children, {
        ref: this.trigger,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut
      }), _react["default"].createElement(_Tip["default"], (0, _extends2["default"])({}, restProps, {
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        visible: visible
      }), tipContent));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'visible')
      };
    }
  }]);
  return TipProvider;
}(_react.Component);

(0, _defineProperty2["default"])(TipProvider, "Position", _Position["default"]);
(0, _defineProperty2["default"])(TipProvider, "Theme", _Theme["default"]);
TipProvider.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,

  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,

  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,

  /**
   * The popover alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true, menu will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,

  /**
   * The function of tip render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of tip rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of tip destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of tip destroyed.
   */
  onDestroyed: _propTypes["default"].func,

  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  tipContent: _propTypes["default"].any
};
TipProvider.defaultProps = {
  theme: _Theme["default"].DARK,
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  shouldFollowScroll: false,
  resetPositionWait: 250,
  showModal: false
};
var _default = TipProvider;
exports["default"] = _default;