"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TransitionGroup = _interopRequireDefault(require("react-transition-group/TransitionGroup"));

var _Ripple = _interopRequireDefault(require("../_Ripple"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TouchRipple =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TouchRipple, _Component);

  function TouchRipple(_props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TouchRipple);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TouchRipple)).call.apply(_getPrototypeOf2, [this, _props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRippleStyle", function (e) {
      var displayCenter = _this.props.displayCenter,
          el = _reactDom["default"].findDOMNode((0, _assertThisInitialized2["default"])(_this)),
          elWidth = el.offsetWidth,
          elHeight = el.offsetHeight; // get pointer offset of el


      var pointerX, pointerY;

      if (!e || displayCenter) {
        pointerX = elWidth / 2;
        pointerY = elHeight / 2;
      } else {
        var _Dom$getOffset = _Dom["default"].getOffset(el),
            _top = _Dom$getOffset.top,
            _left = _Dom$getOffset.left;

        pointerX = e.pageX - _left;
        pointerY = e.pageY - _top;
      } // radius is the max distence


      var rippleRadius = Math.max(_Util["default"].getDiag(pointerX, pointerY), _Util["default"].getDiag(elWidth - pointerX, pointerY), _Util["default"].getDiag(elWidth - pointerX, elHeight - pointerY), _Util["default"].getDiag(pointerX, elHeight - pointerY));
      var rippleSize = rippleRadius * 2; // calculate offset

      var left = pointerX - rippleRadius;
      var top = pointerY - rippleRadius;
      return {
        height: rippleSize,
        width: rippleSize,
        top: top,
        left: left
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addRipple", function (e, props) {
      if (_this.ignoreNextMouseDown) {
        return;
      }

      props = props || {};
      _this.ignoreNextMouseDown = true;
      var ripples = _this.state.ripples;
      ripples.push(_objectSpread({}, props, {
        key: _this.nextKey++,
        style: _objectSpread({}, props.style, {}, _this.getRippleStyle(e))
      }));

      _this.setState({
        ripples: ripples
      }, function () {
        _this.ignoreNextMouseDown = false;
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeRipple", function () {
      _this.setState({
        ripples: []
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      _this.addRipple(e);
    });
    _this.ignoreNextMouseDown = false;
    _this.nextKey = 0;
    _this.state = {
      ripples: []
    };
    return _this;
  }

  (0, _createClass2["default"])(TouchRipple, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          duration = _this$props.duration,
          ripples = this.state.ripples;
      return _react["default"].createElement(_TransitionGroup["default"], {
        className: (0, _classnames["default"])('touch-ripple', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        onMouseDown: this.handleMouseDown,
        onMouseUp: this.removeRipple,
        onMouseLeave: this.removeRipple
      }, ripples && ripples.map(function (item, index) {
        return _react["default"].createElement(_Ripple["default"], (0, _extends2["default"])({}, item, {
          key: index,
          duration: duration
        }));
      }));
    }
  }]);
  return TouchRipple;
}(_react.Component);

TouchRipple.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  duration: _propTypes["default"].number,
  displayCenter: _propTypes["default"].bool
};
TouchRipple.defaultProps = {
  duration: 500,
  displayCenter: false
};
var _default = TouchRipple;
exports["default"] = _default;