"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _VerticalPointStepItem = _interopRequireDefault(require("../_VerticalPointStepItem"));

/**
 * @file VerticalPointStep component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var VerticalPointStep =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(VerticalPointStep, _Component);

  function VerticalPointStep(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, VerticalPointStep);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(VerticalPointStep)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (activatedStep) {
      var onChange = _this.props.onChange;

      _this.setState({
        activatedStep: activatedStep
      }, function () {
        onChange && onChange({
          activatedStep: activatedStep,
          finishedStep: _this.state.finishedStep
        });
      });
    });
    _this.state = {
      activatedStep: props.activatedStep,
      finishedStep: props.finishedStep
    };
    return _this;
  }

  (0, _createClass2["default"])(VerticalPointStep, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.activatedStep !== this.state.activatedStep || nextProps.finishedStep !== this.state.finishedStep) {
        this.setState({
          activatedStep: nextProps.activatedStep,
          finishedStep: nextProps.finishedStep
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          steps = _this$props.steps,
          disabled = _this$props.disabled,
          _this$state = this.state,
          activatedStep = _this$state.activatedStep,
          finishedStep = _this$state.finishedStep;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('vertical-point-step', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, steps && steps.map(function (item, index) {
        return _react["default"].createElement(_VerticalPointStepItem["default"], {
          key: index,
          index: index,
          className: item.className,
          style: item.style,
          activatedStep: activatedStep,
          finishedStep: finishedStep,
          value: item,
          isFirst: index === 0,
          isLast: index === steps.length - 1,
          disabled: disabled,
          onClick: _this2.handleClick
        });
      }));
    }
  }]);
  return VerticalPointStep;
}(_react.Component);

VerticalPointStep.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The render content of step.
   */
  steps: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of step element.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the step element.
     */
    style: _propTypes["default"].object,

    /**
     * The text value of step.
     */
    title: _propTypes["default"].string
  })).isRequired,

  /**
   * Sets the step as active.
   */
  activatedStep: _propTypes["default"].number,

  /**
   * The final step.
   */
  finishedStep: _propTypes["default"].number,
  disabled: _propTypes["default"].bool,

  /**
   * Callback function fired when step change.
   */
  onChange: _propTypes["default"].func
};
VerticalPointStep.defaultProps = {
  activatedStep: 0,
  finishedStep: 0,
  disabled: false
};
var _default = VerticalPointStep;
exports["default"] = _default;