"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Waterfall =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Waterfall, _Component);

  function Waterfall(_props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Waterfall);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Waterfall)).call.apply(_getPrototypeOf2, [this, _props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "initTempColumns", function (column) {
      if (!column || column.length < 1) {
        return;
      }

      var result = [];

      for (var i = 0; i < column; i++) {
        result.push({
          heightCount: 0,
          children: []
        });
      }

      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getMinHeightColumn", function (columns) {
      if (!columns || columns.length < 1) {
        return;
      }

      var minItem = columns[0],
          index = 0,
          min = minItem.heightCount;

      for (var i = 1, len = columns.length; i < len; i++) {
        if (columns[i].heightCount < min) {
          minItem = columns[i];
          index = i;
          min = columns[i].heightCount;
        }
      }

      return {
        item: minItem,
        index: index,
        vslue: min
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "generateTempColumns", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

      var column = props.column,
          separator = props.separator,
          children = props.children,
          tempColumns = _this.initTempColumns(column);

      _react.Children.forEach(children, function (child, index) {
        var el = (0, _reactDom.findDOMNode)(_this.refs["waterfallTempChild".concat(index)]);

        if (el) {
          var elHeight = parseInt(getComputedStyle(el).height);

          if (!isNaN(elHeight)) {
            var result = _this.getMinHeightColumn(tempColumns);

            if (result) {
              var item = result.item,
                  columnNo = result.index,
                  no = item.children.length;
              item.heightCount += elHeight + (no === 0 ? 0 : separator);
              item.children.push((0, _react.cloneElement)(child, {
                key: "".concat(columnNo, "-").concat(no),
                style: _objectSpread({}, child.props.style, {
                  marginTop: no === 0 ? 0 : separator
                })
              }));
            }
          }
        }
      });

      return tempColumns;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderChildren", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

      var column = props.column,
          tempColumns = _this.generateTempColumns(props),
          columnStyle = {
        width: "".concat(100 / column, "%")
      },
          result = [];

      for (var i = 0; i < column; i++) {
        result.push(_react["default"].createElement("div", {
          key: i,
          className: "waterfall-column",
          style: columnStyle
        }, tempColumns[i] && tempColumns[i].children));
      }

      return result;
    });
    _this.shouldRender = false;
    _this.renderTimeout = null;
    _this.state = {
      dom: null
    };
    return _this;
  }

  (0, _createClass2["default"])(Waterfall, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        dom: this.renderChildren()
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps() {
      this.shouldRender = true;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      if (this.shouldRender) {
        if (this.renderTimeout) {
          clearTimeout(this.renderTimeout);
        }

        this.renderTimeout = setTimeout(function () {
          _this2.setState({
            dom: _this2.renderChildren(prevProps)
          }, function () {
            _this2.shouldRender = false;
          });
        }, 0);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          dom = this.state.dom;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('waterfall', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, dom, _react["default"].createElement("div", {
        className: "waterfall-hidden"
      }, children && children.map(function (child, index) {
        return (0, _react.cloneElement)(child, {
          key: index,
          ref: "waterfallTempChild".concat(index)
        });
      })));
    }
  }]);
  return Waterfall;
}(_react.Component);

Waterfall.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Column count of waterfall.
   */
  column: _propTypes["default"].number,

  /**
   * horizontal separator between items for calculation and display.
   */
  separator: _propTypes["default"].number
};
Waterfall.defaultProps = {
  column: 3,
  separator: 10
};
var _default = Waterfall;
exports["default"] = _default;