"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file ArrowStepItem component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ArrowStepItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ArrowStepItem, _Component);

  function ArrowStepItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ArrowStepItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ArrowStepItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          isActivatedStep = _this$props.isActivatedStep,
          isFinishedStep = _this$props.isFinishedStep,
          index = _this$props.index,
          onClick = _this$props.onClick;
      !isActivatedStep && isFinishedStep && onClick && onClick(index, e);
    });
    return _this;
  }

  (0, _createClass2["default"])(ArrowStepItem, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          isActivatedStep = _this$props2.isActivatedStep,
          isFinishedStep = _this$props2.isFinishedStep,
          index = _this$props2.index,
          value = _this$props2.value,
          isFirst = _this$props2.isFirst,
          isLast = _this$props2.isLast,
          triangleClassName = isActivatedStep ? 'activated' : isFinishedStep ? 'finished' : '';
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('arrow-step-item', isActivatedStep ? 'activated' : isFinishedStep ? 'finished' : '', (0, _defineProperty2["default"])({
          first: isFirst,
          last: isLast
        }, className, className)),
        style: style,
        onClick: this.handleClick
      }, _react["default"].createElement("div", {
        className: "arrow-step-item-content"
      }, _react["default"].createElement("div", {
        className: "number"
      }, index + 1), _react["default"].createElement("div", {
        className: "title"
      }, value.title)), isFirst ? null : _react["default"].createElement("div", {
        className: "triangle-wrapper triangle-wrapper-left"
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-top', triangleClassName)
      }), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-bottom', triangleClassName)
      })), isLast ? null : _react["default"].createElement("div", {
        className: "triangle-wrapper triangle-wrapper-right"
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-middle', triangleClassName)
      })));
    }
  }]);
  return ArrowStepItem;
}(_react.Component);

ArrowStepItem.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  index: _propTypes["default"].number,
  isActivatedStep: _propTypes["default"].bool,
  isFinishedStep: _propTypes["default"].bool,
  value: _propTypes["default"].object,
  isFirst: _propTypes["default"].bool,
  isLast: _propTypes["default"].bool,
  onClick: _propTypes["default"].func
};
ArrowStepItem.defaultProps = {
  index: 0,
  isActivatedStep: false,
  isFinishedStep: false,
  isFirst: true,
  isLast: true
};
var _default = ArrowStepItem;
exports["default"] = _default;