"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ColGroup = _interopRequireDefault(require("../_ColGroup"));

var _Thead = _interopRequireDefault(require("../_Thead"));

var _Tbody = _interopRequireDefault(require("../_Tbody"));

var _Tfoot = _interopRequireDefault(require("../_Tfoot"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

/**
 * @file BaseTable component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var BaseTable =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(BaseTable, _Component);

  function BaseTable(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, BaseTable);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(BaseTable)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }
  /* eslint-disable complexity */


  (0, _createClass2["default"])(BaseTable, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          data = _this$props.data,
          value = _this$props.value,
          hoverRowIndex = _this$props.hoverRowIndex,
          idProp = _this$props.idProp,
          baseColIndex = _this$props.baseColIndex,
          fixed = _this$props.fixed,
          fragment = _this$props.fragment,
          columns = _this$props.columns,
          headColumns = _this$props.headColumns,
          bodyColumns = _this$props.bodyColumns,
          selectMode = _this$props.selectMode,
          selectAllMode = _this$props.selectAllMode,
          expandRows = _this$props.expandRows,
          isHeadFixed = _this$props.isHeadFixed,
          isFootFixed = _this$props.isFootFixed,
          isHeadHidden = _this$props.isHeadHidden,
          isFootHidden = _this$props.isFootHidden,
          hasHeadRenderer = _this$props.hasHeadRenderer,
          hasBodyRenderer = _this$props.hasBodyRenderer,
          hasFootRenderer = _this$props.hasFootRenderer,
          sorting = _this$props.sorting,
          defaultSortingType = _this$props.defaultSortingType,
          sortingAscIconCls = _this$props.sortingAscIconCls,
          sortingDescIconCls = _this$props.sortingDescIconCls,
          onRowHover = _this$props.onRowHover,
          onSortChange = _this$props.onSortChange,
          onExpandChange = _this$props.onExpandChange,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "data", "value", "hoverRowIndex", "idProp", "baseColIndex", "fixed", "fragment", "columns", "headColumns", "bodyColumns", "selectMode", "selectAllMode", "expandRows", "isHeadFixed", "isFootFixed", "isHeadHidden", "isFootHidden", "hasHeadRenderer", "hasBodyRenderer", "hasFootRenderer", "sorting", "defaultSortingType", "sortingAscIconCls", "sortingDescIconCls", "onRowHover", "onSortChange", "onExpandChange"]);
      return _react["default"].createElement("table", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('base-table', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }), _react["default"].createElement(_ColGroup["default"], {
        columns: _TableCalculation["default"].getColumnsWithSpan(fragment, bodyColumns || columns)
      }), !isHeadHidden && hasHeadRenderer && (fragment === _TableFragment["default"].HEAD || !fixed && !fragment || !fragment && fixed && !isHeadFixed) ? _react["default"].createElement(_Thead["default"], (0, _extends2["default"])({}, restProps, {
        columns: headColumns || [columns],
        data: data,
        selectMode: selectMode,
        selectAllMode: selectAllMode,
        sorting: sorting,
        defaultSortingType: defaultSortingType,
        sortingAscIconCls: sortingAscIconCls,
        sortingDescIconCls: sortingDescIconCls,
        onSortChange: onSortChange
      })) : null, !fragment && hasBodyRenderer ? _react["default"].createElement(_Tbody["default"], (0, _extends2["default"])({}, restProps, {
        columns: bodyColumns || columns,
        data: data,
        value: value,
        hoverRowIndex: hoverRowIndex,
        selectMode: selectMode,
        selectAllMode: selectAllMode,
        expandRows: expandRows,
        idProp: idProp,
        baseColIndex: baseColIndex,
        sorting: sorting,
        onExpandChange: onExpandChange,
        onRowHover: onRowHover
      })) : null, !isFootHidden && hasFootRenderer && (fragment === _TableFragment["default"].FOOT || !fixed && !fragment || !fragment && fixed && !isFootFixed) ? _react["default"].createElement(_Tfoot["default"], (0, _extends2["default"])({}, restProps, {
        columns: bodyColumns || columns,
        data: data,
        selectMode: selectMode,
        selectAllMode: selectAllMode
      })) : null);
    }
  }]);
  return BaseTable;
}(_react.Component);

(0, _defineProperty2["default"])(BaseTable, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(BaseTable, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(BaseTable, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(BaseTable, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(BaseTable, "SortingType", _SortingType["default"]);
BaseTable.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The select all mode of table, all or current page.
   */
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  fixed: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"]))]),
  fragment: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TableFragment["default"])),

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })),
  headColumns: _propTypes["default"].array,
  bodyColumns: _propTypes["default"].array,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  hoverRowIndex: _propTypes["default"].number,
  idProp: _propTypes["default"].string,
  baseColIndex: _propTypes["default"].number,
  disabled: _propTypes["default"].bool,
  expandRows: _propTypes["default"].array,

  /**
   * fixed
   */
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,

  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,

  /**
   * has renderer
   */
  hasHeadRenderer: _propTypes["default"].bool,
  hasBodyRenderer: _propTypes["default"].bool,
  hasFootRenderer: _propTypes["default"].bool,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,

  /**
   * callback
   */
  onSortChange: _propTypes["default"].func,
  onHeadClick: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onFootClick: _propTypes["default"].func,
  onRowHover: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func
};
BaseTable.defaultProps = {
  baseColIndex: 0,
  disabled: false,
  expandRows: [],

  /**
   * fixed
   */
  isHeadFixed: false,
  isFootFixed: false,

  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,

  /**
   * has renderer
   */
  hasHeadRenderer: true,
  hasBodyRenderer: true,
  hasFootRenderer: true,

  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down'
};
var _default = BaseTable;
exports["default"] = _default;