"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _List = _interopRequireDefault(require("../List"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _HorizontalDirection = _interopRequireDefault(require("../_statics/HorizontalDirection"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

var _CascaderCalculation = _interopRequireDefault(require("../_vendors/CascaderCalculation"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file CascaderListItem component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var CascaderListItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CascaderListItem, _Component);

  function CascaderListItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CascaderListItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CascaderListItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "findDataIndex", function () {
      var _this$props = _this.props,
          activatedPath = _this$props.activatedPath,
          data = _this$props.data,
          valueField = _this$props.valueField,
          displayField = _this$props.displayField;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        var _loop = function _loop() {
          var dataItem = _step.value;
          var index = activatedPath.findIndex(function (item) {
            return item && _Util["default"].getValueByValueField(item.node, valueField, displayField) === _Util["default"].getValueByValueField(dataItem, valueField, displayField);
          });

          if (index > -1) {
            return {
              v: index
            };
          }
        };

        for (var _iterator = data[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ret = _loop();

          if ((0, _typeof2["default"])(_ret) === "object") return _ret.v;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return -1;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getActivatedIndex", function () {
      var _this$props2 = _this.props,
          activatedPath = _this$props2.activatedPath,
          data = _this$props2.data;

      if (!activatedPath || activatedPath.length < 1 || !data) {
        return -1;
      }

      var index = _this.findDataIndex();

      return index < 0 ? -1 : activatedPath[index].index;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isExpanded", function (node, index) {
      return index === _this.getActivatedIndex() && node.children && node.children.length > 0;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getCurrentPathNode", function () {
      var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getActivatedIndex();
      var data = _this.props.data;
      return index > -1 ? {
        index: index,
        node: data[index]
      } : null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPath", function () {
      var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getActivatedIndex();

      var path = _this.props.path,
          currentPathNode = _this.getCurrentPathNode(index);

      return path.length > 0 ? [].concat((0, _toConsumableArray2["default"])(path), [currentPathNode]) : [currentPathNode];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getValue", function () {
      var _this$props3 = _this.props,
          selectMode = _this$props3.selectMode,
          value = _this$props3.value,
          activatedPath = _this$props3.activatedPath,
          depth = _this$props3.depth;

      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        return value || [];
      }

      return activatedPath && activatedPath[depth] && activatedPath[depth].node || null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isListItemIndeterminate", function (node) {
      if (!_this.props.isSelectRecursive || _this.props.selectMode === _SelectMode["default"].SINGLE_SELECT) {
        return false;
      }

      return _Calculation["default"].isItemIndeterminate(node, _this.props.value, _this.props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemClick", function (node, index, e) {
      var _this$props4 = _this.props,
          data = _this$props4.data,
          disabled = _this$props4.disabled,
          isLoading = _this$props4.isLoading,
          readOnly = _this$props4.readOnly;

      if (disabled || isLoading || readOnly || data.disabled || data.isLoading || data.readOnly) {
        return;
      }

      var onNodeClick = _this.props.onNodeClick;
      onNodeClick && onNodeClick(node, index, _this.getPath(index), e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemSelect", function (node, index) {
      var onNodeSelect = _this.props.onNodeSelect;
      onNodeSelect && onNodeSelect(node, _this.getPath(index));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemDeselect", function (node, index) {
      var onNodeDeselect = _this.props.onNodeDeselect;
      onNodeDeselect && onNodeDeselect(node, _this.getPath(index));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "listItemRenderer", function (node, index) {
      if (!node) {
        return null;
      }

      var _this$props5 = _this.props,
          expandDirection = _this$props5.expandDirection,
          valueField = _this$props5.valueField,
          displayField = _this$props5.displayField,
          descriptionField = _this$props5.descriptionField,
          expandedIconCls = _this$props5.expandedIconCls,
          renderer = _this$props5.renderer,
          hasChildren = _CascaderCalculation["default"].hasChildren(node);

      var text, desc;

      if (!renderer) {
        text = _Util["default"].getTextByDisplayField(node, displayField, valueField);
        desc = node[descriptionField] || null;
      }

      return _react["default"].createElement(_react.Fragment, null, expandDirection === _HorizontalDirection["default"].LEFT && hasChildren ? _react["default"].createElement("i", {
        className: (0, _classnames["default"])('cascader-list-item-expand-icon', expandedIconCls || 'fas fa-chevron-left'),
        "aria-hidden": "true"
      }) : null, renderer ? renderer(node, index) : desc ? _react["default"].createElement("div", {
        className: "list-item-content"
      }, _react["default"].createElement("div", {
        className: "list-item-content-value"
      }, text), _react["default"].createElement("div", {
        className: "list-item-content-desc"
      }, desc)) : text, expandDirection === _HorizontalDirection["default"].RIGHT && hasChildren ? _react["default"].createElement("i", {
        className: (0, _classnames["default"])('cascader-list-item-expand-icon', expandedIconCls || 'fas fa-chevron-right'),
        "aria-hidden": "true"
      }) : null);
    });
    return _this;
  }

  (0, _createClass2["default"])(CascaderListItem, [{
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          depth = _this$props6.depth,
          theme = _this$props6.theme,
          listWidth = _this$props6.listWidth,
          selectTheme = _this$props6.selectTheme,
          selectMode = _this$props6.selectMode,
          expandDirection = _this$props6.expandDirection,
          data = _this$props6.data,
          disabled = _this$props6.disabled,
          isLoading = _this$props6.isLoading,
          readOnly = _this$props6.readOnly,
          idField = _this$props6.idField,
          valueField = _this$props6.valueField,
          displayField = _this$props6.displayField,
          descriptionField = _this$props6.descriptionField,
          radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props6.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
          activatedIndex = this.getActivatedIndex(),
          hasChild = activatedIndex > -1 && data[activatedIndex] && data[activatedIndex].children && data[activatedIndex].children.length > 0;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('cascader-list-item', {
          expanded: hasChild
        })
      }, _react["default"].createElement(_List["default"], {
        className: (0, _classnames["default"])('cascader-popup-list', {
          first: depth === 0,
          'expand-left': expandDirection === _HorizontalDirection["default"].LEFT
        }),
        style: {
          width: listWidth
        },
        theme: theme,
        selectTheme: selectTheme,
        selectMode: selectMode,
        data: data,
        value: this.getValue(),
        disabled: disabled,
        isLoading: isLoading,
        readOnly: readOnly,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        autoSelect: selectMode !== _SelectMode["default"].MULTI_SELECT,
        indeterminateCallback: this.isListItemIndeterminate,
        renderer: this.listItemRenderer,
        onItemClick: this.handleListItemClick,
        onItemSelect: this.handleListItemSelect,
        onItemDeselect: this.handleListItemDeselect
      }), activatedIndex > -1 && data[activatedIndex] && data[activatedIndex].children && data[activatedIndex].children.length > 0 ? _react["default"].createElement(CascaderListItem, (0, _extends2["default"])({}, this.props, {
        data: data[activatedIndex].children,
        depth: depth + 1,
        path: this.getPath(activatedIndex)
      })) : null);
    }
  }]);
  return CascaderListItem;
}(_react.Component);

(0, _defineProperty2["default"])(CascaderListItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(CascaderListItem, "ExpandDirection", _HorizontalDirection["default"]);
(0, _defineProperty2["default"])(CascaderListItem, "Theme", _Theme["default"]);
CascaderListItem.propTypes = {
  index: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  activatedPath: _propTypes["default"].array,
  path: _propTypes["default"].array,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  listWidth: _propTypes["default"].number,
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  expandDirection: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalDirection["default"])),
  data: _propTypes["default"].array,
  value: _propTypes["default"].any,
  idField: _propTypes["default"].string,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  descriptionField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isNodeToggling: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  renderer: _propTypes["default"].func,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  onNodeClick: _propTypes["default"].func,
  onNodeSelect: _propTypes["default"].func,
  onNodeDeselect: _propTypes["default"].func
};
CascaderListItem.defaultProps = {
  index: 0,
  depth: 0,
  activatedPath: [],
  path: [],
  theme: _Theme["default"].DEFAULT,
  listWidth: 200,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  expandDirection: _HorizontalDirection["default"].LEFT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isNodeToggling: false,
  isSelectRecursive: true,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = CascaderListItem;
exports["default"] = _default;