"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file ColGroup component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ColGroup =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ColGroup, _Component);

  function ColGroup(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ColGroup);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ColGroup)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColStyle", function (column) {
      var result = {};

      if (column.width != null) {
        result.width = column.width;
      }

      if (column.minWidth != null) {
        result.minWidth = column.minWidth;
      }

      return (0, _isEmpty["default"])(result) ? null : result;
    });
    return _this;
  }

  (0, _createClass2["default"])(ColGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var columns = this.props.columns;
      return columns ? _react["default"].createElement("colgroup", null, columns.map(function (_ref, index) {
        var column = _ref.column,
            span = _ref.span;
        return column ? _react["default"].createElement("col", {
          key: index,
          style: _this2.getColStyle(column),
          span: span && span > 1 ? span : null
        }) : null;
      })) : null;
    }
  }]);
  return ColGroup;
}(_react.Component);

(0, _defineProperty2["default"])(ColGroup, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(ColGroup, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ColGroup, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(ColGroup, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(ColGroup, "SortingType", _SortingType["default"]);
ColGroup.propTypes = {
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' )
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column
     */
    width: _propTypes["default"].number,

    /**
     * minimum width of column
     */
    minWidth: _propTypes["default"].number,

    /**
     * align of current column
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired
};
var _default = ColGroup;
exports["default"] = _default;