"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tr = _interopRequireDefault(require("../_Tr"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var CollapsedTableBody =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(CollapsedTableBody, _Component);

  function CollapsedTableBody(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, CollapsedTableBody);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(CollapsedTableBody)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemChecked", function (rowData) {
      var _this$props = _this.props,
          selectMode = _this$props.selectMode,
          idProp = _this$props.idProp,
          value = _this$props.value;

      if (!rowData || !value) {
        return false;
      }

      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          return value && value.findIndex(function (item) {
            return item[idProp] === rowData[idProp];
          }) !== -1;

        case _SelectMode["default"].SINGLE_SELECT:
          return value[idProp] === rowData[idProp];
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onExpandClick", function (row, rowIndex, colIndex) {
      var _this$props2 = _this.props,
          idProp = _this$props2.idProp,
          onExpandClick = _this$props2.onExpandClick;
      var expandedList = _this.state.expandedList;
      expandedList[row[idProp]] = 'PART';

      _this.setState({
        expandedList: expandedList
      }, function () {
        onExpandClick && onExpandClick(row, rowIndex, colIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCollapseClick", function (row, rowIndex, colIndex) {
      var _this$props3 = _this.props,
          idProp = _this$props3.idProp,
          onCollapseClick = _this$props3.onCollapseClick;
      var expandedList = _this.state.expandedList;
      delete expandedList[row[idProp]];

      _this.setState({
        expandedList: expandedList
      }, function () {
        onCollapseClick && onCollapseClick(row, rowIndex, colIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onViewAllClick", function (row, rowIndex) {
      var _this$props4 = _this.props,
          idProp = _this$props4.idProp,
          onViewAllClick = _this$props4.onViewAllClick;
      var expandedList = _this.state.expandedList;
      expandedList[row[idProp]] = 'ALL';

      _this.setState({
        expandedList: expandedList
      }, function () {
        onViewAllClick && onViewAllClick(row, rowIndex);
      });
    });
    _this.state = {
      expandedList: {}
    };
    return _this;
  }

  (0, _createClass2["default"])(CollapsedTableBody, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          columns = _this$props5.columns,
          data = _this$props5.data,
          startIndex = _this$props5.startIndex,
          idProp = _this$props5.idProp,
          disabled = _this$props5.disabled,
          value = _this$props5.value,
          selectMode = _this$props5.selectMode,
          expandedChildrenLimit = _this$props5.expandedChildrenLimit,
          expandedIconCls = _this$props5.expandedIconCls,
          onRowClick = _this$props5.onRowClick,
          onCellClick = _this$props5.onCellClick,
          expandedList = this.state.expandedList;
      return _react["default"].createElement("tbody", {
        className: "collapsed-table-body"
      }, data && data.map(function (row, rowIndex) {
        return row ? _react["default"].createElement(_react.Fragment, null, _react["default"].createElement(_Tr["default"], {
          key: idProp && idProp in row ? row[idProp] : rowIndex,
          rowIndex: startIndex + rowIndex,
          columns: columns,
          data: row,
          isExpanded: !!expandedList[row[idProp]],
          expandedIconCls: expandedIconCls,
          isChecked: _this2.isItemChecked(row),
          disabled: disabled || row.disabled,
          onRowClick: onRowClick,
          onCellClick: onCellClick,
          onExpand: function onExpand(colIndex) {
            idProp && idProp in row && _this2.onExpandClick(row, rowIndex, colIndex);
          },
          onCollapse: function onCollapse(colIndex) {
            idProp && idProp in row && _this2.onCollapseClick(row, rowIndex, colIndex);
          }
        }), expandedList[row[idProp]] ? !row.children || row.children.length === 0 ? _react["default"].createElement("tr", null, _react["default"].createElement("td", null, _react["default"].createElement("div", {
          className: "is-expand-loading"
        }, _react["default"].createElement(_CircularLoading["default"], null)))) : row.children.length <= expandedChildrenLimit || expandedList[row[idProp]] === 'ALL' ? _react["default"].createElement(_react.Fragment, null, row.children.map(function (childRow, childIndex) {
          return childRow ? _react["default"].createElement(_Tr["default"], {
            className: "expanded-children-row",
            key: idProp && idProp in childRow ? childRow[idProp] : childIndex + 'child',
            rowIndex: startIndex + childIndex,
            columns: columns,
            data: childRow,
            isChecked: _this2.isItemChecked(childRow),
            disabled: disabled || childRow.disabled,
            onRowClick: onRowClick,
            onCellClick: onCellClick
          }) : null;
        })) : _react["default"].createElement(_react.Fragment, null, row.children.slice(0, expandedChildrenLimit).map(function (childRow, childIndex) {
          return childRow ? _react["default"].createElement(_Tr["default"], {
            className: "expanded-children-row",
            key: idProp && idProp in childRow ? childRow[idProp] : childIndex + 'child',
            rowIndex: startIndex + childIndex,
            columns: columns,
            data: childRow,
            isChecked: _this2.isItemChecked(childRow),
            disabled: disabled || childRow.disabled,
            onRowClick: onRowClick,
            onCellClick: onCellClick
          }) : null;
        }), _react["default"].createElement("tr", null, _react["default"].createElement("td", null, _react["default"].createElement("span", {
          className: "view-all",
          onClick: function onClick() {
            _this2.onViewAllClick(row, rowIndex);
          }
        }, "View All(", row.children.length, ")")))) : null) : null;
      }));
    }
  }]);
  return CollapsedTableBody;
}(_react.Component);

(0, _defineProperty2["default"])(CollapsedTableBody, "SelectMode", _SelectMode["default"]);
CollapsedTableBody.propTypes = {
  columns: _propTypes["default"].array,
  data: _propTypes["default"].array,
  startIndex: _propTypes["default"].number,
  expandedChildrenLimit: _propTypes["default"].number,
  idProp: _propTypes["default"].string,
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  disabled: _propTypes["default"].bool,
  isItemChecked: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func
};
CollapsedTableBody.defaultProps = {
  data: [],
  columns: [],
  expandedChildrenLimit: 10,
  startIndex: 0,
  idProp: 'id',
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false
};
var _default = CollapsedTableBody;
exports["default"] = _default;