"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _Radio = _interopRequireDefault(require("../Radio"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

/**
 * @file DraggableListItem component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var DraggableListItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DraggableListItem, _Component);

  function DraggableListItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DraggableListItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DraggableListItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (checked) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          onDeselect = _this$props.onDeselect;

      if (checked) {
        onSelect && onSelect();
      } else {
        onDeselect && onDeselect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function () {
      if (!_this.props.checked) {
        var onSelect = _this.props.onSelect;
        onSelect && onSelect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      e.preventDefault();
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          isLoading = _this$props2.isLoading,
          readOnly = _this$props2.readOnly;

      if (disabled || isLoading || readOnly) {
        return;
      }

      var onClick = _this.props.onClick;
      onClick && onClick(e);

      switch (_this.props.selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(!_this.props.checked);

          return;

        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange();

          return;
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(DraggableListItem, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          index = _this$props3.index,
          className = _this$props3.className,
          style = _this$props3.style,
          theme = _this$props3.theme,
          data = _this$props3.data,
          text = _this$props3.text,
          desc = _this$props3.desc,
          title = _this$props3.title,
          iconCls = _this$props3.iconCls,
          rightIconCls = _this$props3.rightIconCls,
          tip = _this$props3.tip,
          tipPosition = _this$props3.tipPosition,
          disabled = _this$props3.disabled,
          isLoading = _this$props3.isLoading,
          renderer = _this$props3.renderer,
          itemRenderer = _this$props3.itemRenderer,
          readOnly = _this$props3.readOnly,
          isDragDisabled = _this$props3.isDragDisabled,
          anchorIconCls = _this$props3.anchorIconCls,
          checked = _this$props3.checked,
          selectTheme = _this$props3.selectTheme,
          selectMode = _this$props3.selectMode,
          radioUncheckedIconCls = _this$props3.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props3.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props3.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props3.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props3.checkboxIndeterminateIconCls,
          onMouseEnter = _this$props3.onMouseEnter,
          onMouseLeave = _this$props3.onMouseLeave,
          loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return _react["default"].createElement(_reactBeautifulDnd.Draggable, {
        key: index,
        draggableId: '' + index,
        index: index,
        isDragDisabled: isDragDisabled
      }, function (dragProvided) {
        var _classNames;

        return _react["default"].createElement("div", null, _react["default"].createElement("div", (0, _extends2["default"])({
          ref: dragProvided.innerRef,
          style: dragProvided.draggableStyle
        }, dragProvided.draggableProps, dragProvided.dragHandleProps), _react["default"].createElement(_TipProvider["default"], {
          className: "block",
          tipContent: tip,
          position: tipPosition
        }, _react["default"].createElement("div", {
          className: (0, _classnames["default"])('draggable-list-item', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "activated", checked), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
          style: style,
          disabled: disabled || isLoading,
          readOnly: readOnly,
          title: title,
          onClick: _this2.handleClick,
          onMouseEnter: onMouseEnter,
          onMouseLeave: onMouseLeave
        }, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? _react["default"].createElement(_Radio["default"], {
          className: "draggable-list-item-select",
          theme: selectTheme,
          checked: checked,
          disabled: disabled || isLoading,
          uncheckedIconCls: radioUncheckedIconCls,
          checkedIconCls: radioCheckedIconCls,
          disableTouchRipple: true
        }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? _react["default"].createElement(_Checkbox["default"], {
          className: "draggable-list-item-select",
          theme: selectTheme,
          checked: checked,
          disabled: disabled || isLoading,
          uncheckedIconCls: checkboxUncheckedIconCls,
          checkedIconCls: checkboxCheckedIconCls,
          indeterminateIconCls: checkboxIndeterminateIconCls,
          disableTouchRipple: true
        }) : null, isLoading && loadingIconPosition === 'left' ? _react["default"].createElement("div", {
          className: "button-icon button-icon-left"
        }, _react["default"].createElement(_CircularLoading["default"], {
          className: "button-loading-icon",
          size: "small"
        })) : iconCls ? _react["default"].createElement("i", {
          className: "button-icon button-icon-left ".concat(iconCls),
          "aria-hidden": "true"
        }) : null, itemRenderer && typeof itemRenderer === 'function' ? itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : desc ? _react["default"].createElement("div", {
          className: "draggable-list-item-content"
        }, _react["default"].createElement("div", {
          className: "draggable-list-item-content-value"
        }, text), _react["default"].createElement("div", {
          className: "draggable-list-item-content-desc"
        }, desc)) : text, isLoading && loadingIconPosition === 'right' ? _react["default"].createElement(_CircularLoading["default"], {
          className: "button-icon button-icon-right button-loading-icon",
          size: "small"
        }) : rightIconCls ? _react["default"].createElement("i", {
          className: "button-icon button-icon-right ".concat(rightIconCls),
          "aria-hidden": "true"
        }) : null, _react["default"].createElement("i", {
          className: "".concat(anchorIconCls, " draggable-list-item-anchor"),
          "aria-hidden": "true"
        })))), dragProvided.placeholder);
      });
    }
  }]);
  return DraggableListItem;
}(_react.Component);

(0, _defineProperty2["default"])(DraggableListItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableListItem, "Theme", _Theme["default"]);
DraggableListItem.propTypes = {
  index: _propTypes["default"].number,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].object]),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  text: _propTypes["default"].any,
  desc: _propTypes["default"].string,
  title: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  isDragDisabled: _propTypes["default"].bool,
  anchorIconCls: _propTypes["default"].string,
  itemRenderer: _propTypes["default"].func,
  renderer: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func
};
DraggableListItem.defaultProps = {
  index: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false,
  isLoading: false,
  checked: false,
  readOnly: false,
  tipPosition: _Position["default"].BOTTOM,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  isDragDisabled: false,
  anchorIconCls: 'fas fa-bars'
};
var _default = DraggableListItem;
exports["default"] = _default;