"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _TreeNode = _interopRequireDefault(require("../_TreeNode/TreeNode"));

/**
 * @file DraggableTreeNodeList component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var DraggableTreeNodeList =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DraggableTreeNodeList, _Component);

  function DraggableTreeNodeList(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, DraggableTreeNodeList);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DraggableTreeNodeList)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(DraggableTreeNodeList, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          depth = _this$props.depth,
          path = _this$props.path,
          data = _this$props.data,
          collapsed = _this$props.collapsed;
      return _react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "droppable"
      }, function (provided) {
        return _react["default"].createElement("div", {
          ref: provided.innerRef,
          className: 'draggable-tree-node-list' + (collapsed ? ' collapsed' : '')
        }, data && data.length > 0 ? data.map(function (item, index) {
          return _react["default"].createElement(_TreeNode["default"], (0, _extends2["default"])({}, _this.props, {
            key: index,
            data: item,
            index: index,
            depth: depth + 1,
            path: path ? [].concat((0, _toConsumableArray2["default"])(path), [{
              index: index,
              value: item
            }]) : [{
              index: index,
              value: item
            }]
          }));
        }) : null, provided.placeholder);
      });
    }
  }]);
  return DraggableTreeNodeList;
}(_react.Component);

DraggableTreeNodeList.propTypes = {
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  data: _propTypes["default"].array,
  collapsed: _propTypes["default"].bool
};
DraggableTreeNodeList.defaultProps = {
  depth: -1,
  data: [],
  collapsed: false
};
var _default = DraggableTreeNodeList;
exports["default"] = _default;