"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _Radio = _interopRequireDefault(require("../Radio"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _TipProvider = _interopRequireDefault(require("../TipProvider"));

var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file ListItem component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ListItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ListItem, _Component);

  function ListItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ListItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ListItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMultiSelectChange", function (checked) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          onDeselect = _this$props.onDeselect;

      if (checked) {
        onSelect && onSelect();
      } else {
        onDeselect && onDeselect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSingleSelectChange", function () {
      if (!_this.props.checked) {
        var onSelect = _this.props.onSelect;
        onSelect && onSelect();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          isLoading = _this$props2.isLoading,
          readOnly = _this$props2.readOnly,
          autoSelect = _this$props2.autoSelect;

      if (disabled || isLoading || readOnly) {
        return;
      }

      var onClick = _this.props.onClick;
      onClick && onClick(e);

      if (!autoSelect) {
        return;
      }

      switch (_this.props.selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleMultiSelectChange(!_this.props.checked);

          return;

        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleSingleSelectChange();

          return;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioCheck", function () {
      _this.handleSingleSelectChange();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxCheck", function () {
      _this.handleMultiSelectChange(true);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxUncheck", function () {
      _this.handleMultiSelectChange(false);
    });
    return _this;
  }

  (0, _createClass2["default"])(ListItem, [{
    key: "render",

    /* eslint-disable complexity */
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          index = _this$props3.index,
          className = _this$props3.className,
          style = _this$props3.style,
          theme = _this$props3.theme,
          activatedTheme = _this$props3.activatedTheme,
          data = _this$props3.data,
          text = _this$props3.text,
          desc = _this$props3.desc,
          title = _this$props3.title,
          iconCls = _this$props3.iconCls,
          rightIconCls = _this$props3.rightIconCls,
          tip = _this$props3.tip,
          tipPosition = _this$props3.tipPosition,
          disabled = _this$props3.disabled,
          isLoading = _this$props3.isLoading,
          disableTouchRipple = _this$props3.disableTouchRipple,
          rippleDisplayCenter = _this$props3.rippleDisplayCenter,
          readOnly = _this$props3.readOnly,
          renderer = _this$props3.renderer,
          itemRenderer = _this$props3.itemRenderer,
          checked = _this$props3.checked,
          selectTheme = _this$props3.selectTheme,
          selectMode = _this$props3.selectMode,
          indeterminateCallback = _this$props3.indeterminateCallback,
          radioUncheckedIconCls = _this$props3.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props3.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props3.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props3.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props3.checkboxIndeterminateIconCls,
          onMouseEnter = _this$props3.onMouseEnter,
          onMouseLeave = _this$props3.onMouseLeave,
          parentEl = _this$props3.parentEl,
          indeterminated = indeterminateCallback && indeterminateCallback(data) || false,
          loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return _react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        parentEl: parentEl,
        position: tipPosition
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('list-item', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), !checked && theme), (0, _defineProperty2["default"])(_classNames, "theme-".concat(activatedTheme), checked && activatedTheme), (0, _defineProperty2["default"])(_classNames, "activated", checked), (0, _defineProperty2["default"])(_classNames, "indeterminated", indeterminated), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled || isLoading,
        readOnly: readOnly,
        title: title,
        onClick: this.handleClick,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      }, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? _react["default"].createElement(_Radio["default"], {
        className: "list-item-select",
        theme: selectTheme,
        checked: checked,
        disabled: disabled || isLoading,
        uncheckedIconCls: radioUncheckedIconCls,
        checkedIconCls: radioCheckedIconCls,
        disableTouchRipple: true,
        onCheck: this.handleRadioCheck
      }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? _react["default"].createElement(_Checkbox["default"], {
        className: "list-item-select",
        theme: selectTheme,
        checked: checked,
        indeterminate: indeterminated,
        disabled: disabled || isLoading,
        uncheckedIconCls: checkboxUncheckedIconCls,
        checkedIconCls: checkboxCheckedIconCls,
        indeterminateIconCls: checkboxIndeterminateIconCls,
        disableTouchRipple: true,
        onCheck: this.handleCheckboxCheck,
        onUncheck: this.handleCheckboxUncheck
      }) : null, isLoading && loadingIconPosition === 'left' ? _react["default"].createElement("div", {
        className: "button-icon button-icon-left"
      }, _react["default"].createElement(_CircularLoading["default"], {
        className: "button-loading-icon",
        size: "small"
      })) : iconCls ? _react["default"].createElement("i", {
        className: "button-icon button-icon-left ".concat(iconCls),
        "aria-hidden": "true"
      }) : null, itemRenderer && typeof itemRenderer === 'function' ? itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : desc ? _react["default"].createElement("div", {
        className: "list-item-content"
      }, _react["default"].createElement("div", {
        className: "list-item-content-value"
      }, text), _react["default"].createElement("div", {
        className: "list-item-content-desc"
      }, desc)) : text, isLoading && loadingIconPosition === 'right' ? _react["default"].createElement(_CircularLoading["default"], {
        className: "button-icon button-icon-right button-loading-icon",
        size: "small"
      }) : rightIconCls ? _react["default"].createElement("i", {
        className: "button-icon button-icon-right ".concat(rightIconCls),
        "aria-hidden": "true"
      }) : null, disableTouchRipple || readOnly ? null : _react["default"].createElement(_TouchRipple["default"], {
        className: disabled || isLoading ? 'hidden' : '',
        displayCenter: rippleDisplayCenter
      })));
    }
  }]);
  return ListItem;
}(_react.Component);

(0, _defineProperty2["default"])(ListItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(ListItem, "Theme", _Theme["default"]);
ListItem.propTypes = {
  index: _propTypes["default"].number,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].object]),
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  title: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  disableTouchRipple: _propTypes["default"].bool,
  rippleDisplayCenter: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  itemRenderer: _propTypes["default"].func,
  renderer: _propTypes["default"].func,
  indeterminateCallback: _propTypes["default"].func,
  autoSelect: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func
};
ListItem.defaultProps = {
  index: 0,
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false,
  isLoading: false,
  disableTouchRipple: false,
  rippleDisplayCenter: false,
  checked: false,
  readOnly: false,
  tipPosition: _Position["default"].BOTTOM,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  autoSelect: true
};
var _default = ListItem;
exports["default"] = _default;