"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));

var _Theme = _interopRequireDefault(require("../Theme"));

/**
 * @file ListStepItem component
 * @author chao(chao.zhang@derbysoft.com)
 */
var ListStepItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ListStepItem, _Component);

  function ListStepItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ListStepItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ListStepItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props = _this.props,
          activatedStep = _this$props.activatedStep,
          finishedStep = _this$props.finishedStep,
          index = _this$props.index,
          onClick = _this$props.onClick;
      activatedStep !== index && finishedStep >= index && onClick(index);
    });
    return _this;
  }

  (0, _createClass2["default"])(ListStepItem, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          activatedStep = _this$props2.activatedStep,
          finishedStep = _this$props2.finishedStep,
          index = _this$props2.index,
          data = _this$props2.data,
          state = activatedStep === index ? 'activated' : finishedStep >= index ? 'finished' : '';
      return _react["default"].createElement(_RaisedButton["default"], (0, _extends2["default"])({}, data, {
        className: (0, _classnames["default"])('list-step-item', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, state, state), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        theme: state === 'activated' ? _Theme["default"].HIGHLIGHT : state === 'finished' ? _Theme["default"].PRIMARY : '',
        value: data.value,
        onClick: this.handleClick
      }));
    }
  }]);
  return ListStepItem;
}(_react.Component);

(0, _defineProperty2["default"])(ListStepItem, "Theme", _Theme["default"]);
ListStepItem.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Item index.
   */
  index: _propTypes["default"].number,

  /**
   * Sets the step as active.
   */
  activatedStep: _propTypes["default"].number,

  /**
   * The final step.
   */
  finishedStep: _propTypes["default"].number,

  /**
   * The data of step item.
   */
  data: _propTypes["default"].object,

  /**
   * Callback function fired when step change.
   */
  onClick: _propTypes["default"].func
};
ListStepItem.defaultProps = {
  index: 0,
  activatedStep: 0,
  finishedStep: 0
};
var _default = ListStepItem;
exports["default"] = _default;