"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _MaterialProvider = _interopRequireDefault(require("../MaterialProvider"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));

/**
 * @file MaterialDatePickerTextField component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var MaterialDatePickerTextField =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MaterialDatePickerTextField, _Component);

  function MaterialDatePickerTextField(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MaterialDatePickerTextField);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MaterialDatePickerTextField)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      _this.textField && _this.textField.current && _this.textField.current.focus();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blur", function () {
      _this.textField && _this.textField.current && _this.textField.current.blur();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerChange", function (value) {
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.textField = (0, _react.createRef)();
    _this.state = {
      value: ''
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(MaterialDatePickerTextField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        value: this.props.value
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          theme = _this$props.theme,
          label = _this$props.label,
          isLabelAnimate = _this$props.isLabelAnimate,
          disabled = _this$props.disabled,
          required = _this$props.required,
          popupVisible = _this$props.popupVisible,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "theme", "label", "isLabelAnimate", "disabled", "required", "popupVisible"]),
          value = this.state.value;
      return _react["default"].createElement(_MaterialProvider["default"], {
        className: (0, _classnames["default"])('material-date-picker-text-field', (0, _defineProperty2["default"])({
          activated: popupVisible
        }, className, className)),
        style: style,
        theme: theme,
        label: label,
        isLabelAnimate: isLabelAnimate,
        hasValue: !!value,
        disabled: disabled,
        required: required
      }, _react["default"].createElement(_TextField["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.textField,
        theme: theme,
        value: value,
        disabled: disabled,
        required: required,
        onChange: this.handleTriggerChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        isFocus: _ComponentUtil["default"].getDerivedState(props, state, 'popupVisible')
      };
    }
  }]);
  return MaterialDatePickerTextField;
}(_react.Component);

(0, _defineProperty2["default"])(MaterialDatePickerTextField, "Type", _TextField["default"].Type);
(0, _defineProperty2["default"])(MaterialDatePickerTextField, "Theme", _Theme["default"]);
MaterialDatePickerTextField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The TextField theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * Specifies the type of input to display such as "password" or "text".
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TextField["default"].Type)),

  /**
   * The name of the text field.
   */
  name: _propTypes["default"].string,

  /**
   * The label of the text field.
   */
  label: _propTypes["default"].any,

  /**
   * The animate of the text field.
   */
  isLabelAnimate: _propTypes["default"].bool,

  /**
   * The placeholder of the text field.
   */
  placeholder: _propTypes["default"].string,

  /**
   * The value of the text field.Type can be string or number.
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,

  /**
   * Disables the textField if set to true.
   */
  disabled: _propTypes["default"].bool,

  /**
   * If true,the textField will can't editable.
   */
  readOnly: _propTypes["default"].bool,

  /**
   * If true,the textField will autoFocus.
   */
  autoFocus: _propTypes["default"].bool,

  /**
   * The message of the textField.
   */
  infoMsg: _propTypes["default"].string,

  /**
   * If true,clearButton will display when the textField is not empty.
   */
  clearButtonVisible: _propTypes["default"].bool,

  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,

  /**
   * If true,passwordButton will display.
   */
  passwordButtonVisible: _propTypes["default"].bool,
  // valid

  /**
   * If true,the textField must be required.
   */
  required: _propTypes["default"].bool,

  /**
   * The maximum length of textField to enter.
   */
  maxLength: _propTypes["default"].number,

  /**
   * Maximum number of textField that can be entered.
   */
  max: _propTypes["default"].number,

  /**
   * Minimum number of textField that can be entered.
   */
  min: _propTypes["default"].number,

  /**
   * The matching rule of textField.
   */
  pattern: _propTypes["default"].object,

  /**
   * The invalid message of textField.
   */
  patternInvalidMsg: _propTypes["default"].string,

  /**
   *
   */
  autoComplete: _propTypes["default"].string,

  /**
   *
   */
  autoCorrect: _propTypes["default"].string,

  /**
   *
   */
  autoCapitalize: _propTypes["default"].string,

  /**
   *
   */
  spellCheck: _propTypes["default"].string,

  /**
   * Callback function fired when the textField is changed.
   */
  onChange: _propTypes["default"].func,

  /**
   * Callback function fired when the press enter.
   */
  onPressEnter: _propTypes["default"].func,

  /**
   * Callback function fired when textField valid.
   */
  onValid: _propTypes["default"].func,

  /**
   * Callback function fired when textField invalid.
   */
  onInvalid: _propTypes["default"].func,

  /**
   * Callback function fired when textField focus.
   */
  onFocus: _propTypes["default"].func,

  /**
   * Callback function fired when textField blur.
   */
  onBlur: _propTypes["default"].func,

  /**
   * Callback function fired when textField clear.
   */
  onClear: _propTypes["default"].func,

  /**
   * Callback function fired when password visible.
   */
  onPasswordVisible: _propTypes["default"].func,

  /**
   * Callback function fired when password invisible.
   */
  onPasswordInvisible: _propTypes["default"].func,

  /**
   * the datePicker is open if set to true.
   */
  popupVisible: _propTypes["default"].bool,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func
};
MaterialDatePickerTextField.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  type: 'text',
  name: '',
  label: '',
  isLabelAnimate: true,
  placeholder: '',
  value: '',
  disabled: false,
  readOnly: false,
  autoFocus: false,
  popupVisible: false,
  clearButtonVisible: true,
  passwordButtonVisible: true,
  // valid
  required: false,
  patternInvalidMsg: '',
  autoComplete: 'off',
  autoCorrect: 'off',
  autoCapitalize: 'off',
  spellCheck: 'false',
  fieldMsgVisible: false
};
var _default = MaterialDatePickerTextField;
exports["default"] = _default;