"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));

/**
 * @file MonthPicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var MonthPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MonthPicker, _Component);

  function MonthPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, MonthPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MonthPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousLevel", function () {
      _this.props.previousClick && _this.props.previousClick('year');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (s_month) {
      var selectYear = _this.state.selectYear;

      _this.setState({
        currentYear: selectYear,
        currentMonth: s_month,
        selectMonth: s_month
      }, function () {
        _this.props.onChange && _this.props.onChange({
          year: selectYear,
          month: s_month
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var _this$state = _this.state,
          currentYear = _this$state.currentYear,
          currentMonth = _this$state.currentMonth,
          selectYear = _this$state.selectYear,
          selectMonth = _this$state.selectMonth;
      selectYear = +selectYear - 1;
      selectMonth = Number(currentYear) === Number(selectYear) ? currentMonth : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var _this$state2 = _this.state,
          currentYear = _this$state2.currentYear,
          currentMonth = _this$state2.currentMonth,
          selectYear = _this$state2.selectYear,
          selectMonth = _this$state2.selectMonth;
      selectYear = +selectYear + 1;
      selectMonth = Number(currentYear) === Number(selectYear) ? currentMonth : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth
      });
    });
    _this.defaultTable = {
      row_number: 4,
      col_number: 3
    };
    _this.state = {
      selectYear: props.year,
      selectMonth: props.month,
      currentYear: (0, _moment["default"])(props.value).format('YYYY'),
      currentMonth: (0, _moment["default"])(props.value).format('MM'),
      selectDay: props.day
    };
    return _this;
  }

  (0, _createClass2["default"])(MonthPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          value = _this$props.value,
          year = _this$props.year,
          month = _this$props.month;

      if (value && year && month) {
        this.setState({
          selectYear: year,
          selectMonth: month,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM')
        });
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value || nextProps.year !== this.props.year || nextProps.month !== this.props.month) {
        var value = nextProps.value;
        this.setState({
          selectYear: nextProps.year,
          selectMonth: nextProps.month,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM')
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          previousYearIconCls = _this$props2.previousYearIconCls,
          nextYearIconCls = _this$props2.nextYearIconCls;
      var _this$state3 = this.state,
          selectYear = _this$state3.selectYear,
          selectMonth = _this$state3.selectMonth,
          currentYear = _this$state3.currentYear;
      var previousYear = this.previousYear,
          nextYear = this.nextYear,
          selectDate = this.selectDate,
          previousLevel = this.previousLevel;
      var current_months = [],
          ul_list = [];
      var MonthEn = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

      var _loop = function _loop(i) {
        var liClassName = "".concat(currentYear == selectYear && Number(selectMonth) == i + 1 ? 'active' : '', "\n                                ").concat(maxValue && (0, _moment["default"])(maxValue).format('YYYY') == selectYear && +(0, _moment["default"])(maxValue).format('MM') < i + 1 || minValue && (0, _moment["default"])(minValue).format('YYYY') == selectYear && +(0, _moment["default"])(minValue).format('MM') > i + 1 ? 'item-gray' : 'current-years');

        var Months = _react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            liClassName.indexOf('item-gray') === -1 && selectDate(i + 1);
          }
        }, _react["default"].createElement("a", {
          href: "javascript:;"
        }, MonthEn[i], liClassName.indexOf('item-gray') === -1 ? _react["default"].createElement(_TouchRipple["default"], null) : null));

        current_months.push(Months);
      };

      for (var i = 0; i < MonthEn.length; i++) {
        _loop(i);
      }

      if (current_months.length > 0) {
        for (var _i = 0; _i < this.defaultTable.row_number; _i++) {
          var li_list = [],
              start_index = _i * this.defaultTable.col_number,
              end_index = (_i + 1) * this.defaultTable.col_number;

          for (var j = start_index; j < end_index; j++) {
            li_list.push(current_months[j]);
          }

          ul_list.push(li_list);
        }
      }

      selectYear = selectYear.toString();
      var leftNextYear = maxValue && (0, _moment["default"])(maxValue).format('YYYY') <= +selectYear;
      var rightPreYear = minValue && (0, _moment["default"])(minValue).format('YYYY') >= +selectYear;
      return _react["default"].createElement("div", {
        className: 'calendar'
      }, _react["default"].createElement("div", {
        className: "calendar-header"
      }, rightPreYear ? null : _react["default"].createElement("i", {
        className: "previous-year ".concat(previousYearIconCls),
        onClick: previousYear
      }, _react["default"].createElement(_TouchRipple["default"], null)), _react["default"].createElement("span", {
        onClick: previousLevel
      }, selectYear), leftNextYear ? null : _react["default"].createElement("i", {
        className: "next-year ".concat(nextYearIconCls),
        onClick: nextYear
      }, _react["default"].createElement(_TouchRipple["default"], null))), _react["default"].createElement("div", {
        className: "calendar-body  calendar-month-body"
      }, _react["default"].createElement("div", {
        className: "c-body-content"
      }, ul_list && ul_list.map(function (item, key) {
        return _react["default"].createElement("ul", {
          key: 'ul' + key,
          className: "content-row month"
        }, item);
      }))));
    }
  }]);
  return MonthPicker;
}(_react.Component);

MonthPicker.propTypes = {
  className: _propTypes["default"].string,
  value: _propTypes["default"].any,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  onChange: _propTypes["default"].func,
  previousClick: _propTypes["default"].func
};
var _default = MonthPicker;
exports["default"] = _default;