"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _AnchorButton = _interopRequireDefault(require("../AnchorButton"));

var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Notification component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Notification =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Notification, _Component);

  function Notification(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Notification);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Notification)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIconCls", function () {
      switch (_this.props.type) {
        case _MsgType["default"].SUCCESS:
          return 'fas fa-check-circle';

        case _MsgType["default"].WARNING:
          return 'fas fa-exclamation-triangle';

        case _MsgType["default"].ERROR:
          return 'fas fa-times-circle';

        default:
          return 'fas fa-info-circle';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          notificationId = _this$props.notificationId,
          onRequestClose = _this$props.onRequestClose;

      _this.setState({
        hidden: true,
        leave: true
      }, function () {
        setTimeout(function () {
          onRequestClose && onRequestClose(notificationId);
        }, 500);
      });
    });
    _this.notification = (0, _react.createRef)();
    _this.unrenderTimeout = null;
    _this.state = {
      hidden: true,
      leave: false
    };
    return _this;
  }

  (0, _createClass2["default"])(Notification, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props2 = this.props,
          notificationId = _this$props2.notificationId,
          duration = _this$props2.duration,
          onRequestClose = _this$props2.onRequestClose;
      var notificationEl = this.notification && this.notification.current;
      notificationEl.style.height = notificationEl.clientHeight + 'px';
      notificationEl.style.width = notificationEl.clientWidth + 'px';

      if (duration > 0) {
        this.unrenderTimeout = setTimeout(function () {
          _this2.setState({
            hidden: true,
            leave: true
          }, function () {
            setTimeout(function () {
              onRequestClose && onRequestClose(notificationId);
            }, 500);
          });
        }, duration);
      }

      setTimeout(function () {
        _this2.setState({
          hidden: false
        });
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unrenderTimeout && clearTimeout(this.unrenderTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          type = _this$props3.type,
          title = _this$props3.title,
          message = _this$props3.message,
          iconCls = _this$props3.iconCls,
          closeIconVisible = _this$props3.closeIconVisible,
          closeButtonVisible = _this$props3.closeButtonVisible,
          closeButtonValue = _this$props3.closeButtonValue,
          _this$state = this.state,
          hidden = _this$state.hidden,
          leave = _this$state.leave;
      return _react["default"].createElement("div", {
        ref: this.notification,
        className: (0, _classnames["default"])('notification', (_classNames = {
          'theme-default': type === _MsgType["default"].DEFAULT
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(type), type !== _MsgType["default"].DEFAULT), (0, _defineProperty2["default"])(_classNames, "hidden", hidden), (0, _defineProperty2["default"])(_classNames, "leave", leave), (0, _defineProperty2["default"])(_classNames, 'has-close-button', closeButtonVisible), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }, type === _MsgType["default"].DEFAULT ? null : _react["default"].createElement("i", {
        className: "".concat(iconCls ? iconCls : this.getIconCls(), " notification-icon")
      }), _react["default"].createElement("div", {
        className: "notification-title"
      }, title), _react["default"].createElement("div", {
        className: "notification-message"
      }, message), closeIconVisible ? _react["default"].createElement(_IconButton["default"], {
        className: "notification-close-icon",
        iconCls: "fas fa-times",
        onClick: this.handleClick
      }) : null, closeButtonVisible ? _react["default"].createElement(_AnchorButton["default"], {
        className: "notification-close-Button",
        value: closeButtonValue,
        onClick: this.handleClick
      }) : null);
    }
  }]);
  return Notification;
}(_react.Component);

(0, _defineProperty2["default"])(Notification, "Type", _MsgType["default"]);
Notification.propTypes = {
  /**
   * The CSS class name of notification.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the notification.
   */
  style: _propTypes["default"].object,
  notificationId: _propTypes["default"].number,

  /**
   * The type of notification.
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),

  /**
   * The title of notification.
   */
  title: _propTypes["default"].any,

  /**
   * The message of notification.
   */
  message: _propTypes["default"].any,

  /**
   * The icon class name of notification.
   */
  iconCls: _propTypes["default"].string,

  /**
   * The duration of notification.
   */
  duration: _propTypes["default"].number,
  closeIconVisible: _propTypes["default"].bool,
  closeButtonVisible: _propTypes["default"].bool,
  closeButtonValue: _propTypes["default"].string,
  onRequestClose: _propTypes["default"].func
};
Notification.defaultProps = {
  notificationId: 0,
  type: _MsgType["default"].INFO,
  title: 'message',
  message: '',
  iconCls: '',
  duration: 0,
  closeIconVisible: false,
  closeButtonVisible: true,
  closeButtonValue: 'Close'
};
var _default = Notification;
exports["default"] = _default;