"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Pop = _interopRequireDefault(require("../_Pop"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _PositionPopCalculation = _interopRequireDefault(require("../_vendors/PositionPopCalculation"));

/**
 * @file PositionPop component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var PositionPop =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(PositionPop, _Component);

  function PositionPop(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, PositionPop);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(PositionPop)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      return _this.pop && _this.pop.current && _this.pop.current.getEl();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var transitionEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getEl();
      var _this$props = _this.props,
          parentEl = _this$props.parentEl,
          position = _this$props.position;

      _PositionPopCalculation["default"].setStyle(parentEl, transitionEl, position);
    });
    _this.pop = (0, _react.createRef)();
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(PositionPop, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          children = _this$props2.children,
          container = _this$props2.container,
          className = _this$props2.className,
          theme = _this$props2.theme,
          position = _this$props2.position,
          isAnimated = _this$props2.isAnimated,
          isEscClose = _this$props2.isEscClose,
          isBlurClose = _this$props2.isBlurClose,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["children", "container", "className", "theme", "position", "isAnimated", "isEscClose", "isBlurClose"]);
      return _react["default"].createElement(_Pop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('position-pop', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "position-pop-".concat(position), position), (0, _defineProperty2["default"])(_classNames, 'position-pop-animated', isAnimated), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        container: container,
        isAnimated: isAnimated,
        resetPosition: this.resetPosition
      }), function (popEl) {
        return typeof children === 'function' ? children(popEl) : children;
      });
    }
  }]);
  return PositionPop;
}(_react.Component);

(0, _defineProperty2["default"])(PositionPop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(PositionPop, "Theme", _Theme["default"]);
PositionPop.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * If true, the trigger pop is visible.
   */
  visible: _propTypes["default"].bool,

  /**
   * The trigger pop theme. Can be primary, highlight, success, warning, error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,

  /**
   * The trigger pop alignment. The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true, popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,
  container: _propTypes["default"].node,
  showModal: _propTypes["default"].bool,
  modalClassName: _propTypes["default"].string,

  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,

  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
PositionPop.defaultProps = {
  parentEl: document.body,
  depth: 2,
  visible: false,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].CENTER,
  isAnimated: true,
  isBlurClose: true,
  isEscClose: true,
  container: _react["default"].createElement("div", null),
  showModal: false
};
var _default = PositionPop;
exports["default"] = _default;