"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file RoundStepItem component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var RoundStepItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(RoundStepItem, _Component);

  function RoundStepItem(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, RoundStepItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(RoundStepItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRightBarClassName", function () {
      var _this$props = _this.props,
          activatedStep = _this$props.activatedStep,
          finishedStep = _this$props.finishedStep,
          index = _this$props.index;

      if (finishedStep > index || activatedStep > index) {
        return ' full';
      }

      if (activatedStep === index || finishedStep === index) {
        return '';
      }

      return ' hidden';
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props2 = _this.props,
          activatedStep = _this$props2.activatedStep,
          finishedStep = _this$props2.finishedStep,
          index = _this$props2.index,
          disabled = _this$props2.disabled,
          onClick = _this$props2.onClick;
      !disabled && activatedStep !== index && finishedStep >= index && onClick && onClick(index, e);
    });
    return _this;
  }

  (0, _createClass2["default"])(RoundStepItem, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          activatedStep = _this$props3.activatedStep,
          finishedStep = _this$props3.finishedStep,
          index = _this$props3.index,
          value = _this$props3.value,
          isFirst = _this$props3.isFirst,
          isLast = _this$props3.isLast,
          showFinishedStepIcon = _this$props3.showFinishedStepIcon,
          finishedStepIconCls = _this$props3.finishedStepIconCls,
          disabled = _this$props3.disabled;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('round-step-item', activatedStep == index ? ' activated' : finishedStep >= index ? ' finished' : '', (0, _defineProperty2["default"])({
          first: isFirst,
          last: isLast,
          disabled: disabled
        }, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        className: "bg-bar"
      }), _react["default"].createElement("div", {
        className: "bg-round"
      }), !isFirst && (finishedStep >= index || activatedStep >= index) ? _react["default"].createElement("div", {
        className: "left-bar"
      }) : null, !isLast ? _react["default"].createElement("div", {
        className: 'right-bar' + this.getRightBarClassName()
      }) : null, _react["default"].createElement("div", {
        className: "round",
        onClick: this.handleClick
      }, showFinishedStepIcon && finishedStep > index ? _react["default"].createElement("i", {
        className: finishedStepIconCls,
        "aria-hidden": "true"
      }) : index + 1), _react["default"].createElement("div", {
        className: "title"
      }, value.title));
    }
  }]);
  return RoundStepItem;
}(_react.Component);

RoundStepItem.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  activatedStep: _propTypes["default"].number,
  finishedStep: _propTypes["default"].number,
  index: _propTypes["default"].number,
  value: _propTypes["default"].object,
  isFirst: _propTypes["default"].bool,
  isLast: _propTypes["default"].bool,
  showFinishedStepIcon: _propTypes["default"].bool,
  finishedStepIconCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  onClick: _propTypes["default"].func
};
RoundStepItem.defaultProps = {
  activatedStep: 0,
  finishedStep: 0,
  index: 0,
  value: {},
  isFirst: true,
  isLast: false,
  showFinishedStepIcon: true,
  finishedStepIconCls: 'fas fa-check',
  disabled: false
};
var _default = RoundStepItem;
exports["default"] = _default;