"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _BaseTable = _interopRequireDefault(require("../_BaseTable"));

var _ScrollableTable = _interopRequireDefault(require("../_ScrollableTable"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file ScrollTable component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ScrollTable =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ScrollTable, _Component);

  function ScrollTable(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ScrollTable);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ScrollTable)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateEl", (0, _debounce["default"])(function () {
      var _this$props = _this.props,
          isHeadFixed = _this$props.isHeadFixed,
          isFootFixed = _this$props.isFootFixed,
          onGetBodyScrollerEl = _this$props.onGetBodyScrollerEl,
          onGetHeadScrollerEl = _this$props.onGetHeadScrollerEl,
          onGetFootScrollerEl = _this$props.onGetFootScrollerEl;
      onGetBodyScrollerEl && _this.bodyScroller && _this.bodyScroller.current && onGetBodyScrollerEl((0, _reactDom.findDOMNode)(_this.bodyScroller.current));
      isHeadFixed && onGetHeadScrollerEl && _this.headScroller && _this.headScroller.current && onGetHeadScrollerEl((0, _reactDom.findDOMNode)(_this.headScroller.current));
      isFootFixed && onGetFootScrollerEl && _this.footScroller && _this.footScroller.current && onGetFootScrollerEl((0, _reactDom.findDOMNode)(_this.footScroller.current));
    }, 250));
    _this.headScroller = (0, _react.createRef)();
    _this.bodyScroller = (0, _react.createRef)();
    _this.footScroller = (0, _react.createRef)();
    return _this;
  }

  (0, _createClass2["default"])(ScrollTable, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateEl();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          bodyScrollerStyle = _this$props2.bodyScrollerStyle,
          maskStyle = _this$props2.maskStyle,
          tableStyle = _this$props2.tableStyle,
          footStyle = _this$props2.footStyle,
          fixed = _this$props2.fixed,
          columns = _this$props2.columns,
          headColumns = _this$props2.headColumns,
          bodyColumns = _this$props2.bodyColumns,
          isHeadHidden = _this$props2.isHeadHidden,
          isFootHidden = _this$props2.isFootHidden,
          isHeadFixed = _this$props2.isHeadFixed,
          isFootFixed = _this$props2.isFootFixed,
          scroll = _this$props2.scroll,
          hasFixedLeftColumn = _this$props2.hasFixedLeftColumn,
          hasFixedRightColumn = _this$props2.hasFixedRightColumn,
          onScroll = _this$props2.onScroll,
          onWheel = _this$props2.onWheel,
          onGetHeadScrollerEl = _this$props2.onGetHeadScrollerEl,
          onGetBodyScrollerEl = _this$props2.onGetBodyScrollerEl,
          onGetFootScrollerEl = _this$props2.onGetFootScrollerEl,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["className", "style", "bodyScrollerStyle", "maskStyle", "tableStyle", "footStyle", "fixed", "columns", "headColumns", "bodyColumns", "isHeadHidden", "isFootHidden", "isHeadFixed", "isFootFixed", "scroll", "hasFixedLeftColumn", "hasFixedRightColumn", "onScroll", "onWheel", "onGetHeadScrollerEl", "onGetBodyScrollerEl", "onGetFootScrollerEl"]);

      if (!columns && !headColumns && !bodyColumns) {
        return null;
      }

      var overflowHidden = fixed === _HorizontalAlign["default"].LEFT,
          horizontalOverflowScroll = !fixed || fixed === _HorizontalAlign["default"].CENTER;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('scroll-table', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, !isHeadHidden && isHeadFixed ? _react["default"].createElement("div", {
        className: "scroll-table-head"
      }, _react["default"].createElement(_ScrollableTable["default"], {
        ref: this.headScroller,
        className: "scroll-table-head-scroller",
        scroll: scroll,
        overflowHidden: overflowHidden,
        horizontalOverflowScroll: horizontalOverflowScroll,
        onScroll: onScroll
      }, _react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
        style: tableStyle,
        fixed: fixed,
        fragment: _TableFragment["default"].HEAD,
        columns: columns,
        headColumns: headColumns,
        bodyColumns: bodyColumns
      })))) : null, _react["default"].createElement("div", {
        className: "scroll-table-body"
      }, _react["default"].createElement(_ScrollableTable["default"], {
        ref: this.bodyScroller,
        className: "scroll-table-body-scroller",
        style: bodyScrollerStyle,
        scroll: scroll,
        onScroll: onScroll,
        onWheel: onWheel
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('scroll-table-body-mask', {
          'mask-vertical': !isHeadHidden && isHeadFixed || !isFootHidden && isFootFixed,
          'mask-horizontal': hasFixedLeftColumn || hasFixedRightColumn
        }),
        style: maskStyle
      }, _react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
        style: tableStyle,
        fixed: fixed,
        columns: columns,
        headColumns: headColumns,
        bodyColumns: bodyColumns,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isHeadHidden: isHeadHidden,
        isFootHidden: isFootHidden
      }))))), !isFootHidden && isFootFixed ? _react["default"].createElement("div", {
        className: "scroll-table-foot",
        style: footStyle
      }, _react["default"].createElement(_ScrollableTable["default"], {
        ref: this.footScroller,
        className: "scroll-table-foot-scroller",
        scroll: scroll,
        overflowHidden: overflowHidden,
        horizontalOverflowScroll: horizontalOverflowScroll,
        onScroll: onScroll
      }, _react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
        style: tableStyle,
        fixed: fixed,
        fragment: _TableFragment["default"].FOOT,
        columns: columns,
        headColumns: headColumns,
        bodyColumns: bodyColumns
      })))) : null);
    }
  }]);
  return ScrollTable;
}(_react.Component);

(0, _defineProperty2["default"])(ScrollTable, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(ScrollTable, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ScrollTable, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SortingType", _SortingType["default"]);
ScrollTable.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  bodyScrollerStyle: _propTypes["default"].object,
  maskStyle: _propTypes["default"].object,
  tableStyle: _propTypes["default"].object,
  footStyle: _propTypes["default"].object,
  fixed: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"]))]),

  /**
   * The theme of the table select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),

  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The select all mode of table, all or current page.
   */
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })),
  headColumns: _propTypes["default"].array,
  bodyColumns: _propTypes["default"].array,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  hoverRowIndex: _propTypes["default"].number,
  baseColIndex: _propTypes["default"].number,
  expandRows: _propTypes["default"].array,

  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,

  /**
   * fixed
   */
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,

  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,

  /**
   * has renderer
   */
  hasHeadRenderer: _propTypes["default"].bool,
  hasBodyRenderer: _propTypes["default"].bool,
  hasFootRenderer: _propTypes["default"].bool,

  /**
   * fixed column
   */
  hasFixedLeftColumn: _propTypes["default"].bool,
  hasFixedRightColumn: _propTypes["default"].bool,

  /**
   * callback
   */
  onGetBodyScrollerEl: _propTypes["default"].func,
  onGetHeadScrollerEl: _propTypes["default"].func,
  onGetFootScrollerEl: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onScroll: _propTypes["default"].func,
  onWheel: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onRowHover: _propTypes["default"].func
};
ScrollTable.defaultProps = {
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  baseColIndex: 0,
  expandRows: [],

  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',

  /**
   * fixed
   */
  isHeadFixed: false,
  isFootFixed: false,

  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,

  /**
   * has renderer
   */
  hasHeadRenderer: true,
  hasBodyRenderer: true,
  hasFootRenderer: true,

  /**
   * fixed column
   */
  hasFixedLeftColumn: false,
  hasFixedRightColumn: false
};
var _default = ScrollTable;
exports["default"] = _default;