"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _startCase = _interopRequireDefault(require("lodash/startCase"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _ScrollTable = _interopRequireDefault(require("../_ScrollTable"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _BaseTable = _interopRequireDefault(require("../_BaseTable/BaseTable"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TableLayout = _interopRequireDefault(require("../_vendors/TableLayout"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TableContent =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TableContent, _Component);

  function TableContent(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TableContent);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TableContent)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (node, rowIndex, colIndex, collapsed, depth, path) {
      if (!node || _this.props.selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      var _this$props = _this.props,
          data = _this$props.data,
          value = _this$props.value,
          isSelectRecursive = _this$props.isSelectRecursive,
          idProp = _this$props.idProp,
          onSelect = _this$props.onSelect,
          onChange = _this$props.onChange;
      var result = value && (0, _isArray["default"])(value) ? value.slice() : [];

      _TableCalculation["default"].handleSelect(node, result, idProp, isSelectRecursive);

      if (isSelectRecursive) {
        result = _TableCalculation["default"].formatValue(result, data, idProp);
      }

      onSelect && onSelect(node, rowIndex, colIndex, collapsed, depth, path);
      onChange && onChange(result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDeselect", function (node, rowIndex, colIndex, collapsed, depth, path) {
      if (!node || _this.props.selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      var _this$props2 = _this.props,
          isSelectRecursive = _this$props2.isSelectRecursive,
          value = _this$props2.value,
          idProp = _this$props2.idProp,
          onDeselect = _this$props2.onDeselect,
          onChange = _this$props2.onChange;
      var result = value && (0, _isArray["default"])(value) ? value.slice() : [];

      if (result.length > 0) {
        _TableCalculation["default"].handleDeselect(node, result, idProp, isSelectRecursive);

        if (isSelectRecursive) {
          result = _TableCalculation["default"].formatValue(result, data, idProp);
        }
      }

      onDeselect && onDeselect(node, rowIndex, colIndex, collapsed, depth, path);
      onChange && onChange(result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAll", function () {
      var _this$props3 = _this.props,
          selectMode = _this$props3.selectMode,
          selectAllMode = _this$props3.selectAllMode,
          data = _this$props3.data,
          value = _this$props3.value,
          disabled = _this$props3.disabled,
          idProp = _this$props3.idProp,
          onChange = _this$props3.onChange,
          onSelectAll = _this$props3.onSelectAll;

      if (disabled || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      _TableCalculation["default"].handleSelectAll(selectAllMode === _SelectAllMode["default"].ALL ? data : _this.tableData, value, idProp);

      onSelectAll && onSelectAll(value);
      onChange && onChange(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDeselectAll", function () {
      var _this$props4 = _this.props,
          selectMode = _this$props4.selectMode,
          value = _this$props4.value,
          disabled = _this$props4.disabled,
          onChange = _this$props4.onChange,
          onDeselectAll = _this$props4.onDeselectAll;

      if (disabled || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }

      onDeselectAll && onDeselectAll(value);
      onChange && onChange([]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "formatColumns", function () {
      var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.sortedColumns || _this.props.columns;

      if (!columns || columns.length < 1) {
        return columns;
      }

      var _this$props5 = _this.props,
          selectTheme = _this$props5.selectTheme,
          selectMode = _this$props5.selectMode,
          selectAllMode = _this$props5.selectAllMode,
          selectColumn = _this$props5.selectColumn,
          data = _this$props5.data,
          disabled = _this$props5.disabled,
          value = _this$props5.value,
          idProp = _this$props5.idProp,
          expandIconCls = _this$props5.expandIconCls,
          selectUncheckedIconCls = _this$props5.selectUncheckedIconCls,
          selectCheckedIconCls = _this$props5.selectCheckedIconCls,
          selectIndeterminateIconCls = _this$props5.selectIndeterminateIconCls,
          firstColumn = _TableCalculation["default"].getFirstColumn(columns),
          result = columns.slice();
      /**
       * handle expand
       */


      result[0] = (0, _cloneDeep["default"])(columns[0]);

      var expandColumn = _TableCalculation["default"].getFirstColumn(result);

      if (expandColumn) {
        expandColumn.bodyRenderer = function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
          return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("span", {
            className: (0, _classnames["default"])('table-indent', "indent-level-".concat(depth)),
            style: {
              paddingLeft: depth * 20
            }
          }), _TableCalculation["default"].needCollapseButtonSpacing(tableData) ? _react["default"].createElement(_IconButton["default"], {
            className: (0, _classnames["default"])('expand-button', {
              hidden: !rowData || !rowData.children || rowData.children.length < 1
            }),
            iconCls: expandIconCls,
            disableTouchRipple: true,
            onClick: function onClick() {
              return _this.handleExpandChange(!collapsed, rowData);
            }
          }) : null, typeof firstColumn.bodyRenderer === 'function' ? firstColumn.bodyRenderer(rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) : firstColumn.bodyRenderer);
        };

        expandColumn.bodyNoWrap = function (rowData, rowIndex, colIndex, tableData) {
          return _TableCalculation["default"].needCollapseButtonSpacing(tableData);
        };
      }
      /**
       * handle multi select
       */


      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        result.unshift(_objectSpread({}, selectColumn, {
          fixed: selectColumn && selectColumn.fixed || columns[0].fixed,
          align: selectColumn && selectColumn.align || _HorizontalAlign["default"].CENTER,
          headClassName: (0, _classnames["default"])('table-select-th', selectColumn ? (0, _defineProperty2["default"])({}, selectColumn.headClassName, selectColumn.headClassName) : ''),
          headRenderer: function headRenderer() {
            var _TC$isSelectAllChecke = _TableCalculation["default"].isSelectAllChecked(selectAllMode === _SelectAllMode["default"].ALL ? data : _this.tableData, value, idProp),
                checked = _TC$isSelectAllChecke.checked,
                indeterminate = _TC$isSelectAllChecke.indeterminate;

            return _react["default"].createElement(_Checkbox["default"], {
              className: "table-select",
              theme: selectTheme,
              checked: checked,
              disabled: disabled,
              indeterminate: indeterminate,
              uncheckedIconCls: selectUncheckedIconCls,
              checkedIconCls: selectCheckedIconCls,
              indeterminateIconCls: selectIndeterminateIconCls,
              onCheck: _this.handleSelectAll,
              onUncheck: _this.handleDeselectAll
            });
          },
          bodyClassName: (0, _classnames["default"])('table-select-td', selectColumn ? (0, _defineProperty2["default"])({}, selectColumn.bodyClassName, selectColumn.bodyClassName) : ''),
          bodyRenderer: function bodyRenderer(rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
            return _react["default"].createElement(_Checkbox["default"], {
              className: "table-select",
              theme: selectTheme,
              checked: _TableCalculation["default"].isNodeChecked(rowData, value, idProp),
              disabled: disabled || rowData.disabled,
              indeterminate: _Calculation["default"].isItemIndeterminate(rowData, value, idProp),
              uncheckedIconCls: selectUncheckedIconCls,
              checkedIconCls: selectCheckedIconCls,
              indeterminateIconCls: selectIndeterminateIconCls,
              onCheck: function onCheck() {
                return _this.handleSelect(rowData, rowIndex, colIndex, tableData, collapsed, depth, path);
              },
              onUncheck: function onUncheck() {
                return _this.handleDeselect(rowData, rowIndex, colIndex, tableData, collapsed, depth, path);
              }
            });
          }
        }));
      }

      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "sortData", function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.data;
      var _this$props6 = _this.props,
          sorting = _this$props6.sorting,
          autoSorting = _this$props6.autoSorting,
          sortingFunc = _this$props6.sortingFunc;
      return autoSorting && sorting ? _TableCalculation["default"].sortTableData(data, sorting, sortingFunc) : data;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "paginateData", function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.data;

      if (!data) {
        return [];
      }

      if (!_this.props.isPaginated) {
        return data;
      }

      var _this$props7 = _this.props,
          page = _this$props7.page,
          pageSize = _this$props7.pageSize,
          len = data.length;
      var start = page * pageSize,
          stop = start + pageSize;
      start = start < 0 ? 0 : start;
      stop = stop > len ? len : stop;
      return data.slice(start, stop);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "fixLayout", function () {
      if (_this.wrapperEl && _TableLayout["default"].hasFixed(_this.props, (0, _assertThisInitialized2["default"])(_this))) {
        _TableLayout["default"].fixLayout(_this.wrapperEl, _this.rawTableEl, _this.props);

        _TableLayout["default"].updateHorizontalScrollClassNames(_this.wrapperEl, _this.centerHeadScroller);
      } // trigger initial callback at startup


      var _this$props8 = _this.props,
          isInitialing = _this$props8.isInitialing,
          onInit = _this$props8.onInit;
      isInitialing && onInit && onInit();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceFixLayout", (0, _debounce["default"])(function () {
      return _this.fixLayout();
    }, 150));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleGetScrollerEl", function (el, fixed, fragment) {
      _this["".concat(fixed).concat((0, _startCase["default"])(fragment), "Scroller")] = el;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHorizontalScroll", function (e) {
      if (!e || e.currentTarget !== e.target) {
        return;
      }

      var _this$props9 = _this.props,
          isHeadFixed = _this$props9.isHeadFixed,
          isFootFixed = _this$props9.isFootFixed,
          target = e.target,
          scrollLeft = target.scrollLeft;

      if (scrollLeft !== _this.lastScrollLeft) {
        switch (target) {
          case _this.centerBodyScroller:
            {
              if (isHeadFixed && _this.centerHeadScroller) {
                _this.centerHeadScroller.scrollLeft = scrollLeft;
              }

              if (isFootFixed && _this.centerHeadScroller && _this.centerFootScroller) {
                _this.centerFootScroller.scrollLeft = scrollLeft;
              }

              break;
            }

          case _this.centerHeadScroller:
            {
              if (_this.centerBodyScroller) {
                _this.centerBodyScroller.scrollLeft = scrollLeft;
              }

              if (isFootFixed && _this.centerHeadScroller && _this.centerFootScroller) {
                _this.centerFootScroller.scrollLeft = scrollLeft;
              }

              break;
            }

          case _this.centerFootScroller:
            {
              if (isHeadFixed && _this.centerHeadScroller) {
                _this.centerHeadScroller.scrollLeft = scrollLeft;
              }

              if (_this.centerBodyScroller) {
                _this.centerBodyScroller.scrollLeft = scrollLeft;
              }

              break;
            }
        }

        _TableLayout["default"].updateHorizontalScrollClassNames(_this.wrapperEl, _this.centerHeadScroller);
      }

      _this.lastScrollLeft = scrollLeft;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleVerticalScroll", function (e) {
      if (!e || e.currentTarget !== e.target) {
        return;
      }

      var target = e.target,
          scrollTop = target.scrollTop;

      if (scrollTop !== _this.lastScrollTop && (target != _this.centerHeadScroller || target != _this.centerFootScroller)) {
        switch (target) {
          case _this.centerBodyScroller:
            {
              if (_this.leftBodyScroller) {
                _this.leftBodyScroller.scrollTop = scrollTop;
              }

              if (_this.rightBodyScroller) {
                _this.rightBodyScroller.scrollTop = scrollTop;
              }

              break;
            }

          case _this.leftBodyScroller:
            {
              if (_this.centerBodyScroller) {
                _this.centerBodyScroller.scrollTop = scrollTop;
              }

              if (_this.rightBodyScroller) {
                _this.rightBodyScroller.scrollTop = scrollTop;
              }

              break;
            }

          case _this.rightBodyScroller:
            {
              if (_this.leftBodyScroller) {
                _this.leftBodyScroller.scrollTop = scrollTop;
              }

              if (_this.centerBodyScroller) {
                _this.centerBodyScroller.scrollTop = scrollTop;
              }

              break;
            }
        }
      }

      _this.lastScrollTop = scrollTop;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function (e) {
      _this.handleHorizontalScroll(e);

      _this.handleVerticalScroll(e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleWheel", function (e) {
      if (!window.navigator.userAgent.match(/Trident\/7\./)) {
        return;
      }

      e.preventDefault();
      var wd = e.deltaY,
          target = e.target;
      var scrollTop = 0;

      if (_this.lastScrollTop) {
        scrollTop = _this.lastScrollTop + wd;
      } else {
        scrollTop = wd;
      }

      if (_this.leftBodyScroller && _this.leftBodyScroller !== target) {
        _this.leftBodyScroller.scrollTop = scrollTop;
      }

      if (_this.centerBodyScroller && _this.centerBodyScroller !== target) {
        _this.centerBodyScroller.scrollTop = scrollTop;
      }

      if (_this.rightBodyScroller && _this.rightBodyScroller !== target) {
        _this.rightBodyScroller.scrollTop = scrollTop;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExpandChange", function (collapsed, rowData) {
      var _this$props10 = _this.props,
          idProp = _this$props10.idProp,
          expandRows = _this$props10.expandRows,
          onExpand = _this$props10.onExpand,
          onCollapse = _this$props10.onCollapse,
          onExpandChange = _this$props10.onExpandChange;

      if (collapsed) {
        onCollapse && onCollapse(rowData);

        var index = _TableCalculation["default"].indexOfNodeInValue(rowData, expandRows, idProp);

        if (index !== -1) {
          expandRows.splice(index, 1);
          onExpandChange && onExpandChange(expandRows);
        }
      } else {
        onExpand && onExpand(rowData);

        var _index = _TableCalculation["default"].indexOfNodeInValue(rowData, expandRows, idProp);

        if (_index === -1) {
          expandRows.push(rowData);
          onExpandChange && onExpandChange(expandRows, function () {
            var _this$props11 = _this.props,
                value = _this$props11.value,
                selectMode = _this$props11.selectMode,
                isSelectRecursive = _this$props11.isSelectRecursive,
                onChange = _this$props11.onChange;

            if (selectMode === _SelectMode["default"].MULTI_SELECT && isSelectRecursive) {
              onChange && onChange(_TableCalculation["default"].recursiveSelectChildren(rowData, value));
            }
          });
        }
      }
    });
    _this.leftBodyScroller = null;
    _this.centerHeadScroller = null;
    _this.centerBodyScroller = null;
    _this.centerFootScroller = null;
    _this.rightBodyScroller = null;
    _this.lastScrollLeft = 0;
    _this.lastScrollTop = 0;
    _this.wrapper = (0, _react.createRef)();
    _this.wrapperEl = null;
    _this.rawTable = (0, _react.createRef)();
    _this.rawTableEl = null;
    _this.fixedLeft = (0, _react.createRef)();
    _this.fixedLeftEl = null;
    _this.fixedRight = (0, _react.createRef)();
    _this.fixedRightEl = null; // sorted current page cache data

    _this.tableData = [];
    return _this;
  }
  /**
   * handle one node selected
   * @param node
   * @param rowIndex
   * @param colIndex
   * @param collapsed
   * @param depth
   * @param path
   */


  (0, _createClass2["default"])(TableContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // get elements
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.rawTableEl = this.rawTable && this.rawTable.current && (0, _reactDom.findDOMNode)(this.rawTable.current);
      this.fixedLeftEl = this.fixedLeft && this.fixedLeft.current && (0, _reactDom.findDOMNode)(this.fixedLeft.current);
      this.fixedRightEl = this.fixedRight && this.fixedRight.current && (0, _reactDom.findDOMNode)(this.fixedRight.current); // bind event

      _Event["default"].addEvent(window, 'resize', this.debounceFixLayout); // fixed layout at startup


      this.debounceFixLayout();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.debounceFixLayout();
      var onDataUpdate = this.props.onDataUpdate;
      onDataUpdate && onDataUpdate(this.tableData);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(window, 'resize', this.debounceFixLayout);

      this.debounceFixLayout && this.debounceFixLayout.cancel();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props12 = this.props,
          className = _this$props12.className,
          style = _this$props12.style,
          columns = _this$props12.columns,
          data = _this$props12.data,
          scroll = _this$props12.scroll,
          noDataText = _this$props12.noDataText,
          isHeadFixed = _this$props12.isHeadFixed,
          isFootFixed = _this$props12.isFootFixed,
          isHeadHidden = _this$props12.isHeadHidden,
          isFootHidden = _this$props12.isFootHidden,
          isInitialing = _this$props12.isInitialing,
          isSelectRecursive = _this$props12.isSelectRecursive,
          selectUncheckedIconCls = _this$props12.selectUncheckedIconCls,
          selectCheckedIconCls = _this$props12.selectCheckedIconCls,
          selectIndeterminateIconCls = _this$props12.selectIndeterminateIconCls,
          selectColumn = _this$props12.selectColumn,
          expandIconCls = _this$props12.expandIconCls,
          autoSorting = _this$props12.autoSorting,
          isPaginated = _this$props12.isPaginated,
          page = _this$props12.page,
          pageSize = _this$props12.pageSize,
          sortingFunc = _this$props12.sortingFunc,
          onInit = _this$props12.onInit,
          onChange = _this$props12.onChange,
          onExpand = _this$props12.onExpand,
          onCollapse = _this$props12.onCollapse,
          onExpandChange = _this$props12.onExpandChange,
          onDataUpdate = _this$props12.onDataUpdate,
          onSelect = _this$props12.onSelect,
          onSelectAll = _this$props12.onSelectAll,
          onDeselect = _this$props12.onDeselect,
          onDeselectAll = _this$props12.onDeselectAll,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props12, ["className", "style", "columns", "data", "scroll", "noDataText", "isHeadFixed", "isFootFixed", "isHeadHidden", "isFootHidden", "isInitialing", "isSelectRecursive", "selectUncheckedIconCls", "selectCheckedIconCls", "selectIndeterminateIconCls", "selectColumn", "expandIconCls", "autoSorting", "isPaginated", "page", "pageSize", "sortingFunc", "onInit", "onChange", "onExpand", "onCollapse", "onExpandChange", "onDataUpdate", "onSelect", "onSelectAll", "onDeselect", "onDeselectAll"]),
          _TC$sortColumns = _TableCalculation["default"].sortColumns(columns),
          sortedColumns = _TC$sortColumns.sortedColumns,
          hasFixedLeftColumn = _TC$sortColumns.hasFixedLeftColumn,
          hasFixedRightColumn = _TC$sortColumns.hasFixedRightColumn;

      this.sortedColumns = sortedColumns;
      this.hasFixedLeftColumn = hasFixedLeftColumn;
      this.hasFixedRightColumn = hasFixedRightColumn;
      this.formatedColumns = this.formatColumns(this.sortedColumns);
      this.headColumns = _TableCalculation["default"].getHeadColumns(this.formatedColumns);
      this.bodyColumns = _TableCalculation["default"].getBodyColumns(this.formatedColumns);

      if (!this.formatedColumns) {
        return null;
      }

      this.fixedRightColumns = this.formatedColumns.filter(function (column) {
        return column && column.fixed === _HorizontalAlign["default"].RIGHT;
      });
      this.tableData = this.paginateData(this.sortData(data));

      var _TL$getScrollerStyle = _TableLayout["default"].getScrollerStyle(scroll),
          horizontalScrollStyle = _TL$getScrollerStyle.horizontalScrollStyle,
          verticalScrollStyle = _TL$getScrollerStyle.verticalScrollStyle,
          isFinalHeadHidden = isHeadHidden || !_TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].HEAD),
          isFinalFootHidden = isFootHidden || !_TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].FOOT),
          hasHeadRenderer = _TableCalculation["default"].hasHeadRenderer(this.headColumns),
          hasBodyRenderer = _TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].BODY),
          hasFootRenderer = _TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].FOOT);

      return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('table-content', (0, _defineProperty2["default"])({
          'head-fixed': isHeadFixed,
          'foot-fixed': isFootFixed
        }, className, className)),
        style: style
      }, _react["default"].createElement("div", {
        className: "table-content-raw"
      }, _react["default"].createElement(_BaseTable["default"], {
        ref: this.rawTable,
        style: scroll,
        headColumns: this.headColumns,
        bodyColumns: this.bodyColumns,
        data: this.tableData,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isHeadHidden: isFinalHeadHidden,
        isFootHidden: isFinalFootHidden,
        hasHeadRenderer: hasHeadRenderer,
        hasBodyRenderer: hasBodyRenderer,
        hasFootRenderer: hasFootRenderer
      })), _react["default"].createElement(_ScrollTable["default"], (0, _extends2["default"])({}, restProps, {
        className: "table-content-center",
        bodyScrollerStyle: verticalScrollStyle,
        maskStyle: horizontalScrollStyle,
        tableStyle: horizontalScrollStyle,
        headColumns: _TableCalculation["default"].handleFixedColumnsClassName(this.headColumns),
        bodyColumns: _TableCalculation["default"].handleFixedColumnsClassName(this.bodyColumns),
        data: this.tableData,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isHeadHidden: isFinalHeadHidden,
        isFootHidden: isFinalFootHidden,
        hasFixedLeftColumn: hasFixedLeftColumn,
        hasFixedRightColumn: hasFixedRightColumn,
        hasHeadRenderer: hasHeadRenderer,
        hasBodyRenderer: hasBodyRenderer,
        hasFootRenderer: hasFootRenderer,
        scroll: scroll,
        onScroll: this.handleScroll,
        onWheel: this.handleWheel,
        onGetHeadScrollerEl: function onGetHeadScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].CENTER, _TableFragment["default"].HEAD);
        },
        onGetBodyScrollerEl: function onGetBodyScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].CENTER, _TableFragment["default"].BODY);
        },
        onGetFootScrollerEl: function onGetFootScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].CENTER, _TableFragment["default"].FOOT);
        }
      })), hasFixedLeftColumn ? _react["default"].createElement(_ScrollTable["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.fixedLeft,
        className: "table-content-left",
        bodyScrollerStyle: verticalScrollStyle,
        fixed: _HorizontalAlign["default"].LEFT,
        headColumns: _TableCalculation["default"].getFixedHeadColumns(this.headColumns, _HorizontalAlign["default"].LEFT),
        bodyColumns: _TableCalculation["default"].getFixedBodyColumns(this.bodyColumns, _HorizontalAlign["default"].LEFT),
        data: this.tableData,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isHeadHidden: isFinalHeadHidden,
        isFootHidden: isFinalFootHidden,
        hasFixedLeftColumn: hasFixedLeftColumn,
        hasFixedRightColumn: hasFixedRightColumn,
        hasHeadRenderer: hasHeadRenderer,
        hasBodyRenderer: hasBodyRenderer,
        hasFootRenderer: hasFootRenderer,
        scroll: scroll,
        onGetHeadScrollerEl: function onGetHeadScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].LEFT, _TableFragment["default"].HEAD);
        },
        onGetBodyScrollerEl: function onGetBodyScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].LEFT, _TableFragment["default"].BODY);
        },
        onGetFootScrollerEl: function onGetFootScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].LEFT, _TableFragment["default"].FOOT);
        },
        onScroll: this.handleScroll,
        onWheel: this.handleWheel,
        onExpandChange: this.handleExpandChange
      })) : null, hasFixedRightColumn ? _react["default"].createElement(_ScrollTable["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.fixedRight,
        className: "table-content-right",
        bodyScrollerStyle: verticalScrollStyle,
        fixed: _HorizontalAlign["default"].RIGHT,
        headColumns: _TableCalculation["default"].getFixedHeadColumns(this.headColumns, _HorizontalAlign["default"].RIGHT),
        bodyColumns: _TableCalculation["default"].getFixedBodyColumns(this.bodyColumns, _HorizontalAlign["default"].RIGHT),
        data: this.tableData,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isHeadHidden: isFinalHeadHidden,
        isFootHidden: isFinalFootHidden,
        hasFixedLeftColumn: hasFixedLeftColumn,
        hasFixedRightColumn: hasFixedRightColumn,
        hasHeadRenderer: hasHeadRenderer,
        hasBodyRenderer: hasBodyRenderer,
        hasFootRenderer: hasFootRenderer,
        scroll: scroll,
        baseColIndex: this.formatedColumns.length - this.fixedRightColumns.length,
        onScroll: this.handleScroll,
        onWheel: this.handleWheel,
        onGetHeadScrollerEl: function onGetHeadScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].RIGHT, _TableFragment["default"].HEAD);
        },
        onGetBodyScrollerEl: function onGetBodyScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].RIGHT, _TableFragment["default"].BODY);
        },
        onGetFootScrollerEl: function onGetFootScrollerEl(el) {
          return _this2.handleGetScrollerEl(el, _HorizontalAlign["default"].RIGHT, _TableFragment["default"].FOOT);
        }
      })) : null), noDataText && (!this.tableData || this.tableData.length < 1) ? _react["default"].createElement("div", {
        className: "table-no-data"
      }, noDataText) : null);
    }
  }]);
  return TableContent;
}(_react.Component);

(0, _defineProperty2["default"])(TableContent, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(TableContent, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(TableContent, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(TableContent, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TableContent, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(TableContent, "SortingType", _SortingType["default"]);
TableContent.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  hoverRowIndex: _propTypes["default"].number,
  idProp: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isInitialing: _propTypes["default"].bool,
  noDataText: _propTypes["default"].string,

  /**
   * expand
   */
  expandRows: _propTypes["default"].array,
  expandIconCls: _propTypes["default"].string,

  /**
   * selection
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  selectColumn: _propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' )
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"]))
  }),
  isSelectRecursive: _propTypes["default"].bool,
  selectUncheckedIconCls: _propTypes["default"].string,
  selectCheckedIconCls: _propTypes["default"].string,
  selectIndeterminateIconCls: _propTypes["default"].string,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  autoSorting: _propTypes["default"].bool,
  sortingFunc: _propTypes["default"].func,

  /**
   * pagination
   */
  isPaginated: _propTypes["default"].bool,
  page: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,

  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,

  /**
   * fixed
   */
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,

  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),

  /**
   * callback
   */
  onInit: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onSelectAll: _propTypes["default"].func,
  onDeselectAll: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onRowHover: _propTypes["default"].func,
  onDataUpdate: _propTypes["default"].func
};
TableContent.defaultProps = {
  disabled: false,
  isInitialing: true,
  idProp: 'id',
  noDataText: 'No Data',

  /**
   * expand
   */
  expandRows: [],
  expandIconCls: 'fas fa-chevron-right',

  /**
   * selection
   */
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  isSelectRecursive: false,
  selectUncheckedIconCls: 'far fa-square',
  selectCheckedIconCls: 'fas fa-check-square',
  selectIndeterminateIconCls: 'fas fa-minus-square',

  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  autoSorting: true,

  /**
   * pagination
   */
  isPaginated: true,
  page: 0,
  pageSize: 10,

  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,

  /**
   * fixed
   */
  isHeadFixed: false,
  isFootFixed: false
};
var _default = TableContent;
exports["default"] = _default;