"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tr = _interopRequireDefault(require("../_Tr"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Tbody component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tbody =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tbody, _Component);

  function Tbody(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Tbody);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tbody)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemChecked", function (rowData) {
      var _this$props = _this.props,
          selectMode = _this$props.selectMode,
          idProp = _this$props.idProp,
          value = _this$props.value;

      if (!rowData || !value || selectMode === _SelectMode["default"].NORMAL) {
        return false;
      }

      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          return value && value.findIndex(function (item) {
            return item[idProp] === rowData[idProp];
          }) !== -1;

        case _SelectMode["default"].SINGLE_SELECT:
          return value[idProp] === rowData[idProp];
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrMouseEnter", function (e, rowIndex) {
      var onRowHover = _this.props.onRowHover;
      onRowHover && onRowHover(rowIndex);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTrMouseLeave", function (e, rowIndex) {
      var onRowHover = _this.props.onRowHover;
      onRowHover && onRowHover(null);
    });
    return _this;
  }

  (0, _createClass2["default"])(Tbody, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          columns = _this$props2.columns,
          data = _this$props2.data,
          startIndex = _this$props2.startIndex,
          idProp = _this$props2.idProp,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["className", "style", "columns", "data", "startIndex", "idProp", "disabled", "value"]);
      return _react["default"].createElement("tbody", {
        className: className,
        style: style
      }, data && data.map(function (row, index) {
        return row ? _react["default"].createElement(_Tr["default"], (0, _extends2["default"])({}, restProps, {
          key: idProp && idProp in row ? row[idProp] : index,
          index: index,
          rowIndex: startIndex + index,
          columns: columns,
          data: row,
          tableData: data,
          isChecked: _this2.isItemChecked(row),
          disabled: disabled || row.disabled,
          onMouseEnter: _this2.handleTrMouseEnter,
          onMouseLeave: _this2.handleTrMouseLeave
        })) : null;
      }));
    }
  }]);
  return Tbody;
}(_react.Component);

(0, _defineProperty2["default"])(Tbody, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tbody, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tbody, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Tbody, "SortingType", _SortingType["default"]);
Tbody.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,

  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),

  /**
   * The select all mode of table, all or current page.
   */
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  hoverRowIndex: _propTypes["default"].number,
  startIndex: _propTypes["default"].number,
  idProp: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  baseColIndex: _propTypes["default"].number,
  expandRows: _propTypes["default"].array,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),

  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onRowHover: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func
};
Tbody.defaultProps = {
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  startIndex: 0,
  idProp: 'id',
  disabled: false,
  baseColIndex: 0,
  expandRows: []
};
var _default = Tbody;
exports["default"] = _default;