"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Td component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Td =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Td, _Component);

  function Td(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Td);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Td)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRenderer", function () {
      var _this$props = _this.props,
          collapsed = _this$props.collapsed,
          renderer = _this$props.renderer,
          rowIndex = _this$props.rowIndex,
          colIndex = _this$props.colIndex,
          data = _this$props.data,
          parentData = _this$props.parentData,
          tableData = _this$props.tableData,
          depth = _this$props.depth,
          path = _this$props.path;

      switch ((0, _typeof2["default"])(renderer)) {
        case 'function':
          return renderer(data, rowIndex, colIndex, parentData, tableData, collapsed, depth, path);

        default:
          return renderer;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props2 = _this.props,
          data = _this$props2.data,
          rowIndex = _this$props2.rowIndex,
          colIndex = _this$props2.colIndex,
          disabled = _this$props2.disabled,
          onCellClick = _this$props2.onCellClick;
      !disabled && onCellClick && onCellClick(data, rowIndex, colIndex, e);
    });
    return _this;
  }

  (0, _createClass2["default"])(Td, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          align = _this$props3.align,
          span = _this$props3.span,
          noWrap = _this$props3.noWrap,
          sortable = _this$props3.sortable,
          sortingProp = _this$props3.sortingProp,
          sorting = _this$props3.sorting;
      return _react["default"].createElement("td", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, 'no-wrap', noWrap), (0, _defineProperty2["default"])(_classNames, "sorting", sortable && sortingProp && sorting && sorting.prop && sorting.prop === sortingProp), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        colSpan: span || null,
        onClick: this.handleClick
      }, this.handleRenderer());
    }
  }]);
  return Td;
}(_react.Component);

(0, _defineProperty2["default"])(Td, "Align", _HorizontalAlign["default"]);
Td.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  rowIndex: _propTypes["default"].number,
  colIndex: _propTypes["default"].number,
  data: _propTypes["default"].object,
  parentData: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  renderer: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]),
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  span: _propTypes["default"].number,
  disabled: _propTypes["default"].bool,
  noWrap: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,

  /**
   * sorting
   */
  sortable: _propTypes["default"].bool,
  sortingProp: _propTypes["default"].string,
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),

  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func
};
Td.defaultProps = {
  rowIndex: 0,
  colIndex: 0,
  disabled: false,
  noWrap: false,
  collapsed: true,
  depth: 0
};
var _default = Td;
exports["default"] = _default;