"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Tf = _interopRequireDefault(require("../_Tf"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

/**
 * @file Tfoot component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tfoot =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tfoot, _Component);

  function Tfoot(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Tfoot);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tfoot)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
          data = _this$props.data,
          disabled = _this$props.disabled,
          onFootClick = _this$props.onFootClick;
      !disabled && onFootClick && onFootClick(data, e);
    });
    return _this;
  }

  (0, _createClass2["default"])(Tfoot, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          className = _this$props2.className,
          columns = _this$props2.columns,
          data = _this$props2.data,
          disabled = _this$props2.disabled,
          baseColIndex = _this$props2.baseColIndex,
          onCellClick = _this$props2.onCellClick,
          columnsWithSpan = _TableCalculation["default"].getColumnsWithSpan(_TableFragment["default"].FOOT, columns, data);

      return _react["default"].createElement("tfoot", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, className, className), (0, _defineProperty2["default"])(_classNames, data.rowClassName, data.rowClassName), _classNames)),
        style: data.rowStyle,
        disabled: disabled,
        onClick: this.handleClick
      }, _react["default"].createElement("tr", null, columnsWithSpan && columnsWithSpan.map(function (_ref, colIndex) {
        var column = _ref.column,
            span = _ref.span;
        return _react["default"].createElement(_Tf["default"], {
          key: colIndex,
          className: column.footClassName,
          style: column.footStyle,
          colIndex: baseColIndex + colIndex,
          data: data,
          renderer: column.footRenderer,
          align: column.footAlign || column.align,
          span: span,
          noWrap: _TableCalculation["default"].handleNoWrap(column.footNoWrap, column.noWrap, {
            data: data,
            rowIndex: 0,
            colIndex: baseColIndex + colIndex,
            tableData: data
          }),
          disabled: disabled,
          onCellClick: onCellClick
        });
      })));
    }
  }]);
  return Tfoot;
}(_react.Component);

(0, _defineProperty2["default"])(Tfoot, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tfoot, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tfoot, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Tfoot, "SortingType", _SortingType["default"]);
Tfoot.propTypes = {
  className: _propTypes["default"].string,

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired,
  data: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  baseColIndex: _propTypes["default"].number,
  onFootClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func
};
Tfoot.defaultProps = {
  disabled: false,
  baseColIndex: 0
};
var _default = Tfoot;
exports["default"] = _default;