"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ThSortingIcon = _interopRequireDefault(require("../_ThSortingIcon"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Th component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Th =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Th, _Component);

  function Th(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Th);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Th)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props = _this.props,
          colIndex = _this$props.colIndex,
          data = _this$props.data,
          renderer = _this$props.renderer;

      switch ((0, _typeof2["default"])(renderer)) {
        case 'function':
          return renderer(data, colIndex);

        default:
          return renderer;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props2 = _this.props,
          sortable = _this$props2.sortable,
          onSortChange = _this$props2.onSortChange;

      if (!sortable || !onSortChange) {
        return;
      }

      var _this$props3 = _this.props,
          sorting = _this$props3.sorting,
          defaultSortingType = _this$props3.defaultSortingType,
          sortingProp = _this$props3.sortingProp;
      var result = {};

      if (sorting && sorting.prop === sortingProp) {
        result.prop = sorting.prop;

        if (!sorting.type) {
          result.type = defaultSortingType;
        } else if (sorting.type === defaultSortingType) {
          result.type = -defaultSortingType;
        } else {
          result = null;
        }
      } else {
        result.prop = sortingProp;
        result.type = defaultSortingType;
      }

      onSortChange && onSortChange(result);
    });
    return _this;
  }
  /**
   * handle th content render
   * @returns {*}
   */


  (0, _createClass2["default"])(Th, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props4 = this.props,
          className = _this$props4.className,
          style = _this$props4.style,
          renderer = _this$props4.renderer,
          align = _this$props4.align,
          rowSpan = _this$props4.rowSpan,
          colSpan = _this$props4.colSpan,
          noWrap = _this$props4.noWrap,
          sortable = _this$props4.sortable,
          sortingProp = _this$props4.sortingProp,
          sorting = _this$props4.sorting,
          sortingAscIconCls = _this$props4.sortingAscIconCls,
          sortingDescIconCls = _this$props4.sortingDescIconCls;
      return _react["default"].createElement("th", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, "sortable", sortable), (0, _defineProperty2["default"])(_classNames, "sorting", sortable && sortingProp && sorting && sorting.prop && sorting.prop === sortingProp), (0, _defineProperty2["default"])(_classNames, 'no-wrap', sortable || noWrap), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        title: typeof renderer === 'string' ? renderer : null,
        rowSpan: rowSpan,
        colSpan: colSpan,
        onClick: this.handleClick
      }, _react["default"].createElement("span", {
        className: "th-column"
      }, _react["default"].createElement("span", {
        className: (0, _classnames["default"])('th-column-title', {
          'no-wrap': noWrap
        })
      }, this.handleRender()), sortable ? _react["default"].createElement(_ThSortingIcon["default"], {
        sorting: sorting,
        sortingProp: sortingProp,
        sortingAscIconCls: sortingAscIconCls,
        sortingDescIconCls: sortingDescIconCls
      }) : null));
    }
  }]);
  return Th;
}(_react.Component);

(0, _defineProperty2["default"])(Th, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Th, "SortingType", _SortingType["default"]);
Th.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  renderer: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]),
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  colIndex: _propTypes["default"].number,
  data: _propTypes["default"].array,
  noWrap: _propTypes["default"].bool,
  rowSpan: _propTypes["default"].number,
  colSpan: _propTypes["default"].number,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  sortable: _propTypes["default"].bool,
  sortingProp: _propTypes["default"].string,
  onSortChange: _propTypes["default"].func
};
Th.defaultProps = {
  colIndex: 0,
  noWrap: false,
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  sortable: false
};
var _default = Th;
exports["default"] = _default;