"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Th = _interopRequireDefault(require("../_Th"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

/**
 * @file Thead component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Thead =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Thead, _Component);

  function Thead(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, Thead);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Thead)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(Thead, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          columns = _this$props.columns,
          baseColIndex = _this$props.baseColIndex,
          data = _this$props.data,
          sorting = _this$props.sorting,
          defaultSortingType = _this$props.defaultSortingType,
          sortingAscIconCls = _this$props.sortingAscIconCls,
          sortingDescIconCls = _this$props.sortingDescIconCls,
          onSortChange = _this$props.onSortChange,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "columns", "baseColIndex", "data", "sorting", "defaultSortingType", "sortingAscIconCls", "sortingDescIconCls", "onSortChange"]);
      return _react["default"].createElement("thead", {
        className: className,
        style: style
      }, columns && columns.map(function (row, rowIndex) {
        return row ? _react["default"].createElement("tr", {
          key: rowIndex
        }, _TableCalculation["default"].getColumnsWithSpan(_TableFragment["default"].HEAD, row, data).map(function (_ref, colIndex) {
          var column = _ref.column,
              span = _ref.span;
          return column ? _react["default"].createElement(_Th["default"], (0, _extends2["default"])({}, restProps, {
            key: colIndex,
            className: column.headClassName,
            style: column.headStyle,
            data: data,
            renderer: column.headRenderer,
            align: column.headAlign || column.align,
            colIndex: baseColIndex + colIndex,
            rowSpan: column.rowSpan,
            colSpan: column.colSpan,
            noWrap: _TableCalculation["default"].handleNoWrap(column.headNoWrap, column.noWrap, {
              data: data,
              rowIndex: rowIndex,
              colIndex: baseColIndex + colIndex,
              tableData: data
            }),
            sorting: sorting,
            defaultSortingType: column.defaultSortingType || defaultSortingType,
            sortingAscIconCls: sortingAscIconCls,
            sortingDescIconCls: sortingDescIconCls,
            sortable: column.sortable,
            sortingProp: column.sortingProp,
            onSortChange: onSortChange
          })) : null;
        })) : null;
      }));
    }
  }]);
  return Thead;
}(_react.Component);

(0, _defineProperty2["default"])(Thead, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Thead, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Thead, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Thead, "SortingType", _SortingType["default"]);
Thead.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }))).isRequired,
  data: _propTypes["default"].array,
  baseColIndex: _propTypes["default"].number,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  onSortChange: _propTypes["default"].func
};
Thead.defaultProps = {
  baseColIndex: 0,
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down'
};
var _default = Thead;
exports["default"] = _default;