"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TimeItems = _interopRequireDefault(require("../_TimeItems"));

/**
 * @file TimeList component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var TimeList =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TimeList, _Component);

  function TimeList(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TimeList);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TimeList)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "rangeData", function (range, minValue, maxValue) {
      var isRequired = _this.props.isRequired;
      var arr = [];

      for (var i = 0; i < range; i++) {
        if (i < 10) {
          i = '0' + i;
        }

        var obj = void 0;

        if (isRequired) {
          +i > +maxValue || +i < +minValue ? obj = {
            text: i,
            value: false
          } : obj = {
            text: i,
            value: true
          };
        } else {
          obj = {
            text: i,
            value: true
          };
        }

        arr.push(obj);
      }

      return arr;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHourChange", function (value) {
      var state = (0, _cloneDeep["default"])(_this.state);
      var _this$props = _this.props,
          minValue = _this$props.minValue,
          maxValue = _this$props.maxValue;
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;

      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }

      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }

      state.hour = value;

      if (minHour == state.hour) {
        state.minutesData = _this.rangeData(60, minMinute, 60);
      } else if (maxHour == state.hour) {
        state.minutesData = _this.rangeData(60, 0, maxMinute);
      } else if (maxHour == minHour && minHour == state.hour) {
        state.minutesData = _this.rangeData(60, minMinute, maxMinute);
      } else {
        state.minutesData = _this.rangeData(60);
      }

      if (minHour == state.hour && minMinute == state.minute) {
        state.secondsData = _this.rangeData(60, minSecond, 60);
      } else if (maxHour == state.hour && maxMinute == state.minute) {
        state.secondsData = _this.rangeData(60, 0, maxSecond);
      } else if (maxHour == minHour && minHour == state.hour && minMinute == maxMinute && minMinute == state.minute) {
        state.secondsData = _this.rangeData(60, minSecond, maxSecond);
      } else {
        state.secondsData = _this.rangeData(60);
      }

      if (minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + state.minute + ':' + state.second).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + state.minute + ':' + state.second).isAfter('2000-01-01 ' + maxValue)) {
        if (minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + state.minute + ':' + state.second).isBefore('2000-01-01 ' + minValue)) {
          state.hour = (0, _moment["default"])('2000-01-01 ' + minValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + minValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + minValue).format('ss');
        } else {
          state.hour = (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss');
        }

        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange({
            hour: state.hour,
            minute: state.minute,
            second: state.second
          });
        });
      } else {
        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange({
            hour: value,
            minute: state.minute,
            second: state.second
          });
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMinuteChange", function (value) {
      var state = (0, _cloneDeep["default"])(_this.state);
      var _this$props2 = _this.props,
          minValue = _this$props2.minValue,
          maxValue = _this$props2.maxValue;
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;

      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }

      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }

      state.minute = value;

      if (minHour == state.hour && minMinute == state.minute) {
        state.secondsData = _this.rangeData(60, minSecond, 60);
      } else if (maxHour == state.hour && maxMinute == state.minute) {
        state.secondsData = _this.rangeData(60, 0, maxSecond);
      } else if (maxHour == minHour && minHour == state.hour && minMinute == maxMinute && minMinute == state.minute) {
        state.secondsData = _this.rangeData(60, minSecond, maxSecond);
      } else {
        state.secondsData = _this.rangeData(60);
      }

      if (minValue && (0, _moment["default"])('2000-01-01 ' + state.hour + ':' + state.minute + ':' + value).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + state.hour + ':' + state.minute + ':' + value).isAfter('2000-01-01 ' + maxValue)) {
        if (minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + state.minute + ':' + state.second).isBefore('2000-01-01 ' + minValue)) {
          state.hour = (0, _moment["default"])('2000-01-01 ' + minValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + minValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + minValue).format('ss');
        } else {
          state.hour = (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss');
        }

        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange({
            hour: state.hour,
            minute: state.minute,
            second: state.second
          });
        });
      } else {
        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange({
            hour: state.hour,
            minute: value,
            second: state.second
          });
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSecondChange", function (value) {
      var state = (0, _cloneDeep["default"])(_this.state);
      var _this$props3 = _this.props,
          minValue = _this$props3.minValue,
          maxValue = _this$props3.maxValue;

      if (minValue && (0, _moment["default"])('2000-01-01 ' + state.hour + ':' + state.minute + ':' + value).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + state.hour + ':' + state.minute + ':' + value).isAfter('2000-01-01 ' + maxValue)) {
        if (minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + state.minute + ':' + state.second).isBefore('2000-01-01 ' + minValue)) {
          state.hour = (0, _moment["default"])('2000-01-01 ' + minValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + minValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + minValue).format('ss');
        } else {
          state.hour = (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH');
          state.minute = (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm');
          state.second = (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss');
        }

        _this.setState(state, function () {
          _this.props.onChange && _this.props.onChange({
            hour: state.hour,
            minute: state.minute,
            second: state.second
          });
        });
      } else {
        _this.setState({
          second: value
        }, function () {
          _this.props.onChange && _this.props.onChange({
            hour: state.hour,
            minute: state.minute,
            second: value
          });
        });
      }
    });
    _this.state = {
      hour: props.hour,
      minute: props.minute,
      second: props.second,
      hoursData: [],
      minutesData: [],
      secondsData: []
    };
    return _this;
  }

  (0, _createClass2["default"])(TimeList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props4 = this.props,
          minValue = _this$props4.minValue,
          maxValue = _this$props4.maxValue;
      var state = (0, _cloneDeep["default"])(this.state);
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;

      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }

      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }

      state.hoursData = this.rangeData(24, minHour, maxHour);

      if (minHour == state.hour && minHour != maxHour) {
        state.minutesData = this.rangeData(60, minMinute, 60);
      } else if (maxHour == state.hour && maxHour != minHour) {
        state.minutesData = this.rangeData(60, 0, maxMinute);
      } else if (maxHour == minHour && minHour == state.hour) {
        state.minutesData = this.rangeData(60, minMinute, maxMinute);
      } else {
        state.minutesData = this.rangeData(60);
      }

      if (minHour == state.hour && minMinute == state.minute) {
        state.secondsData = this.rangeData(60, minSecond, 60);
      } else if (maxHour == state.hour && maxMinute == state.minute) {
        state.secondsData = this.rangeData(60, 0, maxSecond);
      } else if (maxHour == minHour && minHour == state.hour && minMinute == maxMinute && minMinute == state.minute) {
        state.secondsData = this.rangeData(60, minSecond, maxSecond);
      } else {
        state.secondsData = this.rangeData(60);
      }

      this.setState(state);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.hour !== this.props.hour || nextProps.minute !== this.props.minute || nextProps.second !== this.props.second || nextProps.minValue !== this.props.minValue || nextProps.maxValue !== this.props.maxValue || this.props.isRequired == nextProps.isRequired) {
        // debugger
        var minValue = nextProps.minValue,
            maxValue = nextProps.maxValue;
        var state = (0, _cloneDeep["default"])(this.state);
        var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;

        if (minValue) {
          minHour = minValue.split(':')[0];
          minMinute = minValue.split(':')[1];
          minSecond = minValue.split(':')[2];
        }

        if (maxValue) {
          maxHour = maxValue.split(':')[0];
          maxMinute = maxValue.split(':')[1];
          maxSecond = maxValue.split(':')[2];
        }

        state.hoursData = this.rangeData(24, minHour, maxHour);

        if (minHour == state.hour) {
          state.minutesData = this.rangeData(60, minMinute, 60);
        } else if (maxHour == state.hour) {
          state.minutesData = this.rangeData(60, 0, maxMinute);
        } else if (maxHour == minHour && minHour == state.hour) {
          state.minutesData = this.rangeData(60, minMinute, maxMinute);
        } else {
          state.minutesData = this.rangeData(60);
        }

        if (minHour == state.hour && minMinute == state.minute) {
          state.secondsData = this.rangeData(60, minSecond, 60);
        } else if (maxHour == state.hour && maxMinute == state.minute) {
          state.secondsData = this.rangeData(60, 0, maxSecond);
        } else if (maxHour == minHour && minHour == state.hour && minMinute == maxMinute && minMinute == state.minute) {
          state.secondsData = this.rangeData(60, minSecond, maxSecond);
        } else {
          state.secondsData = this.rangeData(60);
        }

        state.hour = nextProps.hour;
        state.minute = nextProps.minute;
        state.second = nextProps.second;
        state.minValue = nextProps.minValue;
        state.maxValue = nextProps.maxValue;
        state.isRequired = nextProps.isRequired;
        this.setState(state);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          className = _this$props5.className,
          popupVisible = _this$props5.popupVisible,
          dateFormat = _this$props5.dateFormat,
          _this$state = this.state,
          hour = _this$state.hour,
          minute = _this$state.minute,
          second = _this$state.second,
          hoursData = _this$state.hoursData,
          minutesData = _this$state.minutesData,
          secondsData = _this$state.secondsData,
          itemsStyle = {
        width: 100 / dateFormat.split(':').length + '%'
      };
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('calendar', (0, _defineProperty2["default"])({}, className, className))
      }, _react["default"].createElement(_TimeItems["default"], {
        className: "hours",
        style: itemsStyle,
        data: hoursData,
        value: hour,
        popupVisible: popupVisible,
        onChange: this.handleHourChange
      }), dateFormat.split(':').length > 1 ? _react["default"].createElement(_TimeItems["default"], {
        className: "minutes",
        style: itemsStyle,
        data: minutesData,
        value: minute,
        popupVisible: popupVisible,
        onChange: this.handleMinuteChange
      }) : null, dateFormat.split(':').length > 2 ? _react["default"].createElement(_TimeItems["default"], {
        className: "seconds",
        style: itemsStyle,
        data: secondsData,
        value: second,
        popupVisible: popupVisible,
        onChange: this.handleSecondChange
      }) : null);
    }
  }]);
  return TimeList;
}(_react.Component);

TimeList.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  popupVisible: _propTypes["default"].bool,
  hour: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  minute: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  second: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  isRequired: _propTypes["default"].bool,
  maxValue: _propTypes["default"].string,
  minValue: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
var _default = TimeList;
exports["default"] = _default;