"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Td = _interopRequireDefault(require("../_Td"));

var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));

/**
 * @file Tr component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tr =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tr, _Component);

  function Tr(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Tr);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tr)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCollapsed", function () {
      var _this$props = _this.props,
          idProp = _this$props.idProp,
          data = _this$props.data,
          expandRows = _this$props.expandRows;

      if (!expandRows || expandRows.length < 1) {
        return true;
      }

      return _TableCalculation["default"].indexOfNodeInValue(data, expandRows, idProp) === -1;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseEnter", function (e) {
      var _this$props2 = _this.props,
          rowIndex = _this$props2.rowIndex,
          onMouseEnter = _this$props2.onMouseEnter;
      onMouseEnter && onMouseEnter(e, rowIndex);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseLeave", function (e) {
      var _this$props3 = _this.props,
          rowIndex = _this$props3.rowIndex,
          onMouseLeave = _this$props3.onMouseLeave;
      onMouseLeave && onMouseLeave(e, rowIndex);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props4 = _this.props,
          data = _this$props4.data,
          rowIndex = _this$props4.rowIndex,
          disabled = _this$props4.disabled,
          onRowClick = _this$props4.onRowClick;
      !disabled && onRowClick && onRowClick(data, rowIndex, e);
    });
    return _this;
  }

  (0, _createClass2["default"])(Tr, [{
    key: "render",
    value: function render() {
      var _classNames,
          _this2 = this;

      var _this$props5 = this.props,
          className = _this$props5.className,
          columns = _this$props5.columns,
          hoverRowIndex = _this$props5.hoverRowIndex,
          rowIndex = _this$props5.rowIndex,
          data = _this$props5.data,
          parentData = _this$props5.parentData,
          tableData = _this$props5.tableData,
          isChecked = _this$props5.isChecked,
          disabled = _this$props5.disabled,
          baseColIndex = _this$props5.baseColIndex,
          depth = _this$props5.depth,
          index = _this$props5.index,
          path = _this$props5.path,
          respProps = (0, _objectWithoutProperties2["default"])(_this$props5, ["className", "columns", "hoverRowIndex", "rowIndex", "data", "parentData", "tableData", "isChecked", "disabled", "baseColIndex", "depth", "index", "path"]),
          collapsed = this.isCollapsed(),
          columnsWithSpan = _TableCalculation["default"].getColumnsWithSpan(_TableFragment["default"].BODY, columns, data, rowIndex),
          nodePath = path || [{
        index: index,
        node: data
      }];

      return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("tr", {
        className: (0, _classnames["default"])((_classNames = {
          checked: isChecked,
          expanded: !collapsed,
          hover: hoverRowIndex === rowIndex
        }, (0, _defineProperty2["default"])(_classNames, data.rowClassName, data.rowClassName), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: data.rowStyle,
        disabled: disabled,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave,
        onClick: this.handleClick
      }, columnsWithSpan && columnsWithSpan.map(function (_ref, colIndex) {
        var column = _ref.column,
            span = _ref.span;
        return column ? _react["default"].createElement(_Td["default"], (0, _extends2["default"])({}, respProps, {
          key: colIndex,
          className: column.bodyClassName,
          style: column.bodyStyle,
          rowIndex: rowIndex,
          colIndex: baseColIndex + colIndex,
          data: data,
          parentData: parentData,
          tableData: tableData,
          collapsed: collapsed,
          renderer: column.bodyRenderer,
          align: column.bodyAlign || column.align,
          span: span,
          disabled: disabled,
          noWrap: _TableCalculation["default"].handleNoWrap(column.bodyNoWrap, column.noWrap, {
            data: data,
            rowIndex: rowIndex,
            colIndex: baseColIndex + colIndex,
            tableData: tableData
          }),
          depth: depth,
          path: nodePath,
          sortable: column.sortable,
          sortingProp: column.sortingProp
        })) : null;
      })),
      /*rowHasChildren && */
      !collapsed && data && data.children && data.children.length > 0 ? data.children.map(function (item, index) {
        return _react["default"].createElement(Tr, (0, _extends2["default"])({}, _this2.props, {
          key: index,
          index: index,
          data: item,
          parentData: data,
          depth: depth + 1,
          path: nodePath ? [].concat((0, _toConsumableArray2["default"])(nodePath), [{
            index: index,
            node: item
          }]) : [{
            index: index,
            node: item
          }]
        }));
      }) : null);
    }
  }]);
  return Tr;
}(_react.Component);

(0, _defineProperty2["default"])(Tr, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tr, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tr, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Tr, "SortingType", _SortingType["default"]);
Tr.propTypes = {
  className: _propTypes["default"].string,
  hoverRowIndex: _propTypes["default"].number,
  rowIndex: _propTypes["default"].number,

  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),

    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,

    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,

    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,

    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,

    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,

    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,

    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,

    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,

    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),

    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,

    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),

    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),

    /**
     * If true,this column can be sorted.
     */
    sortable: _propTypes["default"].bool,

    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  })).isRequired,
  data: _propTypes["default"].object,
  parentData: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  isChecked: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  expandRows: _propTypes["default"].array,
  baseColIndex: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  index: _propTypes["default"].number,
  path: _propTypes["default"].array,
  idProp: _propTypes["default"].string,

  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),

  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func
};
Tr.defaultProps = {
  rowIndex: 0,
  isChecked: false,
  disabled: false,
  expandRows: [],
  baseColIndex: 0,
  depth: 0,
  idProp: 'id'
};
var _default = Tr;
exports["default"] = _default;