"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Radio = _interopRequireDefault(require("../Radio"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));

var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TreeCalculation = _interopRequireDefault(require("../_vendors/TreeCalculation"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TreeNode =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TreeNode, _Component);

  function TreeNode(_props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TreeNode);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TreeNode)).call.apply(_getPrototypeOf2, [this, _props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCollapsed", function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;
      var data = props.data,
          isNodeCollapsed = props.isNodeCollapsed,
          collapsed = props.collapsed,
          index = props.index,
          depth = props.depth,
          path = props.path;

      if (data && data[_VirtualRoot["default"]]) {
        return false;
      }

      if (isNodeCollapsed) {
        if (typeof isNodeCollapsed === 'function') {
          return isNodeCollapsed(data, index, depth, path);
        } else {
          return !!isNodeCollapsed;
        }
      }

      return collapsed;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleTreeNode", function (e) {
      e && e.stopPropagation();
      var onNodeToggleStart = _this.props.onNodeToggleStart;
      onNodeToggleStart && onNodeToggleStart();

      _this.setState({
        collapsed: !_this.state.collapsed
      }, function () {
        var onNodeToggleEnd = _this.props.onNodeToggleEnd;
        onNodeToggleEnd && onNodeToggleEnd();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCheckboxChange", function (e) {
      var _this$props = _this.props,
          data = _this$props.data,
          path = _this$props.path,
          value = _this$props.value,
          onSelect = _this$props.onSelect,
          onDeselect = _this$props.onDeselect;

      if (!_TreeCalculation["default"].isNodeChecked(data, value, _this.props)) {
        onSelect && onSelect(data, path, e);
      } else {
        onDeselect && onDeselect(data, path, e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRadioChange", function (e) {
      var _this$props2 = _this.props,
          data = _this$props2.data,
          path = _this$props2.path,
          onSelect = _this$props2.onSelect;
      onSelect && onSelect(data, path, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props3 = _this.props,
          data = _this$props3.data,
          path = _this$props3.path,
          disabled = _this$props3.disabled,
          isLoading = _this$props3.isLoading,
          readOnly = _this$props3.readOnly;

      if (disabled || isLoading || readOnly || data.disabled || data.isLoading || data.readOnly) {
        return;
      }

      var _this$props4 = _this.props,
          selectMode = _this$props4.selectMode,
          onClick = _this$props4.onClick;
      onClick && onClick(data, path, e);

      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          _this.handleCheckboxChange(e);

          return;

        case _SelectMode["default"].SINGLE_SELECT:
          _this.handleRadioChange(e);

          return;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderChildren", function () {
      var _this$props5 = _this.props,
          depth = _this$props5.depth,
          path = _this$props5.path,
          data = _this$props5.data,
          collapsed = _this.state.collapsed,
          isVirtual = _VirtualRoot["default"] in data;
      return !collapsed && data.children && data.children.length > 0 ? _react["default"].createElement(_react.Fragment, null, data.children.map(function (item, index) {
        return _react["default"].createElement(TreeNode, (0, _extends2["default"])({}, _this.props, {
          key: index,
          data: item,
          index: index,
          depth: depth + (isVirtual ? 0 : 1),
          path: path ? [].concat((0, _toConsumableArray2["default"])(path), [{
            index: index,
            node: item
          }]) : [{
            index: index,
            node: item
          }]
        }));
      })) : null;
    });
    _this.state = {
      collapsed: _this.isCollapsed(_props)
    };
    return _this;
  }

  (0, _createClass2["default"])(TreeNode, [{
    key: "render",

    /* eslint-disable complexity */
    value: function render() {
      var _classNames;

      var data = this.props.data;

      if (_VirtualRoot["default"] in data) {
        return this.renderChildren();
      }

      var _this$props6 = this.props,
          index = _this$props6.index,
          depth = _this$props6.depth,
          theme = _this$props6.theme,
          selectTheme = _this$props6.selectTheme,
          selectMode = _this$props6.selectMode,
          value = _this$props6.value,
          disabled = _this$props6.disabled,
          isLoading = _this$props6.isLoading,
          readOnly = _this$props6.readOnly,
          allowCollapse = _this$props6.allowCollapse,
          isSelectRecursive = _this$props6.isSelectRecursive,
          indentWidth = _this$props6.indentWidth,
          valueField = _this$props6.valueField,
          displayField = _this$props6.displayField,
          descriptionField = _this$props6.descriptionField,
          collapsedIconCls = _this$props6.collapsedIconCls,
          expandedIconCls = _this$props6.expandedIconCls,
          radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
          radioCheckedIconCls = _this$props6.radioCheckedIconCls,
          checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
          checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
          checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
          renderer = _this$props6.renderer,
          onMouseEnter = _this$props6.onMouseEnter,
          onMouseLeave = _this$props6.onMouseLeave,
          collapsed = this.state.collapsed,
          checked = _TreeCalculation["default"].isNodeChecked(data, value, this.props),
          indeterminate = _TreeCalculation["default"].isNodeCheckedIndeterminate(data, value, this.props),
          isNodeLoading = data.isLoading || isLoading,
          isNodeDisabled = data.disabled || disabled || isNodeLoading,
          loadingIconPosition = data.rightIconCls && !data.iconCls ? 'right' : 'left';

      return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('tree-node', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, data.className, data.className), _classNames)),
        style: _objectSpread({}, data.style, {
          paddingLeft: (depth + 1) * indentWidth
        }),
        title: data.title,
        disabled: isNodeDisabled,
        readOnly: readOnly,
        onClick: this.handleClick,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      }, _react["default"].createElement("div", {
        className: "tree-node-inner"
      }, allowCollapse && data.children && data.children.length > 0 ? _react["default"].createElement(_IconButton["default"], {
        className: "tree-node-collapse-icon",
        iconCls: collapsed ? data.collapsedIconCls || collapsedIconCls : data.expandedIconCls || expandedIconCls,
        onClick: this.toggleTreeNode
      }) : null, selectMode === _SelectMode["default"].SINGLE_SELECT && (radioUncheckedIconCls || radioCheckedIconCls) ? _react["default"].createElement(_Radio["default"], {
        className: "tree-node-select",
        theme: selectTheme,
        checked: checked,
        disabled: isNodeDisabled,
        uncheckedIconCls: data.radioUncheckedIconCls || radioUncheckedIconCls,
        checkedIconCls: data.radioCheckedIconCls || radioCheckedIconCls,
        disableTouchRipple: true
      }) : null, selectMode === _SelectMode["default"].MULTI_SELECT ? _react["default"].createElement(_Checkbox["default"], {
        className: "tree-node-select",
        theme: selectTheme,
        checked: checked,
        indeterminate: isSelectRecursive ? indeterminate : false,
        disabled: isNodeDisabled,
        uncheckedIconCls: data.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
        checkedIconCls: data.checkboxCheckedIconCls || checkboxCheckedIconCls,
        indeterminateIconCls: data.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
        disableTouchRipple: true
      }) : null, isNodeLoading && loadingIconPosition === 'left' ? _react["default"].createElement("div", {
        className: "button-icon button-icon-left"
      }, _react["default"].createElement(_CircularLoading["default"], {
        className: "button-loading-icon",
        size: "small"
      })) : data.iconCls ? _react["default"].createElement("i", {
        className: "button-icon button-icon-left ".concat(data.iconCls),
        "aria-hidden": "true"
      }) : null, data.itemRenderer && typeof data.itemRenderer === 'function' ? data.itemRenderer(data, index) : renderer && typeof renderer === 'function' ? renderer(data, index) : data[descriptionField] ? _react["default"].createElement("div", {
        className: "tree-node-content"
      }, _react["default"].createElement("span", {
        className: "tree-node-content-value"
      }, _Util["default"].getTextByDisplayField(data, displayField, valueField)), _react["default"].createElement("span", {
        className: "tree-node-content-desc"
      }, data[descriptionField])) : _Util["default"].getTextByDisplayField(data, displayField, valueField), isNodeLoading && loadingIconPosition === 'right' ? _react["default"].createElement(_CircularLoading["default"], {
        className: "button-icon button-icon-right button-loading-icon",
        size: "small"
      }) : data.rightIconCls ? _react["default"].createElement("i", {
        className: "button-icon button-icon-right ".concat(data.rightIconCls),
        "aria-hidden": "true"
      }) : null)), this.renderChildren());
    }
  }]);
  return TreeNode;
}(_react.Component);

(0, _defineProperty2["default"])(TreeNode, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TreeNode, "Theme", _Theme["default"]);
TreeNode.propTypes = {
  index: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].object,
  value: _propTypes["default"].any,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  descriptionField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  isNodeToggling: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  indentWidth: _propTypes["default"].number,
  renderer: _propTypes["default"].func,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onNodeToggleStart: _propTypes["default"].func,
  onNodeToggleEnd: _propTypes["default"].func
};
TreeNode.defaultProps = {
  index: 0,
  depth: 0,
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  allowCollapse: true,
  collapsed: false,
  isNodeToggling: false,
  isSelectRecursive: false,
  indentWidth: 20,
  collapsedIconCls: 'fas fa-caret-right',
  expandedIconCls: 'fas fa-caret-down',
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = TreeNode;
exports["default"] = _default;