"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Pop = _interopRequireDefault(require("../_Pop"));

var _Paper = _interopRequireDefault(require("../Paper"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _TriggerPopCalculation = _interopRequireDefault(require("../_vendors/TriggerPopCalculation"));

var _Dom = _interopRequireDefault(require("../_vendors/Dom"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

/**
 * @file TriggerPop component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
// Components
// Statics
// Vendors
var TriggerPop =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TriggerPop, _Component);

  function TriggerPop(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TriggerPop);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TriggerPop)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs))); // closest scrollable element of trigger

    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      return _this.pop && _this.pop.current && _this.pop.current.getEl();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var transitionEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getEl();
      var _this$props = _this.props,
          parentEl = _this$props.parentEl,
          triggerEl = _this$props.triggerEl,
          position = _this$props.position;

      _TriggerPopCalculation["default"].setStyle(parentEl, triggerEl, transitionEl, _this.getScrollEl(), position);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollEl", function () {
      var triggerEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.triggerEl;

      if (_this.props.scrollEl) {
        return _this.props.scrollEl;
      }

      if (_this.scrollEl) {
        return _this.scrollEl;
      }

      var scrollEl = _Dom["default"].getClosestScrollable(triggerEl);

      return _this.scrollEl = scrollEl || document.body;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function () {
      _this.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addWatchScroll", function () {
      var scrollEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getScrollEl();
      var triggerEl = _this.props.triggerEl;

      if (!triggerEl) {
        return;
      }

      scrollEl && _Event["default"].addEvent(scrollEl, 'scroll', _this.handleScroll);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeWatchScroll", function () {
      var scrollEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getScrollEl();
      scrollEl && _Event["default"].removeEvent(scrollEl, 'scroll', _this.handleScroll);
    });
    _this.scrollEl = null;
    _this.pop = (0, _react.createRef)();
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(TriggerPop, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.shouldFollowScroll && !prevProps.visible && this.props.visible) {
        this.addWatchScroll();
      } else if (prevProps.shouldFollowScroll && prevProps.visible && !this.props.visible) {
        this.removeWatchScroll();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          children = _this$props2.children,
          className = _this$props2.className,
          contentClassName = _this$props2.contentClassName,
          theme = _this$props2.theme,
          hasTriangle = _this$props2.hasTriangle,
          triangle = _this$props2.triangle,
          position = _this$props2.position,
          isAnimated = _this$props2.isAnimated,
          isEscClose = _this$props2.isEscClose,
          isBlurClose = _this$props2.isBlurClose,
          shouldFollowScroll = _this$props2.shouldFollowScroll,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["children", "className", "contentClassName", "theme", "hasTriangle", "triangle", "position", "isAnimated", "isEscClose", "isBlurClose", "shouldFollowScroll"]);
      return _react["default"].createElement(_Pop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('trigger-pop', (_classNames = {
          'trigger-pop-has-triangle': hasTriangle
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "trigger-pop-".concat(position), position), (0, _defineProperty2["default"])(_classNames, 'trigger-pop-animated', isAnimated), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        container: _react["default"].createElement(_Paper["default"], null),
        isAnimated: isAnimated,
        resetPosition: this.resetPosition
      }), function (popEl) {
        return _react["default"].createElement(_react.Fragment, null, hasTriangle ? _react["default"].createElement("div", {
          className: "trigger-pop-triangle-wrapper"
        }, triangle) : null, _react["default"].createElement("div", {
          className: (0, _classnames["default"])('trigger-pop-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName))
        }, typeof children === 'function' ? children(popEl) : children));
      });
    }
  }]);
  return TriggerPop;
}(_react.Component);

(0, _defineProperty2["default"])(TriggerPop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(TriggerPop, "Theme", _Theme["default"]);
TriggerPop.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The trigger pop theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,

  /**
   * This is the DOM element that will be used to set the position of the trigger pop.
   */
  triggerEl: _propTypes["default"].object,

  /**
   * If true,the trigger pop is visible.
   */
  visible: _propTypes["default"].bool,

  /**
   * If true,the trigger pop will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,
  showModal: _propTypes["default"].bool,

  /**
   * The trigger pop alignment.The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true,popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,

  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,

  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func
};
TriggerPop.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  parentEl: document.body,
  depth: 2,
  visible: false,
  hasTriangle: true,
  triangle: _react["default"].createElement("div", {
    className: "trigger-pop-triangle"
  }),
  showModal: false,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  isBlurClose: true,
  isEscClose: true,
  shouldFollowScroll: false,
  resetPositionWait: 250
};
var _default = TriggerPop;
exports["default"] = _default;