"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));

/**
 * @file YearPicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var YearPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(YearPicker, _Component);

  function YearPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, YearPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(YearPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (s_year) {
      _this.setState({
        currentYear: s_year,
        selectYear: s_year
      }, function () {
        _this.props.onChange && _this.props.onChange(s_year);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var selectYear = _this.state.selectYear;
      selectYear = +selectYear - 10;

      _this.setState({
        YearArr: _this.getYearArr(selectYear),
        selectYear: selectYear
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var selectYear = _this.state.selectYear;
      selectYear = +selectYear + 10;

      _this.setState({
        YearArr: _this.getYearArr(selectYear),
        selectYear: selectYear
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getYearArr", function (num) {
      var yearString = num.toString();
      yearString = yearString.substr(0, yearString.length - 1);
      var YearArr = [];

      for (var i = 0; i < 10; i++) {
        YearArr.push(yearString + i);
      }

      return YearArr;
    });
    _this.defaultTable = {
      row_number: 4,
      col_number: 3
    };
    _this.state = {
      YearArr: _this.getYearArr(props.year),
      selectYear: props.year,
      currentYear: (0, _moment["default"])(props.value).format('YYYY'),
      selectMonth: props.month,
      selectDay: props.day,
      maxValue: props.maxValue,
      minValue: props.minValue
    };
    return _this;
  }

  (0, _createClass2["default"])(YearPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          value = _this$props.value,
          year = _this$props.year;

      if (value && year) {
        this.setState({
          YearArr: this.getYearArr(year),
          selectYear: year,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM')
        });
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value || nextProps.year !== this.props.year) {
        var value = nextProps.value;
        this.setState({
          selectYear: nextProps.year,
          YearArr: this.getYearArr(nextProps.year),
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM')
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          previousYearIconCls = _this$props2.previousYearIconCls,
          nextYearIconCls = _this$props2.nextYearIconCls;
      var _this$state = this.state,
          YearArr = _this$state.YearArr,
          selectYear = _this$state.selectYear;
      var previousYear = this.previousYear,
          nextYear = this.nextYear,
          selectDate = this.selectDate;
      var previous_years = [],
          current_years = [],
          next_years = [],
          total_years = [],
          ul_list = [];
      previous_years.push(_react["default"].createElement("li", {
        className: "item-gray",
        key: Number(YearArr[0]) - 1
      }, _react["default"].createElement("a", {
        href: "javascript:;"
      }, Number(YearArr[0]) - 1)));

      var _loop = function _loop(i) {
        var liClassName = "".concat(Number(selectYear) == Number(YearArr[i]) ? 'active' : '', "\n                                           ").concat(maxValue && (0, _moment["default"])(maxValue).format('YYYY') < Number(YearArr[i]) || minValue && (0, _moment["default"])(minValue).format('YYYY') > Number(YearArr[i]) ? 'item-gray' : 'current-years');

        var Years = _react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            liClassName.indexOf('item-gray') === -1 && selectDate(YearArr[i]);
          }
        }, _react["default"].createElement("a", {
          href: "javascript:;"
        }, YearArr[i], liClassName.indexOf('item-gray') === -1 ? _react["default"].createElement(_TouchRipple["default"], null) : null));

        current_years.push(Years);
      };

      for (var i = 0; i < YearArr.length; i++) {
        _loop(i);
      }

      next_years.push(_react["default"].createElement("li", {
        className: "item-gray",
        key: Number(YearArr[YearArr.length - 1]) + 1
      }, _react["default"].createElement("a", {
        href: "javascript:;"
      }, Number(YearArr[YearArr.length - 1]) + 1)));
      total_years = previous_years.concat(current_years, next_years);

      if (total_years.length > 0) {
        for (var _i = 0; _i < this.defaultTable.row_number; _i++) {
          var li_list = [],
              start_index = _i * this.defaultTable.col_number,
              end_index = (_i + 1) * this.defaultTable.col_number;

          for (var j = start_index; j < end_index; j++) {
            li_list.push(total_years[j]);
          }

          ul_list.push(li_list);
        }
      }

      selectYear = selectYear.toString();
      var yearRangeEnd = selectYear.substr(0, selectYear.length - 1) + '9';
      var yearRangeStart = selectYear.substr(0, selectYear.length - 1) + '1';
      var leftNextYear = maxValue && (0, _moment["default"])(maxValue).format('YYYY') <= +yearRangeEnd ? true : false;
      var rightPreYear = minValue && (0, _moment["default"])(minValue).format('YYYY') >= +yearRangeStart ? true : false;
      return _react["default"].createElement("div", {
        className: 'calendar'
      }, _react["default"].createElement("div", {
        className: "calendar-header"
      }, rightPreYear ? null : _react["default"].createElement("i", {
        className: "previous-year ".concat(previousYearIconCls),
        onClick: previousYear
      }, _react["default"].createElement(_TouchRipple["default"], null)), _react["default"].createElement("span", null, YearArr[0], "-", YearArr[YearArr.length - 1]), leftNextYear ? null : _react["default"].createElement("i", {
        className: "next-year ".concat(nextYearIconCls),
        onClick: nextYear
      }, _react["default"].createElement(_TouchRipple["default"], null))), _react["default"].createElement("div", {
        className: "calendar-body calendar-year-body"
      }, _react["default"].createElement("div", {
        className: "c-body-content"
      }, ul_list && ul_list.map(function (item, key) {
        return _react["default"].createElement("ul", {
          key: 'ul' + key,
          className: "content-row year"
        }, item);
      }))));
    }
  }]);
  return YearPicker;
}(_react.Component);

YearPicker.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  value: _propTypes["default"].any,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  onChange: _propTypes["default"].func
};
var _default = YearPicker;
exports["default"] = _default;