"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
 * @file CharSize vendor
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var charCount = 100,
    charSize = {};

function calculateCharWidth(_char, testEl) {
  if (!_char || !testEl) {
    return 0;
  }

  if (_char in charSize) {
    return charSize[_char];
  }

  testEl.innerHTML = _char.repeat(charCount);
  return charSize[_char] = testEl.getBoundingClientRect().width / charCount;
}

function calculateStringWidth(string, testEl) {
  if (!string || !testEl) {
    return 0;
  }

  var width = 0;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = string[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _char2 = _step.value;
      width += calculateCharWidth(_char2, testEl);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return width;
}

var _default = {
  calculateCharWidth: calculateCharWidth,
  calculateStringWidth: calculateStringWidth
};
exports["default"] = _default;