"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Dom = _interopRequireDefault(require("./Dom"));

/**
 * @file DropdownCalculation vendor
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
function isAbove(dropdownEl, triggerEl, popupEl) {
  if (!dropdownEl || !triggerEl || !popupEl) {
    return false;
  }

  var _Dom$getOffset = _Dom["default"].getOffset(dropdownEl),
      top = _Dom$getOffset.top,
      scrollTop = _Dom["default"].getScrollTop(),
      triggerHeight = triggerEl.clientHeight,
      popupHeight = popupEl.clientHeight;

  if (top + triggerHeight + popupHeight - scrollTop > window.innerHeight // bottom overflow
  && top - popupHeight - scrollTop >= 0 // no top overflow
  ) {
      return true;
    }

  return false;
}

var _default = {
  isAbove: isAbove
};
exports["default"] = _default;