"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _Direction = _interopRequireDefault(require("../_statics/Direction"));

require("./ScrollBar.scss");

/**
 * @file ScrollBar vendor
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var tempSize = {
  vertical: null,
  horizontal: null
};

function getSize() {
  var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _Direction["default"].VERTICAL;

  if (document == undefined || window == undefined) {
    return;
  }

  var isVertical = direction === _Direction["default"].VERTICAL;

  if (isVertical && tempSize.vertical !== null) {
    return tempSize.vertical;
  } else if (!isVertical && tempSize.horizontal != null) {
    return tempSize.horizontal;
  }

  var scrollDiv = document.createElement('div');
  scrollDiv.className = (0, _classnames["default"])('scroll-bar-for-measure', direction);
  document.body.appendChild(scrollDiv);
  var size = 0;

  if (isVertical) {
    size = scrollDiv.offsetWidth - scrollDiv.clientWidth;
    tempSize.vertical = size;
  } else {
    size = scrollDiv.offsetHeight - scrollDiv.clientHeight;
    tempSize.horizontal = size;
  }

  document.body.removeChild(scrollDiv);
  return size;
}

var _default = {
  getSize: getSize
};
exports["default"] = _default;