"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));

var _Util = _interopRequireDefault(require("./Util"));

var _Calculation = _interopRequireDefault(require("./Calculation"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function calDepth(data, path) {
  var list = data,
      depth = 0;

  if (!data || !path) {
    return depth = 0;
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = path[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;

      if (item.index in list) {
        list = list[item.index].children;
        depth++;
      } else {
        return depth;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  if (list && list.length > 0) {
    return depth + 1;
  }

  return depth;
}

function calPath(value, data, props) {
  if (!value || !data) {
    return;
  }

  return traverseDataCalPath(data, value, props, null);
}

function traverseDataCalPath(node, value, props, parent) {
  var index = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;

  if (!node || node.length < 1 || !value) {
    return;
  }

  var valueField = props.valueField,
      displayField = props.displayField;

  if (_Util["default"].getValueByValueField(node, valueField, displayField) === _Util["default"].getValueByValueField(value, valueField, displayField)) {
    if (!parent) {
      // root
      return null;
    } else {
      return [{
        node: node,
        index: index
      }];
    }
  } // find in children


  if (node.children && node.children.length > 0) {
    for (var i = 0, len = node.children.length; i < len; i++) {
      // traverse child node
      var path = traverseDataCalPath(node.children[i], value, props, node, i); // if finded in child node

      if (path) {
        if (!parent) {
          // root
          return path;
        }

        path.unshift({
          node: node,
          index: index
        });
        return path;
      }
    }
  }

  return;
}

function findNodeById(node, id, callback) {
  var index = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var parent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

  if (!node) {
    return;
  }

  if ('' + node.id === '' + id) {
    callback && callback(node, index, parent);
    return true;
  }

  if (node.children && node.children.length > 0) {
    for (var i = 0, len = node.children.length; i < len; i++) {
      if (findNodeById(node.children[i], id, callback, i, node)) {
        return;
      }
    }
  }
}

function addRecursiveValue(node, value, props) {
  if (!node || !value) {
    return;
  }

  if (!_Calculation["default"].isItemChecked(node, value, props)) {
    value.push(node);
  }

  if (!node.children || node.children.length < 1) {
    return;
  }

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = node.children[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var item = _step2.value;
      addRecursiveValue(item, value, props);
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
        _iterator2["return"]();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }
}
/**
 * traverse tree data to update value when multi recursive select
 * @param value
 * @returns {Array}
 */


function updateValue(value, props) {
  var _ref;

  var data = props.data,
      valueField = props.valueField,
      displayField = props.displayField;
  var result = [];

  _Util["default"].postOrderTraverse((0, _isArray["default"])(data) ? (_ref = {}, (0, _defineProperty2["default"])(_ref, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref, "children", data), _ref) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      if (!node.children || node.children.length < 1) {
        if (value.findIndex(function (item) {
          return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(node, valueField, displayField);
        }) > -1) {
          result.push(node);
        }
      } else {
        if (node.children.every(function (child) {
          return result.findIndex(function (item) {
            return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(child, valueField, displayField);
          }) > -1;
        })) {
          result.push(node);
        }
      }
    }
  });

  return result;
}

function getTotalCount(data) {
  var _ref2;

  if (!data) {
    return 0;
  }

  var result = 0;

  _Util["default"].preOrderTraverse((0, _isArray["default"])(data) ? (_ref2 = {}, (0, _defineProperty2["default"])(_ref2, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref2, "children", data), _ref2) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      result++;
    }
  });

  return result;
}

function isNodeMatched(node, filter, props) {
  if (node[_VirtualRoot["default"]]) {
    return true;
  }

  var value = _Util["default"].getTextByDisplayField(node, props && props.displayField || undefined, props && props.valueField || undefined);

  return value.toString().toUpperCase().includes(filter.toUpperCase());
}

function filterNode(node, filter, props) {
  if (!node || !filter) {
    return node;
  }

  var result = _objectSpread({}, node);

  var hasChildMatched = false;

  if (node.children && node.children.length > 0) {
    result.children = [];
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = node.children[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var child = _step3.value;
        var filteredChild = filterNode(child, filter, props);

        if (filteredChild) {
          result.children.push(filteredChild);
        }
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
          _iterator3["return"]();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }

    if (result.children && result.children.length > 0) {
      hasChildMatched = true;
    }
  }

  return hasChildMatched || isNodeMatched(node, filter, props) ? result : null;
}

function filterData(data, filter, props) {
  var _ref3;

  if (!filter || !data || data.length < 1) {
    return data;
  }

  var isArrayData = (0, _isArray["default"])(data),
      result = filterNode(isArrayData ? (_ref3 = {}, (0, _defineProperty2["default"])(_ref3, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref3, "children", data), _ref3) : data, filter, props);
  return isArrayData ? result.children : result;
}

function isCheckedAll(data, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!data || !value || value.length < 1) {
    return false;
  }

  return isNodeChecked({
    children: (0, _isArray["default"])(data) ? data : [data]
  }, value, props);
}

function isCheckedIndeterminate(data, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!data || !value || value.length < 1) {
    return false;
  }

  return isNodeCheckedIndeterminate({
    children: (0, _isArray["default"])(data) ? data : [data]
  }, value, props);
}

function isNodeChecked(node, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!props.isSelectRecursive) {
    return _Calculation["default"].isItemChecked(node, value, props);
  }

  var result = true;

  _Util["default"].preOrderTraverse(node, function (currentNode) {
    // leaf node & not checked
    if (currentNode && (!currentNode.children || currentNode.children.length < 1) && !_Calculation["default"].isItemChecked(currentNode, value, props)) {
      result = false;
      return false;
    }
  });

  return result;
}

function isNodeCheckedIndeterminate(node, value, props) {
  if (!props.isSelectRecursive) {
    return _Calculation["default"].isItemIndeterminate(node, value, props);
  }

  var total = 0,
      count = 0;

  _Util["default"].preOrderTraverse(node, function (currentNode) {
    // leaf node & not checked
    if (currentNode && (!currentNode.children || currentNode.children.length < 1)) {
      total++;

      if (_Calculation["default"].isItemChecked(currentNode, value, props)) {
        count++;
      }
    }
  });

  return count > 0 && count < total;
}

function removeAllNode(data, value) {
  var _ref4;

  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!data || !value) {
    return value;
  }

  var valueField = props.valueField,
      displayField = props.displayField;

  _Util["default"].preOrderTraverse((0, _isArray["default"])(data) ? (_ref4 = {}, (0, _defineProperty2["default"])(_ref4, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref4, "children", data), _ref4) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      var index = value.findIndex(function (item) {
        return _Util["default"].isValueEqual(node, item, valueField, displayField);
      });

      if (index !== -1) {
        value.splice(index, 1);
      }
    }
  });

  return value;
}

function removeRecursiveValue(node, value, props) {
  if (!node || !value) {
    return;
  }

  var index = _Calculation["default"].getMultiSelectItemIndex(node, value, props);

  if (index > -1) {
    value.splice(index, 1);
  }

  if (!node.children || node.children.length < 1) {
    return;
  }

  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = node.children[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var item = _step4.value;
      removeRecursiveValue(item, value, props);
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
        _iterator4["return"]();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }
}

var _default = {
  calDepth: calDepth,
  calPath: calPath,
  findNodeById: findNodeById,
  addRecursiveValue: addRecursiveValue,
  updateValue: updateValue,
  getTotalCount: getTotalCount,
  filterData: filterData,
  isCheckedAll: isCheckedAll,
  isCheckedIndeterminate: isCheckedIndeterminate,
  isNodeChecked: isNodeChecked,
  isNodeCheckedIndeterminate: isNodeCheckedIndeterminate,
  removeAllNode: removeAllNode,
  removeRecursiveValue: removeRecursiveValue
};
exports["default"] = _default;